//---------------------------------------------------------------------------------------------
//	COMPLEX MATRIX DATATYPE
//---------------------------------------------------------------------------------------------
	
	//---------------------------------------------------------------------------------------------
	//	BINOMIAL COEFFICIENT ROUTINE FROM WIKIPEDIA :-)                         
	//---------------------------------------------------------------------------------------------
	
	unsigned long long binomial(unsigned n, unsigned k) {
		
		if (k > n) return 0;

		if (k > n/2) k = n-k;
		
		long double accum = 1;
		unsigned i;
		for (i = 1; i <= k; i++) accum = accum * (n-k+i) / i;

		return accum + 0.5;
	}


	int epsilonT(int i, int j, int k)
	{
		
		return (i-j)*(j-k)*(k-i)/2;
		
	}

	//---------------------------------------------------------------------------------------------
	//	MATRIX DATATYPE NECESSARY ROUTINES SUCH AS MULTIPLICATION AND INVERSION
	//---------------------------------------------------------------------------------------------

	//---------------------------------------------------------------------------------------------
	//	MATRIX MULTIPLICATION
	//---------------------------------------------------------------------------------------------

	#if (SUN==2)

		void GenMatMult(double* c, const double* a, const double* b)
		{

			*(c+0)	= *(a+0) * *(b+0) - *(a+1) * *(b+1) + *(a+2) * *(b+4) - *(a+3) * *(b+5);
			*(c+1)	= *(a+1) * *(b+0) + *(a+0) * *(b+1) + *(a+3) * *(b+4) + *(a+2) * *(b+5);

			*(c+2)	= *(a+0) * *(b+2) - *(a+1) * *(b+3) + *(a+2) * *(b+6) - *(a+3) * *(b+7);
			*(c+3)	= *(a+1) * *(b+2) + *(a+0) * *(b+3) + *(a+3) * *(b+6) + *(a+2) * *(b+7);

			*(c+4)	= *(a+4) * *(b+0) - *(a+5) * *(b+1) + *(a+6) * *(b+4) - *(a+7) * *(b+5);
			*(c+5)	= *(a+5) * *(b+0) + *(a+4) * *(b+1) + *(a+7) * *(b+4) + *(a+6) * *(b+5);

			*(c+6)	= *(a+4) * *(b+2) - *(a+5) * *(b+3) + *(a+6) * *(b+6) - *(a+7) * *(b+7);
			*(c+7)	= *(a+5) * *(b+2) + *(a+4) * *(b+3) + *(a+7) * *(b+6) + *(a+6) * *(b+7);
			
		}

	#endif



	#if (SUN==3)

		void GenMatMult(double* c, const double* a, const double* b)
		{
		*c      = *a      * *b      - *(a+1)  * *(b+1)    +
			*(a+2)  * *(b+6)  - *(a+3)  * *(b+7)    +
			*(a+4)  * *(b+12) - *(a+5)  * *(b+13);
		*(c+1)  = *a      * *(b+1)  + *(a+1)  * *b        +
			*(a+2)  * *(b+7)  + *(a+3)  * *(b+6)    +
			*(a+4)  * *(b+13) + *(a+5)  * *(b+12);

		*(c+2)  = *a      * *(b+2)  - *(a+1)  * *(b+3)    +
			*(a+2)  * *(b+8)  - *(a+3)  * *(b+9)    +
			*(a+4)  * *(b+14) - *(a+5)  * *(b+15);
		*(c+3)  = *a      * *(b+3)  + *(a+1)  * *(b+2)    +
			*(a+2)  * *(b+9)  + *(a+3)  * *(b+8)    +
			*(a+4)  * *(b+15) + *(a+5)  * *(b+14);

		*(c+4)  = *a      * *(b+4)  - *(a+1)  * *(b+5)    +
			*(a+2)  * *(b+10) - *(a+3)  * *(b+11)   +
			*(a+4)  * *(b+16) - *(a+5)  * *(b+17);
		*(c+5)  = *a      * *(b+5)  + *(a+1)  * *(b+4)    +
			*(a+2)  * *(b+11) + *(a+3)  * *(b+10)   +
			*(a+4)  * *(b+17) + *(a+5)  * *(b+16);

		*(c+6)  = *(a+6)  * *b      - *(a+7)  * *(b+1)    +
			*(a+8)  * *(b+6)  - *(a+9)  * *(b+7)    +
			*(a+10) * *(b+12) - *(a+11) * *(b+13);
		*(c+7)  = *(a+6)  * *(b+1)  + *(a+7)  * *b        +
			*(a+8)  * *(b+7)  + *(a+9)  * *(b+6)    +
			*(a+10) * *(b+13) + *(a+11) * *(b+12);

		*(c+8)  = *(a+6)  * *(b+2)  - *(a+7)  * *(b+3)    +
			*(a+8)  * *(b+8)  - *(a+9)  * *(b+9)    +
			*(a+10) * *(b+14) - *(a+11) * *(b+15);
		*(c+9)  = *(a+6)  * *(b+3)  + *(a+7)  * *(b+2)    +
			*(a+8)  * *(b+9)  + *(a+9)  * *(b+8)    +
			*(a+10) * *(b+15) + *(a+11) * *(b+14);

		*(c+10) = *(a+6)  * *(b+4)  - *(a+7)  * *(b+5)    +
			*(a+8)  * *(b+10) - *(a+9)  * *(b+11)   +
			*(a+10) * *(b+16) - *(a+11) * *(b+17);
		*(c+11) = *(a+6)  * *(b+5)  + *(a+7)  * *(b+4)    +
			*(a+8)  * *(b+11) + *(a+9)  * *(b+10)   +
			*(a+10) * *(b+17) + *(a+11) * *(b+16);

		*(c+12) = *(a+12) * *b      - *(a+13) * *(b+1)    +
			*(a+14) * *(b+6)  - *(a+15) * *(b+7)    +
			*(a+16) * *(b+12) - *(a+17) * *(b+13);
		*(c+13) = *(a+12) * *(b+1)  + *(a+13) * *b        +
			*(a+14) * *(b+7)  + *(a+15) * *(b+6)    +
			*(a+16) * *(b+13) + *(a+17) * *(b+12);

		*(c+14) = *(a+12) * *(b+2)  - *(a+13) * *(b+3)    +
			*(a+14) * *(b+8)  - *(a+15) * *(b+9)    +
			*(a+16) * *(b+14) - *(a+17) * *(b+15);
		*(c+15) = *(a+12) * *(b+3)  + *(a+13) * *(b+2)    +
			*(a+14) * *(b+9)  + *(a+15) * *(b+8)    +
			*(a+16) * *(b+15) + *(a+17) * *(b+14);

		*(c+16) = *(a+12) * *(b+4)  - *(a+13) * *(b+5)    +
			*(a+14) * *(b+10) - *(a+15) * *(b+11)   +
			*(a+16) * *(b+16) - *(a+17) * *(b+17);
		*(c+17) = *(a+12) * *(b+5)  + *(a+13) * *(b+4)    +
			*(a+14) * *(b+11) + *(a+15) * *(b+10)   +
			*(a+16) * *(b+17) + *(a+17) * *(b+16);
		}


	#endif

	#if (SUN==4)

		void GenMatMult(double* c, const double* a, const double* b)
		{

			*(c+0)	= *(a+0) * *(b+0) - *(a+1) * *(b+1) + *(a+4) * *(b+16) - *(a+5) * *(b+17) + *(a+6) * *(b+24) - *(a+7) * *(b+25) + *(a+2) * *(b+8) - *(a+3) * *(b+9);
			*(c+1)	= *(a+1) * *(b+0) + *(a+0) * *(b+1) + *(a+5) * *(b+16) + *(a+4) * *(b+17) + *(a+7) * *(b+24) + *(a+6) * *(b+25) + *(a+3) * *(b+8) + *(a+2) * *(b+9);

			*(c+2)	= *(a+2) * *(b+10) - *(a+3) * *(b+11) + *(a+4) * *(b+18) - *(a+5) * *(b+19) + *(a+0) * *(b+2) + *(a+6) * *(b+26) - *(a+7) * *(b+27) - *(a+1) * *(b+3);
			*(c+3)	= *(a+3) * *(b+10) + *(a+2) * *(b+11) + *(a+5) * *(b+18) + *(a+4) * *(b+19) + *(a+1) * *(b+2) + *(a+7) * *(b+26) + *(a+6) * *(b+27) + *(a+0) * *(b+3);

			*(c+4)	= *(a+2) * *(b+12) - *(a+3) * *(b+13) + *(a+4) * *(b+20) - *(a+5) * *(b+21) + *(a+6) * *(b+28) - *(a+7) * *(b+29) + *(a+0) * *(b+4) - *(a+1) * *(b+5);
			*(c+5)	= *(a+3) * *(b+12) + *(a+2) * *(b+13) + *(a+5) * *(b+20) + *(a+4) * *(b+21) + *(a+7) * *(b+28) + *(a+6) * *(b+29) + *(a+1) * *(b+4) + *(a+0) * *(b+5);

			*(c+6)	= *(a+2) * *(b+14) - *(a+3) * *(b+15) + *(a+4) * *(b+22) - *(a+5) * *(b+23) + *(a+6) * *(b+30) - *(a+7) * *(b+31) + *(a+0) * *(b+6) - *(a+1) * *(b+7);
			*(c+7)	= *(a+3) * *(b+14) + *(a+2) * *(b+15) + *(a+5) * *(b+22) + *(a+4) * *(b+23) + *(a+7) * *(b+30) + *(a+6) * *(b+31) + *(a+1) * *(b+6) + *(a+0) * *(b+7);

			*(c+8)	= *(a+8) * *(b+0) - *(a+9) * *(b+1) + *(a+12) * *(b+16) - *(a+13) * *(b+17) + *(a+14) * *(b+24) - *(a+15) * *(b+25) + *(a+10) * *(b+8) - *(a+11) * *(b+9);
			*(c+9)	= *(a+9) * *(b+0) + *(a+8) * *(b+1) + *(a+13) * *(b+16) + *(a+12) * *(b+17) + *(a+15) * *(b+24) + *(a+14) * *(b+25) + *(a+11) * *(b+8) + *(a+10) * *(b+9);

			*(c+10)	= *(a+10) * *(b+10) - *(a+11) * *(b+11) + *(a+12) * *(b+18) - *(a+13) * *(b+19) + *(a+8) * *(b+2) + *(a+14) * *(b+26) - *(a+15) * *(b+27) - *(a+9) * *(b+3);
			*(c+11)	= *(a+11) * *(b+10) + *(a+10) * *(b+11) + *(a+13) * *(b+18) + *(a+12) * *(b+19) + *(a+9) * *(b+2) + *(a+15) * *(b+26) + *(a+14) * *(b+27) + *(a+8) * *(b+3);

			*(c+12)	= *(a+10) * *(b+12) - *(a+11) * *(b+13) + *(a+12) * *(b+20) - *(a+13) * *(b+21) + *(a+14) * *(b+28) - *(a+15) * *(b+29) + *(a+8) * *(b+4) - *(a+9) * *(b+5);
			*(c+13)	= *(a+11) * *(b+12) + *(a+10) * *(b+13) + *(a+13) * *(b+20) + *(a+12) * *(b+21) + *(a+15) * *(b+28) + *(a+14) * *(b+29) + *(a+9) * *(b+4) + *(a+8) * *(b+5);

			*(c+14)	= *(a+10) * *(b+14) - *(a+11) * *(b+15) + *(a+12) * *(b+22) - *(a+13) * *(b+23) + *(a+14) * *(b+30) - *(a+15) * *(b+31) + *(a+8) * *(b+6) - *(a+9) * *(b+7);
			*(c+15)	= *(a+11) * *(b+14) + *(a+10) * *(b+15) + *(a+13) * *(b+22) + *(a+12) * *(b+23) + *(a+15) * *(b+30) + *(a+14) * *(b+31) + *(a+9) * *(b+6) + *(a+8) * *(b+7);

			*(c+16)	= *(a+16) * *(b+0) - *(a+17) * *(b+1) + *(a+20) * *(b+16) - *(a+21) * *(b+17) + *(a+22) * *(b+24) - *(a+23) * *(b+25) + *(a+18) * *(b+8) - *(a+19) * *(b+9);
			*(c+17)	= *(a+17) * *(b+0) + *(a+16) * *(b+1) + *(a+21) * *(b+16) + *(a+20) * *(b+17) + *(a+23) * *(b+24) + *(a+22) * *(b+25) + *(a+19) * *(b+8) + *(a+18) * *(b+9);

			*(c+18)	= *(a+18) * *(b+10) - *(a+19) * *(b+11) + *(a+20) * *(b+18) - *(a+21) * *(b+19) + *(a+16) * *(b+2) + *(a+22) * *(b+26) - *(a+23) * *(b+27) - *(a+17) * *(b+3);
			*(c+19)	= *(a+19) * *(b+10) + *(a+18) * *(b+11) + *(a+21) * *(b+18) + *(a+20) * *(b+19) + *(a+17) * *(b+2) + *(a+23) * *(b+26) + *(a+22) * *(b+27) + *(a+16) * *(b+3);

			*(c+20)	= *(a+18) * *(b+12) - *(a+19) * *(b+13) + *(a+20) * *(b+20) - *(a+21) * *(b+21) + *(a+22) * *(b+28) - *(a+23) * *(b+29) + *(a+16) * *(b+4) - *(a+17) * *(b+5);
			*(c+21)	= *(a+19) * *(b+12) + *(a+18) * *(b+13) + *(a+21) * *(b+20) + *(a+20) * *(b+21) + *(a+23) * *(b+28) + *(a+22) * *(b+29) + *(a+17) * *(b+4) + *(a+16) * *(b+5);

			*(c+22)	= *(a+18) * *(b+14) - *(a+19) * *(b+15) + *(a+20) * *(b+22) - *(a+21) * *(b+23) + *(a+22) * *(b+30) - *(a+23) * *(b+31) + *(a+16) * *(b+6) - *(a+17) * *(b+7);
			*(c+23)	= *(a+19) * *(b+14) + *(a+18) * *(b+15) + *(a+21) * *(b+22) + *(a+20) * *(b+23) + *(a+23) * *(b+30) + *(a+22) * *(b+31) + *(a+17) * *(b+6) + *(a+16) * *(b+7);

			*(c+24)	= *(a+24) * *(b+0) - *(a+25) * *(b+1) + *(a+28) * *(b+16) - *(a+29) * *(b+17) + *(a+30) * *(b+24) - *(a+31) * *(b+25) + *(a+26) * *(b+8) - *(a+27) * *(b+9);
			*(c+25)	= *(a+25) * *(b+0) + *(a+24) * *(b+1) + *(a+29) * *(b+16) + *(a+28) * *(b+17) + *(a+31) * *(b+24) + *(a+30) * *(b+25) + *(a+27) * *(b+8) + *(a+26) * *(b+9);

			*(c+26)	= *(a+26) * *(b+10) - *(a+27) * *(b+11) + *(a+28) * *(b+18) - *(a+29) * *(b+19) + *(a+24) * *(b+2) + *(a+30) * *(b+26) - *(a+31) * *(b+27) - *(a+25) * *(b+3);
			*(c+27)	= *(a+27) * *(b+10) + *(a+26) * *(b+11) + *(a+29) * *(b+18) + *(a+28) * *(b+19) + *(a+25) * *(b+2) + *(a+31) * *(b+26) + *(a+30) * *(b+27) + *(a+24) * *(b+3);

			*(c+28)	= *(a+26) * *(b+12) - *(a+27) * *(b+13) + *(a+28) * *(b+20) - *(a+29) * *(b+21) + *(a+30) * *(b+28) - *(a+31) * *(b+29) + *(a+24) * *(b+4) - *(a+25) * *(b+5);
			*(c+29)	= *(a+27) * *(b+12) + *(a+26) * *(b+13) + *(a+29) * *(b+20) + *(a+28) * *(b+21) + *(a+31) * *(b+28) + *(a+30) * *(b+29) + *(a+25) * *(b+4) + *(a+24) * *(b+5);

			*(c+30)	= *(a+26) * *(b+14) - *(a+27) * *(b+15) + *(a+28) * *(b+22) - *(a+29) * *(b+23) + *(a+30) * *(b+30) - *(a+31) * *(b+31) + *(a+24) * *(b+6) - *(a+25) * *(b+7);
			*(c+31)	= *(a+27) * *(b+14) + *(a+26) * *(b+15) + *(a+29) * *(b+22) + *(a+28) * *(b+23) + *(a+31) * *(b+30) + *(a+30) * *(b+31) + *(a+25) * *(b+6) + *(a+24) * *(b+7);

		}

	#endif

	#if (SUN==5)

		void GenMatMult(double* c, const double* a, const double* b)
		{
			
			*(c+0) = *(a+0) * *(b+0) - *(a+1) * *(b+1) + *(a+2) * *(b+10) - *(a+3) * *(b+11) + *(a+4) * *(b+20) - *(a+5) * *(b+21) + *(a+6) * *(b+30) - *(a+7) * *(b+31) + *(a+8) * *(b+40) - *(a+9) * *(b+41);
			*(c+1) = *(a+1) * *(b+0) + *(a+0) * *(b+1) + *(a+3) * *(b+10) + *(a+2) * *(b+11) + *(a+5) * *(b+20) + *(a+4) * *(b+21) + *(a+7) * *(b+30) + *(a+6) * *(b+31) + *(a+9) * *(b+40) + *(a+8) * *(b+41);

			*(c+2) = *(a+2) * *(b+12) - *(a+3) * *(b+13) + *(a+0) * *(b+2) + *(a+4) * *(b+22) - *(a+5) * *(b+23) - *(a+1) * *(b+3) + *(a+6) * *(b+32) - *(a+7) * *(b+33) + *(a+8) * *(b+42) - *(a+9) * *(b+43);
			*(c+3) = *(a+3) * *(b+12) + *(a+2) * *(b+13) + *(a+1) * *(b+2) + *(a+5) * *(b+22) + *(a+4) * *(b+23) + *(a+0) * *(b+3) + *(a+7) * *(b+32) + *(a+6) * *(b+33) + *(a+9) * *(b+42) + *(a+8) * *(b+43);

			*(c+4) = *(a+2) * *(b+14) - *(a+3) * *(b+15) + *(a+4) * *(b+24) - *(a+5) * *(b+25) + *(a+6) * *(b+34) - *(a+7) * *(b+35) + *(a+0) * *(b+4) + *(a+8) * *(b+44) - *(a+9) * *(b+45) - *(a+1) * *(b+5);
			*(c+5) = *(a+3) * *(b+14) + *(a+2) * *(b+15) + *(a+5) * *(b+24) + *(a+4) * *(b+25) + *(a+7) * *(b+34) + *(a+6) * *(b+35) + *(a+1) * *(b+4) + *(a+9) * *(b+44) + *(a+8) * *(b+45) + *(a+0) * *(b+5);

			*(c+6) = *(a+2) * *(b+16) - *(a+3) * *(b+17) + *(a+4) * *(b+26) - *(a+5) * *(b+27) + *(a+6) * *(b+36) - *(a+7) * *(b+37) + *(a+8) * *(b+46) - *(a+9) * *(b+47) + *(a+0) * *(b+6) - *(a+1) * *(b+7);
			*(c+7) = *(a+3) * *(b+16) + *(a+2) * *(b+17) + *(a+5) * *(b+26) + *(a+4) * *(b+27) + *(a+7) * *(b+36) + *(a+6) * *(b+37) + *(a+9) * *(b+46) + *(a+8) * *(b+47) + *(a+1) * *(b+6) + *(a+0) * *(b+7);

			*(c+8) = *(a+2) * *(b+18) - *(a+3) * *(b+19) + *(a+4) * *(b+28) - *(a+5) * *(b+29) + *(a+6) * *(b+38) - *(a+7) * *(b+39) + *(a+8) * *(b+48) - *(a+9) * *(b+49) + *(a+0) * *(b+8) - *(a+1) * *(b+9);
			*(c+9) = *(a+3) * *(b+18) + *(a+2) * *(b+19) + *(a+5) * *(b+28) + *(a+4) * *(b+29) + *(a+7) * *(b+38) + *(a+6) * *(b+39) + *(a+9) * *(b+48) + *(a+8) * *(b+49) + *(a+1) * *(b+8) + *(a+0) * *(b+9);

			*(c+10) = *(a+10) * *(b+0) - *(a+11) * *(b+1) + *(a+12) * *(b+10) - *(a+13) * *(b+11) + *(a+14) * *(b+20) - *(a+15) * *(b+21) + *(a+16) * *(b+30) - *(a+17) * *(b+31) + *(a+18) * *(b+40) - *(a+19) * *(b+41);
			*(c+11) = *(a+11) * *(b+0) + *(a+10) * *(b+1) + *(a+13) * *(b+10) + *(a+12) * *(b+11) + *(a+15) * *(b+20) + *(a+14) * *(b+21) + *(a+17) * *(b+30) + *(a+16) * *(b+31) + *(a+19) * *(b+40) + *(a+18) * *(b+41);

			*(c+12) = *(a+12) * *(b+12) - *(a+13) * *(b+13) + *(a+10) * *(b+2) + *(a+14) * *(b+22) - *(a+15) * *(b+23) - *(a+11) * *(b+3) + *(a+16) * *(b+32) - *(a+17) * *(b+33) + *(a+18) * *(b+42) - *(a+19) * *(b+43);
			*(c+13) = *(a+13) * *(b+12) + *(a+12) * *(b+13) + *(a+11) * *(b+2) + *(a+15) * *(b+22) + *(a+14) * *(b+23) + *(a+10) * *(b+3) + *(a+17) * *(b+32) + *(a+16) * *(b+33) + *(a+19) * *(b+42) + *(a+18) * *(b+43);

			*(c+14) = *(a+12) * *(b+14) - *(a+13) * *(b+15) + *(a+14) * *(b+24) - *(a+15) * *(b+25) + *(a+16) * *(b+34) - *(a+17) * *(b+35) + *(a+10) * *(b+4) + *(a+18) * *(b+44) - *(a+19) * *(b+45) - *(a+11) * *(b+5);
			*(c+15) = *(a+13) * *(b+14) + *(a+12) * *(b+15) + *(a+15) * *(b+24) + *(a+14) * *(b+25) + *(a+17) * *(b+34) + *(a+16) * *(b+35) + *(a+11) * *(b+4) + *(a+19) * *(b+44) + *(a+18) * *(b+45) + *(a+10) * *(b+5);

			*(c+16) = *(a+12) * *(b+16) - *(a+13) * *(b+17) + *(a+14) * *(b+26) - *(a+15) * *(b+27) + *(a+16) * *(b+36) - *(a+17) * *(b+37) + *(a+18) * *(b+46) - *(a+19) * *(b+47) + *(a+10) * *(b+6) - *(a+11) * *(b+7);
			*(c+17) = *(a+13) * *(b+16) + *(a+12) * *(b+17) + *(a+15) * *(b+26) + *(a+14) * *(b+27) + *(a+17) * *(b+36) + *(a+16) * *(b+37) + *(a+19) * *(b+46) + *(a+18) * *(b+47) + *(a+11) * *(b+6) + *(a+10) * *(b+7);

			*(c+18) = *(a+12) * *(b+18) - *(a+13) * *(b+19) + *(a+14) * *(b+28) - *(a+15) * *(b+29) + *(a+16) * *(b+38) - *(a+17) * *(b+39) + *(a+18) * *(b+48) - *(a+19) * *(b+49) + *(a+10) * *(b+8) - *(a+11) * *(b+9);
			*(c+19) = *(a+13) * *(b+18) + *(a+12) * *(b+19) + *(a+15) * *(b+28) + *(a+14) * *(b+29) + *(a+17) * *(b+38) + *(a+16) * *(b+39) + *(a+19) * *(b+48) + *(a+18) * *(b+49) + *(a+11) * *(b+8) + *(a+10) * *(b+9);

			*(c+20) = *(a+20) * *(b+0) - *(a+21) * *(b+1) + *(a+22) * *(b+10) - *(a+23) * *(b+11) + *(a+24) * *(b+20) - *(a+25) * *(b+21) + *(a+26) * *(b+30) - *(a+27) * *(b+31) + *(a+28) * *(b+40) - *(a+29) * *(b+41);
			*(c+21) = *(a+21) * *(b+0) + *(a+20) * *(b+1) + *(a+23) * *(b+10) + *(a+22) * *(b+11) + *(a+25) * *(b+20) + *(a+24) * *(b+21) + *(a+27) * *(b+30) + *(a+26) * *(b+31) + *(a+29) * *(b+40) + *(a+28) * *(b+41);

			*(c+22) = *(a+22) * *(b+12) - *(a+23) * *(b+13) + *(a+20) * *(b+2) + *(a+24) * *(b+22) - *(a+25) * *(b+23) - *(a+21) * *(b+3) + *(a+26) * *(b+32) - *(a+27) * *(b+33) + *(a+28) * *(b+42) - *(a+29) * *(b+43);
			*(c+23) = *(a+23) * *(b+12) + *(a+22) * *(b+13) + *(a+21) * *(b+2) + *(a+25) * *(b+22) + *(a+24) * *(b+23) + *(a+20) * *(b+3) + *(a+27) * *(b+32) + *(a+26) * *(b+33) + *(a+29) * *(b+42) + *(a+28) * *(b+43);

			*(c+24) = *(a+22) * *(b+14) - *(a+23) * *(b+15) + *(a+24) * *(b+24) - *(a+25) * *(b+25) + *(a+26) * *(b+34) - *(a+27) * *(b+35) + *(a+20) * *(b+4) + *(a+28) * *(b+44) - *(a+29) * *(b+45) - *(a+21) * *(b+5);
			*(c+25) = *(a+23) * *(b+14) + *(a+22) * *(b+15) + *(a+25) * *(b+24) + *(a+24) * *(b+25) + *(a+27) * *(b+34) + *(a+26) * *(b+35) + *(a+21) * *(b+4) + *(a+29) * *(b+44) + *(a+28) * *(b+45) + *(a+20) * *(b+5);

			*(c+26) = *(a+22) * *(b+16) - *(a+23) * *(b+17) + *(a+24) * *(b+26) - *(a+25) * *(b+27) + *(a+26) * *(b+36) - *(a+27) * *(b+37) + *(a+28) * *(b+46) - *(a+29) * *(b+47) + *(a+20) * *(b+6) - *(a+21) * *(b+7);
			*(c+27) = *(a+23) * *(b+16) + *(a+22) * *(b+17) + *(a+25) * *(b+26) + *(a+24) * *(b+27) + *(a+27) * *(b+36) + *(a+26) * *(b+37) + *(a+29) * *(b+46) + *(a+28) * *(b+47) + *(a+21) * *(b+6) + *(a+20) * *(b+7);

			*(c+28) = *(a+22) * *(b+18) - *(a+23) * *(b+19) + *(a+24) * *(b+28) - *(a+25) * *(b+29) + *(a+26) * *(b+38) - *(a+27) * *(b+39) + *(a+28) * *(b+48) - *(a+29) * *(b+49) + *(a+20) * *(b+8) - *(a+21) * *(b+9);
			*(c+29) = *(a+23) * *(b+18) + *(a+22) * *(b+19) + *(a+25) * *(b+28) + *(a+24) * *(b+29) + *(a+27) * *(b+38) + *(a+26) * *(b+39) + *(a+29) * *(b+48) + *(a+28) * *(b+49) + *(a+21) * *(b+8) + *(a+20) * *(b+9);

			*(c+30) = *(a+30) * *(b+0) - *(a+31) * *(b+1) + *(a+32) * *(b+10) - *(a+33) * *(b+11) + *(a+34) * *(b+20) - *(a+35) * *(b+21) + *(a+36) * *(b+30) - *(a+37) * *(b+31) + *(a+38) * *(b+40) - *(a+39) * *(b+41);
			*(c+31) = *(a+31) * *(b+0) + *(a+30) * *(b+1) + *(a+33) * *(b+10) + *(a+32) * *(b+11) + *(a+35) * *(b+20) + *(a+34) * *(b+21) + *(a+37) * *(b+30) + *(a+36) * *(b+31) + *(a+39) * *(b+40) + *(a+38) * *(b+41);

			*(c+32) = *(a+32) * *(b+12) - *(a+33) * *(b+13) + *(a+30) * *(b+2) + *(a+34) * *(b+22) - *(a+35) * *(b+23) - *(a+31) * *(b+3) + *(a+36) * *(b+32) - *(a+37) * *(b+33) + *(a+38) * *(b+42) - *(a+39) * *(b+43);
			*(c+33) = *(a+33) * *(b+12) + *(a+32) * *(b+13) + *(a+31) * *(b+2) + *(a+35) * *(b+22) + *(a+34) * *(b+23) + *(a+30) * *(b+3) + *(a+37) * *(b+32) + *(a+36) * *(b+33) + *(a+39) * *(b+42) + *(a+38) * *(b+43);

			*(c+34) = *(a+32) * *(b+14) - *(a+33) * *(b+15) + *(a+34) * *(b+24) - *(a+35) * *(b+25) + *(a+36) * *(b+34) - *(a+37) * *(b+35) + *(a+30) * *(b+4) + *(a+38) * *(b+44) - *(a+39) * *(b+45) - *(a+31) * *(b+5);
			*(c+35) = *(a+33) * *(b+14) + *(a+32) * *(b+15) + *(a+35) * *(b+24) + *(a+34) * *(b+25) + *(a+37) * *(b+34) + *(a+36) * *(b+35) + *(a+31) * *(b+4) + *(a+39) * *(b+44) + *(a+38) * *(b+45) + *(a+30) * *(b+5);

			*(c+36) = *(a+32) * *(b+16) - *(a+33) * *(b+17) + *(a+34) * *(b+26) - *(a+35) * *(b+27) + *(a+36) * *(b+36) - *(a+37) * *(b+37) + *(a+38) * *(b+46) - *(a+39) * *(b+47) + *(a+30) * *(b+6) - *(a+31) * *(b+7);
			*(c+37) = *(a+33) * *(b+16) + *(a+32) * *(b+17) + *(a+35) * *(b+26) + *(a+34) * *(b+27) + *(a+37) * *(b+36) + *(a+36) * *(b+37) + *(a+39) * *(b+46) + *(a+38) * *(b+47) + *(a+31) * *(b+6) + *(a+30) * *(b+7);

			*(c+38) = *(a+32) * *(b+18) - *(a+33) * *(b+19) + *(a+34) * *(b+28) - *(a+35) * *(b+29) + *(a+36) * *(b+38) - *(a+37) * *(b+39) + *(a+38) * *(b+48) - *(a+39) * *(b+49) + *(a+30) * *(b+8) - *(a+31) * *(b+9);
			*(c+39) = *(a+33) * *(b+18) + *(a+32) * *(b+19) + *(a+35) * *(b+28) + *(a+34) * *(b+29) + *(a+37) * *(b+38) + *(a+36) * *(b+39) + *(a+39) * *(b+48) + *(a+38) * *(b+49) + *(a+31) * *(b+8) + *(a+30) * *(b+9);

			*(c+40) = *(a+40) * *(b+0) - *(a+41) * *(b+1) + *(a+42) * *(b+10) - *(a+43) * *(b+11) + *(a+44) * *(b+20) - *(a+45) * *(b+21) + *(a+46) * *(b+30) - *(a+47) * *(b+31) + *(a+48) * *(b+40) - *(a+49) * *(b+41);
			*(c+41) = *(a+41) * *(b+0) + *(a+40) * *(b+1) + *(a+43) * *(b+10) + *(a+42) * *(b+11) + *(a+45) * *(b+20) + *(a+44) * *(b+21) + *(a+47) * *(b+30) + *(a+46) * *(b+31) + *(a+49) * *(b+40) + *(a+48) * *(b+41);

			*(c+42) = *(a+42) * *(b+12) - *(a+43) * *(b+13) + *(a+40) * *(b+2) + *(a+44) * *(b+22) - *(a+45) * *(b+23) - *(a+41) * *(b+3) + *(a+46) * *(b+32) - *(a+47) * *(b+33) + *(a+48) * *(b+42) - *(a+49) * *(b+43);
			*(c+43) = *(a+43) * *(b+12) + *(a+42) * *(b+13) + *(a+41) * *(b+2) + *(a+45) * *(b+22) + *(a+44) * *(b+23) + *(a+40) * *(b+3) + *(a+47) * *(b+32) + *(a+46) * *(b+33) + *(a+49) * *(b+42) + *(a+48) * *(b+43);

			*(c+44) = *(a+42) * *(b+14) - *(a+43) * *(b+15) + *(a+44) * *(b+24) - *(a+45) * *(b+25) + *(a+46) * *(b+34) - *(a+47) * *(b+35) + *(a+40) * *(b+4) + *(a+48) * *(b+44) - *(a+49) * *(b+45) - *(a+41) * *(b+5);
			*(c+45) = *(a+43) * *(b+14) + *(a+42) * *(b+15) + *(a+45) * *(b+24) + *(a+44) * *(b+25) + *(a+47) * *(b+34) + *(a+46) * *(b+35) + *(a+41) * *(b+4) + *(a+49) * *(b+44) + *(a+48) * *(b+45) + *(a+40) * *(b+5);

			*(c+46) = *(a+42) * *(b+16) - *(a+43) * *(b+17) + *(a+44) * *(b+26) - *(a+45) * *(b+27) + *(a+46) * *(b+36) - *(a+47) * *(b+37) + *(a+48) * *(b+46) - *(a+49) * *(b+47) + *(a+40) * *(b+6) - *(a+41) * *(b+7);
			*(c+47) = *(a+43) * *(b+16) + *(a+42) * *(b+17) + *(a+45) * *(b+26) + *(a+44) * *(b+27) + *(a+47) * *(b+36) + *(a+46) * *(b+37) + *(a+49) * *(b+46) + *(a+48) * *(b+47) + *(a+41) * *(b+6) + *(a+40) * *(b+7);

			*(c+48) = *(a+42) * *(b+18) - *(a+43) * *(b+19) + *(a+44) * *(b+28) - *(a+45) * *(b+29) + *(a+46) * *(b+38) - *(a+47) * *(b+39) + *(a+48) * *(b+48) - *(a+49) * *(b+49) + *(a+40) * *(b+8) - *(a+41) * *(b+9);
			*(c+49) = *(a+43) * *(b+18) + *(a+42) * *(b+19) + *(a+45) * *(b+28) + *(a+44) * *(b+29) + *(a+47) * *(b+38) + *(a+46) * *(b+39) + *(a+49) * *(b+48) + *(a+48) * *(b+49) + *(a+41) * *(b+8) + *(a+40) * *(b+9);	

		
		}
	#endif
		
	#if (SUN>5)

		void GenMatMult(double* c, const double* a, const double* b)
		{
			
			
			
			Complex *C = (Complex*)c;
			Complex *A = (Complex*)a;
			Complex *B = (Complex*)b;
			
			
			for( int i=0; i<SUN; i++){
				for( int j=0; j<SUN; j++){
			
					C[i*SUN+j]=A[i*SUN+0]*B[0*SUN+j];
					
					for ( int k=1;k<SUN;k++) C[i*SUN+j]+=A[i*SUN+k]*B[k*SUN+j];
					
			}}

			
		}

	#endif

	//---------------------------------------------------------------------------------------------
	//	MATRIX ADDING MULTIPLICATION
	//---------------------------------------------------------------------------------------------
	
	#if (SUN==2)

		void GenMatMultAdd(double* c, const double* a, const double* b)
		{

			*(c+0)	+= *(a+0) * *(b+0) - *(a+1) * *(b+1) + *(a+2) * *(b+4) - *(a+3) * *(b+5);
			*(c+1)	+= *(a+1) * *(b+0) + *(a+0) * *(b+1) + *(a+3) * *(b+4) + *(a+2) * *(b+5);

			*(c+2)	+= *(a+0) * *(b+2) - *(a+1) * *(b+3) + *(a+2) * *(b+6) - *(a+3) * *(b+7);
			*(c+3)	+= *(a+1) * *(b+2) + *(a+0) * *(b+3) + *(a+3) * *(b+6) + *(a+2) * *(b+7);

			*(c+4)	+= *(a+4) * *(b+0) - *(a+5) * *(b+1) + *(a+6) * *(b+4) - *(a+7) * *(b+5);
			*(c+5)	+= *(a+5) * *(b+0) + *(a+4) * *(b+1) + *(a+7) * *(b+4) + *(a+6) * *(b+5);

			*(c+6)	+= *(a+4) * *(b+2) - *(a+5) * *(b+3) + *(a+6) * *(b+6) - *(a+7) * *(b+7);
			*(c+7)	+= *(a+5) * *(b+2) + *(a+4) * *(b+3) + *(a+7) * *(b+6) + *(a+6) * *(b+7);
			
		}

	#endif



	#if (SUN==3)

		void GenMatMultAdd(double* c, const double* a, const double* b)
		{
		*c      += *a      * *b      - *(a+1)  * *(b+1)    +
			*(a+2)  * *(b+6)  - *(a+3)  * *(b+7)    +
			*(a+4)  * *(b+12) - *(a+5)  * *(b+13);
		*(c+1)  += *a      * *(b+1)  + *(a+1)  * *b        +
			*(a+2)  * *(b+7)  + *(a+3)  * *(b+6)    +
			*(a+4)  * *(b+13) + *(a+5)  * *(b+12);

		*(c+2)  += *a      * *(b+2)  - *(a+1)  * *(b+3)    +
			*(a+2)  * *(b+8)  - *(a+3)  * *(b+9)    +
			*(a+4)  * *(b+14) - *(a+5)  * *(b+15);
		*(c+3)  += *a      * *(b+3)  + *(a+1)  * *(b+2)    +
			*(a+2)  * *(b+9)  + *(a+3)  * *(b+8)    +
			*(a+4)  * *(b+15) + *(a+5)  * *(b+14);

		*(c+4)  += *a      * *(b+4)  - *(a+1)  * *(b+5)    +
			*(a+2)  * *(b+10) - *(a+3)  * *(b+11)   +
			*(a+4)  * *(b+16) - *(a+5)  * *(b+17);
		*(c+5)  += *a      * *(b+5)  + *(a+1)  * *(b+4)    +
			*(a+2)  * *(b+11) + *(a+3)  * *(b+10)   +
			*(a+4)  * *(b+17) + *(a+5)  * *(b+16);

		*(c+6)  += *(a+6)  * *b      - *(a+7)  * *(b+1)    +
			*(a+8)  * *(b+6)  - *(a+9)  * *(b+7)    +
			*(a+10) * *(b+12) - *(a+11) * *(b+13);
		*(c+7)  += *(a+6)  * *(b+1)  + *(a+7)  * *b        +
			*(a+8)  * *(b+7)  + *(a+9)  * *(b+6)    +
			*(a+10) * *(b+13) + *(a+11) * *(b+12);

		*(c+8)  += *(a+6)  * *(b+2)  - *(a+7)  * *(b+3)    +
			*(a+8)  * *(b+8)  - *(a+9)  * *(b+9)    +
			*(a+10) * *(b+14) - *(a+11) * *(b+15);
		*(c+9)  += *(a+6)  * *(b+3)  + *(a+7)  * *(b+2)    +
			*(a+8)  * *(b+9)  + *(a+9)  * *(b+8)    +
			*(a+10) * *(b+15) + *(a+11) * *(b+14);

		*(c+10) += *(a+6)  * *(b+4)  - *(a+7)  * *(b+5)    +
			*(a+8)  * *(b+10) - *(a+9)  * *(b+11)   +
			*(a+10) * *(b+16) - *(a+11) * *(b+17);
		*(c+11) += *(a+6)  * *(b+5)  + *(a+7)  * *(b+4)    +
			*(a+8)  * *(b+11) + *(a+9)  * *(b+10)   +
			*(a+10) * *(b+17) + *(a+11) * *(b+16);

		*(c+12) += *(a+12) * *b      - *(a+13) * *(b+1)    +
			*(a+14) * *(b+6)  - *(a+15) * *(b+7)    +
			*(a+16) * *(b+12) - *(a+17) * *(b+13);
		*(c+13) += *(a+12) * *(b+1)  + *(a+13) * *b        +
			*(a+14) * *(b+7)  + *(a+15) * *(b+6)    +
			*(a+16) * *(b+13) + *(a+17) * *(b+12);

		*(c+14) += *(a+12) * *(b+2)  - *(a+13) * *(b+3)    +
			*(a+14) * *(b+8)  - *(a+15) * *(b+9)    +
			*(a+16) * *(b+14) - *(a+17) * *(b+15);
		*(c+15) += *(a+12) * *(b+3)  + *(a+13) * *(b+2)    +
			*(a+14) * *(b+9)  + *(a+15) * *(b+8)    +
			*(a+16) * *(b+15) + *(a+17) * *(b+14);

		*(c+16) += *(a+12) * *(b+4)  - *(a+13) * *(b+5)    +
			*(a+14) * *(b+10) - *(a+15) * *(b+11)   +
			*(a+16) * *(b+16) - *(a+17) * *(b+17);
		*(c+17) += *(a+12) * *(b+5)  + *(a+13) * *(b+4)    +
			*(a+14) * *(b+11) + *(a+15) * *(b+10)   +
			*(a+16) * *(b+17) + *(a+17) * *(b+16);
		}


	#endif

	#if (SUN==4)

		void GenMatMultAdd(double* c, const double* a, const double* b)
		{

			*(c+0)	+= *(a+0) * *(b+0) - *(a+1) * *(b+1) + *(a+4) * *(b+16) - *(a+5) * *(b+17) + *(a+6) * *(b+24) - *(a+7) * *(b+25) + *(a+2) * *(b+8) - *(a+3) * *(b+9);
			*(c+1)	+= *(a+1) * *(b+0) + *(a+0) * *(b+1) + *(a+5) * *(b+16) + *(a+4) * *(b+17) + *(a+7) * *(b+24) + *(a+6) * *(b+25) + *(a+3) * *(b+8) + *(a+2) * *(b+9);

			*(c+2)	+= *(a+2) * *(b+10) - *(a+3) * *(b+11) + *(a+4) * *(b+18) - *(a+5) * *(b+19) + *(a+0) * *(b+2) + *(a+6) * *(b+26) - *(a+7) * *(b+27) - *(a+1) * *(b+3);
			*(c+3)	+= *(a+3) * *(b+10) + *(a+2) * *(b+11) + *(a+5) * *(b+18) + *(a+4) * *(b+19) + *(a+1) * *(b+2) + *(a+7) * *(b+26) + *(a+6) * *(b+27) + *(a+0) * *(b+3);

			*(c+4)	+= *(a+2) * *(b+12) - *(a+3) * *(b+13) + *(a+4) * *(b+20) - *(a+5) * *(b+21) + *(a+6) * *(b+28) - *(a+7) * *(b+29) + *(a+0) * *(b+4) - *(a+1) * *(b+5);
			*(c+5)	+= *(a+3) * *(b+12) + *(a+2) * *(b+13) + *(a+5) * *(b+20) + *(a+4) * *(b+21) + *(a+7) * *(b+28) + *(a+6) * *(b+29) + *(a+1) * *(b+4) + *(a+0) * *(b+5);

			*(c+6)	+= *(a+2) * *(b+14) - *(a+3) * *(b+15) + *(a+4) * *(b+22) - *(a+5) * *(b+23) + *(a+6) * *(b+30) - *(a+7) * *(b+31) + *(a+0) * *(b+6) - *(a+1) * *(b+7);
			*(c+7)	+= *(a+3) * *(b+14) + *(a+2) * *(b+15) + *(a+5) * *(b+22) + *(a+4) * *(b+23) + *(a+7) * *(b+30) + *(a+6) * *(b+31) + *(a+1) * *(b+6) + *(a+0) * *(b+7);

			*(c+8)	+= *(a+8) * *(b+0) - *(a+9) * *(b+1) + *(a+12) * *(b+16) - *(a+13) * *(b+17) + *(a+14) * *(b+24) - *(a+15) * *(b+25) + *(a+10) * *(b+8) - *(a+11) * *(b+9);
			*(c+9)	+= *(a+9) * *(b+0) + *(a+8) * *(b+1) + *(a+13) * *(b+16) + *(a+12) * *(b+17) + *(a+15) * *(b+24) + *(a+14) * *(b+25) + *(a+11) * *(b+8) + *(a+10) * *(b+9);

			*(c+10)	+= *(a+10) * *(b+10) - *(a+11) * *(b+11) + *(a+12) * *(b+18) - *(a+13) * *(b+19) + *(a+8) * *(b+2) + *(a+14) * *(b+26) - *(a+15) * *(b+27) - *(a+9) * *(b+3);
			*(c+11)	+= *(a+11) * *(b+10) + *(a+10) * *(b+11) + *(a+13) * *(b+18) + *(a+12) * *(b+19) + *(a+9) * *(b+2) + *(a+15) * *(b+26) + *(a+14) * *(b+27) + *(a+8) * *(b+3);

			*(c+12)	+= *(a+10) * *(b+12) - *(a+11) * *(b+13) + *(a+12) * *(b+20) - *(a+13) * *(b+21) + *(a+14) * *(b+28) - *(a+15) * *(b+29) + *(a+8) * *(b+4) - *(a+9) * *(b+5);
			*(c+13)	+= *(a+11) * *(b+12) + *(a+10) * *(b+13) + *(a+13) * *(b+20) + *(a+12) * *(b+21) + *(a+15) * *(b+28) + *(a+14) * *(b+29) + *(a+9) * *(b+4) + *(a+8) * *(b+5);

			*(c+14)	+= *(a+10) * *(b+14) - *(a+11) * *(b+15) + *(a+12) * *(b+22) - *(a+13) * *(b+23) + *(a+14) * *(b+30) - *(a+15) * *(b+31) + *(a+8) * *(b+6) - *(a+9) * *(b+7);
			*(c+15)	+= *(a+11) * *(b+14) + *(a+10) * *(b+15) + *(a+13) * *(b+22) + *(a+12) * *(b+23) + *(a+15) * *(b+30) + *(a+14) * *(b+31) + *(a+9) * *(b+6) + *(a+8) * *(b+7);

			*(c+16)	+= *(a+16) * *(b+0) - *(a+17) * *(b+1) + *(a+20) * *(b+16) - *(a+21) * *(b+17) + *(a+22) * *(b+24) - *(a+23) * *(b+25) + *(a+18) * *(b+8) - *(a+19) * *(b+9);
			*(c+17)	+= *(a+17) * *(b+0) + *(a+16) * *(b+1) + *(a+21) * *(b+16) + *(a+20) * *(b+17) + *(a+23) * *(b+24) + *(a+22) * *(b+25) + *(a+19) * *(b+8) + *(a+18) * *(b+9);

			*(c+18)	+= *(a+18) * *(b+10) - *(a+19) * *(b+11) + *(a+20) * *(b+18) - *(a+21) * *(b+19) + *(a+16) * *(b+2) + *(a+22) * *(b+26) - *(a+23) * *(b+27) - *(a+17) * *(b+3);
			*(c+19)	+= *(a+19) * *(b+10) + *(a+18) * *(b+11) + *(a+21) * *(b+18) + *(a+20) * *(b+19) + *(a+17) * *(b+2) + *(a+23) * *(b+26) + *(a+22) * *(b+27) + *(a+16) * *(b+3);

			*(c+20)	+= *(a+18) * *(b+12) - *(a+19) * *(b+13) + *(a+20) * *(b+20) - *(a+21) * *(b+21) + *(a+22) * *(b+28) - *(a+23) * *(b+29) + *(a+16) * *(b+4) - *(a+17) * *(b+5);
			*(c+21)	+= *(a+19) * *(b+12) + *(a+18) * *(b+13) + *(a+21) * *(b+20) + *(a+20) * *(b+21) + *(a+23) * *(b+28) + *(a+22) * *(b+29) + *(a+17) * *(b+4) + *(a+16) * *(b+5);

			*(c+22)	+= *(a+18) * *(b+14) - *(a+19) * *(b+15) + *(a+20) * *(b+22) - *(a+21) * *(b+23) + *(a+22) * *(b+30) - *(a+23) * *(b+31) + *(a+16) * *(b+6) - *(a+17) * *(b+7);
			*(c+23)	+= *(a+19) * *(b+14) + *(a+18) * *(b+15) + *(a+21) * *(b+22) + *(a+20) * *(b+23) + *(a+23) * *(b+30) + *(a+22) * *(b+31) + *(a+17) * *(b+6) + *(a+16) * *(b+7);

			*(c+24)	+= *(a+24) * *(b+0) - *(a+25) * *(b+1) + *(a+28) * *(b+16) - *(a+29) * *(b+17) + *(a+30) * *(b+24) - *(a+31) * *(b+25) + *(a+26) * *(b+8) - *(a+27) * *(b+9);
			*(c+25)	+= *(a+25) * *(b+0) + *(a+24) * *(b+1) + *(a+29) * *(b+16) + *(a+28) * *(b+17) + *(a+31) * *(b+24) + *(a+30) * *(b+25) + *(a+27) * *(b+8) + *(a+26) * *(b+9);

			*(c+26)	+= *(a+26) * *(b+10) - *(a+27) * *(b+11) + *(a+28) * *(b+18) - *(a+29) * *(b+19) + *(a+24) * *(b+2) + *(a+30) * *(b+26) - *(a+31) * *(b+27) - *(a+25) * *(b+3);
			*(c+27)	+= *(a+27) * *(b+10) + *(a+26) * *(b+11) + *(a+29) * *(b+18) + *(a+28) * *(b+19) + *(a+25) * *(b+2) + *(a+31) * *(b+26) + *(a+30) * *(b+27) + *(a+24) * *(b+3);

			*(c+28)	+= *(a+26) * *(b+12) - *(a+27) * *(b+13) + *(a+28) * *(b+20) - *(a+29) * *(b+21) + *(a+30) * *(b+28) - *(a+31) * *(b+29) + *(a+24) * *(b+4) - *(a+25) * *(b+5);
			*(c+29)	+= *(a+27) * *(b+12) + *(a+26) * *(b+13) + *(a+29) * *(b+20) + *(a+28) * *(b+21) + *(a+31) * *(b+28) + *(a+30) * *(b+29) + *(a+25) * *(b+4) + *(a+24) * *(b+5);

			*(c+30)	+= *(a+26) * *(b+14) - *(a+27) * *(b+15) + *(a+28) * *(b+22) - *(a+29) * *(b+23) + *(a+30) * *(b+30) - *(a+31) * *(b+31) + *(a+24) * *(b+6) - *(a+25) * *(b+7);
			*(c+31)	+= *(a+27) * *(b+14) + *(a+26) * *(b+15) + *(a+29) * *(b+22) + *(a+28) * *(b+23) + *(a+31) * *(b+30) + *(a+30) * *(b+31) + *(a+25) * *(b+6) + *(a+24) * *(b+7);

		}

	#endif

	#if (SUN==5)

		void GenMatMultAdd(double* c, const double* a, const double* b)
		{
			
			*(c+0) += *(a+0) * *(b+0) - *(a+1) * *(b+1) + *(a+2) * *(b+10) - *(a+3) * *(b+11) + *(a+4) * *(b+20) - *(a+5) * *(b+21) + *(a+6) * *(b+30) - *(a+7) * *(b+31) + *(a+8) * *(b+40) - *(a+9) * *(b+41);
			*(c+1) += *(a+1) * *(b+0) + *(a+0) * *(b+1) + *(a+3) * *(b+10) + *(a+2) * *(b+11) + *(a+5) * *(b+20) + *(a+4) * *(b+21) + *(a+7) * *(b+30) + *(a+6) * *(b+31) + *(a+9) * *(b+40) + *(a+8) * *(b+41);

			*(c+2) += *(a+2) * *(b+12) - *(a+3) * *(b+13) + *(a+0) * *(b+2) + *(a+4) * *(b+22) - *(a+5) * *(b+23) - *(a+1) * *(b+3) + *(a+6) * *(b+32) - *(a+7) * *(b+33) + *(a+8) * *(b+42) - *(a+9) * *(b+43);
			*(c+3) += *(a+3) * *(b+12) + *(a+2) * *(b+13) + *(a+1) * *(b+2) + *(a+5) * *(b+22) + *(a+4) * *(b+23) + *(a+0) * *(b+3) + *(a+7) * *(b+32) + *(a+6) * *(b+33) + *(a+9) * *(b+42) + *(a+8) * *(b+43);

			*(c+4) += *(a+2) * *(b+14) - *(a+3) * *(b+15) + *(a+4) * *(b+24) - *(a+5) * *(b+25) + *(a+6) * *(b+34) - *(a+7) * *(b+35) + *(a+0) * *(b+4) + *(a+8) * *(b+44) - *(a+9) * *(b+45) - *(a+1) * *(b+5);
			*(c+5) += *(a+3) * *(b+14) + *(a+2) * *(b+15) + *(a+5) * *(b+24) + *(a+4) * *(b+25) + *(a+7) * *(b+34) + *(a+6) * *(b+35) + *(a+1) * *(b+4) + *(a+9) * *(b+44) + *(a+8) * *(b+45) + *(a+0) * *(b+5);

			*(c+6) += *(a+2) * *(b+16) - *(a+3) * *(b+17) + *(a+4) * *(b+26) - *(a+5) * *(b+27) + *(a+6) * *(b+36) - *(a+7) * *(b+37) + *(a+8) * *(b+46) - *(a+9) * *(b+47) + *(a+0) * *(b+6) - *(a+1) * *(b+7);
			*(c+7) += *(a+3) * *(b+16) + *(a+2) * *(b+17) + *(a+5) * *(b+26) + *(a+4) * *(b+27) + *(a+7) * *(b+36) + *(a+6) * *(b+37) + *(a+9) * *(b+46) + *(a+8) * *(b+47) + *(a+1) * *(b+6) + *(a+0) * *(b+7);

			*(c+8) += *(a+2) * *(b+18) - *(a+3) * *(b+19) + *(a+4) * *(b+28) - *(a+5) * *(b+29) + *(a+6) * *(b+38) - *(a+7) * *(b+39) + *(a+8) * *(b+48) - *(a+9) * *(b+49) + *(a+0) * *(b+8) - *(a+1) * *(b+9);
			*(c+9) += *(a+3) * *(b+18) + *(a+2) * *(b+19) + *(a+5) * *(b+28) + *(a+4) * *(b+29) + *(a+7) * *(b+38) + *(a+6) * *(b+39) + *(a+9) * *(b+48) + *(a+8) * *(b+49) + *(a+1) * *(b+8) + *(a+0) * *(b+9);

			*(c+10) += *(a+10) * *(b+0) - *(a+11) * *(b+1) + *(a+12) * *(b+10) - *(a+13) * *(b+11) + *(a+14) * *(b+20) - *(a+15) * *(b+21) + *(a+16) * *(b+30) - *(a+17) * *(b+31) + *(a+18) * *(b+40) - *(a+19) * *(b+41);
			*(c+11) += *(a+11) * *(b+0) + *(a+10) * *(b+1) + *(a+13) * *(b+10) + *(a+12) * *(b+11) + *(a+15) * *(b+20) + *(a+14) * *(b+21) + *(a+17) * *(b+30) + *(a+16) * *(b+31) + *(a+19) * *(b+40) + *(a+18) * *(b+41);

			*(c+12) += *(a+12) * *(b+12) - *(a+13) * *(b+13) + *(a+10) * *(b+2) + *(a+14) * *(b+22) - *(a+15) * *(b+23) - *(a+11) * *(b+3) + *(a+16) * *(b+32) - *(a+17) * *(b+33) + *(a+18) * *(b+42) - *(a+19) * *(b+43);
			*(c+13) += *(a+13) * *(b+12) + *(a+12) * *(b+13) + *(a+11) * *(b+2) + *(a+15) * *(b+22) + *(a+14) * *(b+23) + *(a+10) * *(b+3) + *(a+17) * *(b+32) + *(a+16) * *(b+33) + *(a+19) * *(b+42) + *(a+18) * *(b+43);

			*(c+14) += *(a+12) * *(b+14) - *(a+13) * *(b+15) + *(a+14) * *(b+24) - *(a+15) * *(b+25) + *(a+16) * *(b+34) - *(a+17) * *(b+35) + *(a+10) * *(b+4) + *(a+18) * *(b+44) - *(a+19) * *(b+45) - *(a+11) * *(b+5);
			*(c+15) += *(a+13) * *(b+14) + *(a+12) * *(b+15) + *(a+15) * *(b+24) + *(a+14) * *(b+25) + *(a+17) * *(b+34) + *(a+16) * *(b+35) + *(a+11) * *(b+4) + *(a+19) * *(b+44) + *(a+18) * *(b+45) + *(a+10) * *(b+5);

			*(c+16) += *(a+12) * *(b+16) - *(a+13) * *(b+17) + *(a+14) * *(b+26) - *(a+15) * *(b+27) + *(a+16) * *(b+36) - *(a+17) * *(b+37) + *(a+18) * *(b+46) - *(a+19) * *(b+47) + *(a+10) * *(b+6) - *(a+11) * *(b+7);
			*(c+17) += *(a+13) * *(b+16) + *(a+12) * *(b+17) + *(a+15) * *(b+26) + *(a+14) * *(b+27) + *(a+17) * *(b+36) + *(a+16) * *(b+37) + *(a+19) * *(b+46) + *(a+18) * *(b+47) + *(a+11) * *(b+6) + *(a+10) * *(b+7);

			*(c+18) += *(a+12) * *(b+18) - *(a+13) * *(b+19) + *(a+14) * *(b+28) - *(a+15) * *(b+29) + *(a+16) * *(b+38) - *(a+17) * *(b+39) + *(a+18) * *(b+48) - *(a+19) * *(b+49) + *(a+10) * *(b+8) - *(a+11) * *(b+9);
			*(c+19) += *(a+13) * *(b+18) + *(a+12) * *(b+19) + *(a+15) * *(b+28) + *(a+14) * *(b+29) + *(a+17) * *(b+38) + *(a+16) * *(b+39) + *(a+19) * *(b+48) + *(a+18) * *(b+49) + *(a+11) * *(b+8) + *(a+10) * *(b+9);

			*(c+20) += *(a+20) * *(b+0) - *(a+21) * *(b+1) + *(a+22) * *(b+10) - *(a+23) * *(b+11) + *(a+24) * *(b+20) - *(a+25) * *(b+21) + *(a+26) * *(b+30) - *(a+27) * *(b+31) + *(a+28) * *(b+40) - *(a+29) * *(b+41);
			*(c+21) += *(a+21) * *(b+0) + *(a+20) * *(b+1) + *(a+23) * *(b+10) + *(a+22) * *(b+11) + *(a+25) * *(b+20) + *(a+24) * *(b+21) + *(a+27) * *(b+30) + *(a+26) * *(b+31) + *(a+29) * *(b+40) + *(a+28) * *(b+41);

			*(c+22) += *(a+22) * *(b+12) - *(a+23) * *(b+13) + *(a+20) * *(b+2) + *(a+24) * *(b+22) - *(a+25) * *(b+23) - *(a+21) * *(b+3) + *(a+26) * *(b+32) - *(a+27) * *(b+33) + *(a+28) * *(b+42) - *(a+29) * *(b+43);
			*(c+23) += *(a+23) * *(b+12) + *(a+22) * *(b+13) + *(a+21) * *(b+2) + *(a+25) * *(b+22) + *(a+24) * *(b+23) + *(a+20) * *(b+3) + *(a+27) * *(b+32) + *(a+26) * *(b+33) + *(a+29) * *(b+42) + *(a+28) * *(b+43);

			*(c+24) += *(a+22) * *(b+14) - *(a+23) * *(b+15) + *(a+24) * *(b+24) - *(a+25) * *(b+25) + *(a+26) * *(b+34) - *(a+27) * *(b+35) + *(a+20) * *(b+4) + *(a+28) * *(b+44) - *(a+29) * *(b+45) - *(a+21) * *(b+5);
			*(c+25) += *(a+23) * *(b+14) + *(a+22) * *(b+15) + *(a+25) * *(b+24) + *(a+24) * *(b+25) + *(a+27) * *(b+34) + *(a+26) * *(b+35) + *(a+21) * *(b+4) + *(a+29) * *(b+44) + *(a+28) * *(b+45) + *(a+20) * *(b+5);

			*(c+26) += *(a+22) * *(b+16) - *(a+23) * *(b+17) + *(a+24) * *(b+26) - *(a+25) * *(b+27) + *(a+26) * *(b+36) - *(a+27) * *(b+37) + *(a+28) * *(b+46) - *(a+29) * *(b+47) + *(a+20) * *(b+6) - *(a+21) * *(b+7);
			*(c+27) += *(a+23) * *(b+16) + *(a+22) * *(b+17) + *(a+25) * *(b+26) + *(a+24) * *(b+27) + *(a+27) * *(b+36) + *(a+26) * *(b+37) + *(a+29) * *(b+46) + *(a+28) * *(b+47) + *(a+21) * *(b+6) + *(a+20) * *(b+7);

			*(c+28) += *(a+22) * *(b+18) - *(a+23) * *(b+19) + *(a+24) * *(b+28) - *(a+25) * *(b+29) + *(a+26) * *(b+38) - *(a+27) * *(b+39) + *(a+28) * *(b+48) - *(a+29) * *(b+49) + *(a+20) * *(b+8) - *(a+21) * *(b+9);
			*(c+29) += *(a+23) * *(b+18) + *(a+22) * *(b+19) + *(a+25) * *(b+28) + *(a+24) * *(b+29) + *(a+27) * *(b+38) + *(a+26) * *(b+39) + *(a+29) * *(b+48) + *(a+28) * *(b+49) + *(a+21) * *(b+8) + *(a+20) * *(b+9);

			*(c+30) += *(a+30) * *(b+0) - *(a+31) * *(b+1) + *(a+32) * *(b+10) - *(a+33) * *(b+11) + *(a+34) * *(b+20) - *(a+35) * *(b+21) + *(a+36) * *(b+30) - *(a+37) * *(b+31) + *(a+38) * *(b+40) - *(a+39) * *(b+41);
			*(c+31) += *(a+31) * *(b+0) + *(a+30) * *(b+1) + *(a+33) * *(b+10) + *(a+32) * *(b+11) + *(a+35) * *(b+20) + *(a+34) * *(b+21) + *(a+37) * *(b+30) + *(a+36) * *(b+31) + *(a+39) * *(b+40) + *(a+38) * *(b+41);

			*(c+32) += *(a+32) * *(b+12) - *(a+33) * *(b+13) + *(a+30) * *(b+2) + *(a+34) * *(b+22) - *(a+35) * *(b+23) - *(a+31) * *(b+3) + *(a+36) * *(b+32) - *(a+37) * *(b+33) + *(a+38) * *(b+42) - *(a+39) * *(b+43);
			*(c+33) += *(a+33) * *(b+12) + *(a+32) * *(b+13) + *(a+31) * *(b+2) + *(a+35) * *(b+22) + *(a+34) * *(b+23) + *(a+30) * *(b+3) + *(a+37) * *(b+32) + *(a+36) * *(b+33) + *(a+39) * *(b+42) + *(a+38) * *(b+43);

			*(c+34) += *(a+32) * *(b+14) - *(a+33) * *(b+15) + *(a+34) * *(b+24) - *(a+35) * *(b+25) + *(a+36) * *(b+34) - *(a+37) * *(b+35) + *(a+30) * *(b+4) + *(a+38) * *(b+44) - *(a+39) * *(b+45) - *(a+31) * *(b+5);
			*(c+35) += *(a+33) * *(b+14) + *(a+32) * *(b+15) + *(a+35) * *(b+24) + *(a+34) * *(b+25) + *(a+37) * *(b+34) + *(a+36) * *(b+35) + *(a+31) * *(b+4) + *(a+39) * *(b+44) + *(a+38) * *(b+45) + *(a+30) * *(b+5);

			*(c+36) += *(a+32) * *(b+16) - *(a+33) * *(b+17) + *(a+34) * *(b+26) - *(a+35) * *(b+27) + *(a+36) * *(b+36) - *(a+37) * *(b+37) + *(a+38) * *(b+46) - *(a+39) * *(b+47) + *(a+30) * *(b+6) - *(a+31) * *(b+7);
			*(c+37) += *(a+33) * *(b+16) + *(a+32) * *(b+17) + *(a+35) * *(b+26) + *(a+34) * *(b+27) + *(a+37) * *(b+36) + *(a+36) * *(b+37) + *(a+39) * *(b+46) + *(a+38) * *(b+47) + *(a+31) * *(b+6) + *(a+30) * *(b+7);

			*(c+38) += *(a+32) * *(b+18) - *(a+33) * *(b+19) + *(a+34) * *(b+28) - *(a+35) * *(b+29) + *(a+36) * *(b+38) - *(a+37) * *(b+39) + *(a+38) * *(b+48) - *(a+39) * *(b+49) + *(a+30) * *(b+8) - *(a+31) * *(b+9);
			*(c+39) += *(a+33) * *(b+18) + *(a+32) * *(b+19) + *(a+35) * *(b+28) + *(a+34) * *(b+29) + *(a+37) * *(b+38) + *(a+36) * *(b+39) + *(a+39) * *(b+48) + *(a+38) * *(b+49) + *(a+31) * *(b+8) + *(a+30) * *(b+9);

			*(c+40) += *(a+40) * *(b+0) - *(a+41) * *(b+1) + *(a+42) * *(b+10) - *(a+43) * *(b+11) + *(a+44) * *(b+20) - *(a+45) * *(b+21) + *(a+46) * *(b+30) - *(a+47) * *(b+31) + *(a+48) * *(b+40) - *(a+49) * *(b+41);
			*(c+41) += *(a+41) * *(b+0) + *(a+40) * *(b+1) + *(a+43) * *(b+10) + *(a+42) * *(b+11) + *(a+45) * *(b+20) + *(a+44) * *(b+21) + *(a+47) * *(b+30) + *(a+46) * *(b+31) + *(a+49) * *(b+40) + *(a+48) * *(b+41);

			*(c+42) += *(a+42) * *(b+12) - *(a+43) * *(b+13) + *(a+40) * *(b+2) + *(a+44) * *(b+22) - *(a+45) * *(b+23) - *(a+41) * *(b+3) + *(a+46) * *(b+32) - *(a+47) * *(b+33) + *(a+48) * *(b+42) - *(a+49) * *(b+43);
			*(c+43) += *(a+43) * *(b+12) + *(a+42) * *(b+13) + *(a+41) * *(b+2) + *(a+45) * *(b+22) + *(a+44) * *(b+23) + *(a+40) * *(b+3) + *(a+47) * *(b+32) + *(a+46) * *(b+33) + *(a+49) * *(b+42) + *(a+48) * *(b+43);

			*(c+44) += *(a+42) * *(b+14) - *(a+43) * *(b+15) + *(a+44) * *(b+24) - *(a+45) * *(b+25) + *(a+46) * *(b+34) - *(a+47) * *(b+35) + *(a+40) * *(b+4) + *(a+48) * *(b+44) - *(a+49) * *(b+45) - *(a+41) * *(b+5);
			*(c+45) += *(a+43) * *(b+14) + *(a+42) * *(b+15) + *(a+45) * *(b+24) + *(a+44) * *(b+25) + *(a+47) * *(b+34) + *(a+46) * *(b+35) + *(a+41) * *(b+4) + *(a+49) * *(b+44) + *(a+48) * *(b+45) + *(a+40) * *(b+5);

			*(c+46) += *(a+42) * *(b+16) - *(a+43) * *(b+17) + *(a+44) * *(b+26) - *(a+45) * *(b+27) + *(a+46) * *(b+36) - *(a+47) * *(b+37) + *(a+48) * *(b+46) - *(a+49) * *(b+47) + *(a+40) * *(b+6) - *(a+41) * *(b+7);
			*(c+47) += *(a+43) * *(b+16) + *(a+42) * *(b+17) + *(a+45) * *(b+26) + *(a+44) * *(b+27) + *(a+47) * *(b+36) + *(a+46) * *(b+37) + *(a+49) * *(b+46) + *(a+48) * *(b+47) + *(a+41) * *(b+6) + *(a+40) * *(b+7);

			*(c+48) += *(a+42) * *(b+18) - *(a+43) * *(b+19) + *(a+44) * *(b+28) - *(a+45) * *(b+29) + *(a+46) * *(b+38) - *(a+47) * *(b+39) + *(a+48) * *(b+48) - *(a+49) * *(b+49) + *(a+40) * *(b+8) - *(a+41) * *(b+9);
			*(c+49) += *(a+43) * *(b+18) + *(a+42) * *(b+19) + *(a+45) * *(b+28) + *(a+44) * *(b+29) + *(a+47) * *(b+38) + *(a+46) * *(b+39) + *(a+49) * *(b+48) + *(a+48) * *(b+49) + *(a+41) * *(b+8) + *(a+40) * *(b+9);	

		
		}
	#endif
		
	#if (SUN>5)

		void GenMatMultAdd(double* c, const double* a, const double* b)
		{
			Complex *C = (Complex*)c;
			Complex *A = (Complex*)a;
			Complex *B = (Complex*)b;
			
			
			for( int i=0; i<SUN; i++){
				for( int j=0; j<SUN; j++){
			
					C[i*SUN+j]+=A[i*SUN+0]*B[0*SUN+j];
					
					for ( int k=1;k<SUN;k++) C[i*SUN+j]+=A[i*SUN+k]*B[k*SUN+j];
					
			}}

			
		}

	#endif	
	
	//---------------------------------------------------------------------------------------------
	//	MATRIX DAGGER
	//---------------------------------------------------------------------------------------------

	#if (SUN==2)
	
		void SetDagger(double *u, const double* a)
		{
			
			*(u+0)	= *(a+0);
			*(u+1)	= -*(a+1);

			*(u+2)	= *(a+4);
			*(u+3)	= -*(a+5);

			*(u+4)	= *(a+2);
			*(u+5)	= -*(a+3);

			*(u+6)	= *(a+6);
			*(u+7)	= -*(a+7);

		}
		
	#endif

	#if (SUN==3)
	
		void SetDagger(double *u, const double* a)
		{

			u[0]  = a[0];   u[1]  = -a[1];
			u[6]  = a[2];   u[7]  = -a[3];
			u[12] = a[4];   u[13] = -a[5];
			u[2]  = a[6];   u[3]  = -a[7];
			u[8]  = a[8];   u[9]  = -a[9];
			u[14] = a[10];  u[15] = -a[11];
			u[4]  = a[12];  u[5]  = -a[13];
			u[10] = a[14];  u[11] = -a[15];
			u[16] = a[16];  u[17] = -a[17];
			
		}
		
	#endif
	
	#if (SUN==4)
	
		void SetDagger(double *u, const double* a)
		{

			*(u+0)	= *(a+0);
			*(u+1)	= -*(a+1);

			*(u+2)	= *(a+8);
			*(u+3)	= -*(a+9);

			*(u+4)	= *(a+16);
			*(u+5)	= -*(a+17);

			*(u+6)	= *(a+24);
			*(u+7)	= -*(a+25);

			*(u+8)	= *(a+2);
			*(u+9)	= -*(a+3);

			*(u+10)	= *(a+10);
			*(u+11)	= -*(a+11);

			*(u+12)	= *(a+18);
			*(u+13)	= -*(a+19);

			*(u+14)	= *(a+26);
			*(u+15)	= -*(a+27);

			*(u+16)	= *(a+4);
			*(u+17)	= -*(a+5);

			*(u+18)	= *(a+12);
			*(u+19)	= -*(a+13);

			*(u+20)	= *(a+20);
			*(u+21)	= -*(a+21);

			*(u+22)	= *(a+28);
			*(u+23)	= -*(a+29);

			*(u+24)	= *(a+6);
			*(u+25)	= -*(a+7);

			*(u+26)	= *(a+14);
			*(u+27)	= -*(a+15);

			*(u+28)	= *(a+22);
			*(u+29)	= -*(a+23);

			*(u+30)	= *(a+30);
			*(u+31)	= -*(a+31);
		}
	#endif
	
	#if (SUN==5)
	
		void SetDagger(double *u, const double* a)
		{
			
			*(u+0)	= *(a+0);
			*(u+1)	= -*(a+1);

			*(u+2)	= *(a+10);
			*(u+3)	= -*(a+11);

			*(u+4)	= *(a+20);
			*(u+5)	= -*(a+21);

			*(u+6)	= *(a+30);
			*(u+7)	= -*(a+31);

			*(u+8)	= *(a+40);
			*(u+9)	= -*(a+41);

			*(u+10)	= *(a+2);
			*(u+11)	= -*(a+3);

			*(u+12)	= *(a+12);
			*(u+13)	= -*(a+13);

			*(u+14)	= *(a+22);
			*(u+15)	= -*(a+23);

			*(u+16)	= *(a+32);
			*(u+17)	= -*(a+33);

			*(u+18)	= *(a+42);
			*(u+19)	= -*(a+43);

			*(u+20)	= *(a+4);
			*(u+21)	= -*(a+5);

			*(u+22)	= *(a+14);
			*(u+23)	= -*(a+15);

			*(u+24)	= *(a+24);
			*(u+25)	= -*(a+25);

			*(u+26)	= *(a+34);
			*(u+27)	= -*(a+35);

			*(u+28)	= *(a+44);
			*(u+29)	= -*(a+45);

			*(u+30)	= *(a+6);
			*(u+31)	= -*(a+7);

			*(u+32)	= *(a+16);
			*(u+33)	= -*(a+17);

			*(u+34)	= *(a+26);
			*(u+35)	= -*(a+27);

			*(u+36)	= *(a+36);
			*(u+37)	= -*(a+37);

			*(u+38)	= *(a+46);
			*(u+39)	= -*(a+47);

			*(u+40)	= *(a+8);
			*(u+41)	= -*(a+9);

			*(u+42)	= *(a+18);
			*(u+43)	= -*(a+19);

			*(u+44)	= *(a+28);
			*(u+45)	= -*(a+29);

			*(u+46)	= *(a+38);
			*(u+47)	= -*(a+39);

			*(u+48)	= *(a+48);
			*(u+49)	= -*(a+49);

		}
	#endif
	
	#if (SUN>5)
	
		void SetDagger(double *u, const double* a)
		{

			for(int i=0;i<SUN;i++){
				for(int j=0;j<SUN;j++){
				
					u[2*(i*SUN+j)]=a[2*(j*SUN+i)];
					u[2*(i*SUN+j)+1]=-a[2*(j*SUN+i)+1];
					
			}}
			
		}
	#endif

	//---------------------------------------------------------------------------------------------
	//	MATRIX TRANSPOSE (double <-> double )
	//---------------------------------------------------------------------------------------------

	#if (SUN==2)
	
		void SetTranspose(double *u, const double* a)
		{
			
			*(u+0)	= *(a+0);
			*(u+1)	= *(a+1);

			*(u+2)	= *(a+4);
			*(u+3)	= *(a+5);

			*(u+4)	= *(a+2);
			*(u+5)	= *(a+3);

			*(u+6)	= *(a+6);
			*(u+7)	= *(a+7);

		}
		
	#endif

	#if (SUN==3)
	
		void SetTranspose(double *u, const double* a)
		{

			u[0]  = a[0];   u[1]  = a[1];
			u[6]  = a[2];   u[7]  = a[3];
			u[12] = a[4];   u[13] = a[5];
			u[2]  = a[6];   u[3]  = a[7];
			u[8]  = a[8];   u[9]  = a[9];
			u[14] = a[10];  u[15] = a[11];
			u[4]  = a[12];  u[5]  = a[13];
			u[10] = a[14];  u[11] = a[15];
			u[16] = a[16];  u[17] = a[17];
			
		}
		
	#endif
	
	#if (SUN==4)
	
		void SetTranspose(double *u, const double* a)
		{

			*(u+0)	= *(a+0);
			*(u+1)	= *(a+1);

			*(u+2)	= *(a+8);
			*(u+3)	= *(a+9);

			*(u+4)	= *(a+16);
			*(u+5)	= *(a+17);

			*(u+6)	= *(a+24);
			*(u+7)	= *(a+25);

			*(u+8)	= *(a+2);
			*(u+9)	= *(a+3);

			*(u+10)	= *(a+10);
			*(u+11)	= *(a+11);

			*(u+12)	= *(a+18);
			*(u+13)	= *(a+19);

			*(u+14)	= *(a+26);
			*(u+15)	= *(a+27);

			*(u+16)	= *(a+4);
			*(u+17)	= *(a+5);

			*(u+18)	= *(a+12);
			*(u+19)	= *(a+13);

			*(u+20)	= *(a+20);
			*(u+21)	= *(a+21);

			*(u+22)	= *(a+28);
			*(u+23)	= *(a+29);

			*(u+24)	= *(a+6);
			*(u+25)	= *(a+7);

			*(u+26)	= *(a+14);
			*(u+27)	= *(a+15);

			*(u+28)	= *(a+22);
			*(u+29)	= *(a+23);

			*(u+30)	= *(a+30);
			*(u+31)	= *(a+31);
		}
	#endif
	
	#if (SUN==5)
	
		void SetTranspose(double *u, const double* a)
		{
			
			*(u+0)	= *(a+0);
			*(u+1)	= *(a+1);

			*(u+2)	= *(a+10);
			*(u+3)	= *(a+11);

			*(u+4)	= *(a+20);
			*(u+5)	= *(a+21);

			*(u+6)	= *(a+30);
			*(u+7)	= *(a+31);

			*(u+8)	= *(a+40);
			*(u+9)	= *(a+41);

			*(u+10)	= *(a+2);
			*(u+11)	= *(a+3);

			*(u+12)	= *(a+12);
			*(u+13)	= *(a+13);

			*(u+14)	= *(a+22);
			*(u+15)	= *(a+23);

			*(u+16)	= *(a+32);
			*(u+17)	= *(a+33);

			*(u+18)	= *(a+42);
			*(u+19)	= *(a+43);

			*(u+20)	= *(a+4);
			*(u+21)	= *(a+5);

			*(u+22)	= *(a+14);
			*(u+23)	= *(a+15);

			*(u+24)	= *(a+24);
			*(u+25)	= *(a+25);

			*(u+26)	= *(a+34);
			*(u+27)	= *(a+35);

			*(u+28)	= *(a+44);
			*(u+29)	= *(a+45);

			*(u+30)	= *(a+6);
			*(u+31)	= *(a+7);

			*(u+32)	= *(a+16);
			*(u+33)	= *(a+17);

			*(u+34)	= *(a+26);
			*(u+35)	= *(a+27);

			*(u+36)	= *(a+36);
			*(u+37)	= *(a+37);

			*(u+38)	= *(a+46);
			*(u+39)	= *(a+47);

			*(u+40)	= *(a+8);
			*(u+41)	= *(a+9);

			*(u+42)	= *(a+18);
			*(u+43)	= *(a+19);

			*(u+44)	= *(a+28);
			*(u+45)	= *(a+29);

			*(u+46)	= *(a+38);
			*(u+47)	= *(a+39);

			*(u+48)	= *(a+48);
			*(u+49)	= *(a+49);

		}
	#endif
	
	#if (SUN>5)
	
		void SetTranspose(double *u, const double* a)
		{

			for(int i=0;i<SUN;i++){
				for(int j=0;j<SUN;j++){
				
					u[2*(i*SUN+j)]=a[2*(j*SUN+i)];
					u[2*(i*SUN+j)+1]=a[2*(j*SUN+i)+1];
					
			}}
			
		}
	#endif

	//---------------------------------------------------------------------------------------------
	//	MATRIX TRANSPOSE (long double <-> double )
	//---------------------------------------------------------------------------------------------

	#if (SUN==2)
	
		void SetTranspose(long double *u, const double* a)
		{
			
			*(u+0)	= *(a+0);
			*(u+1)	= *(a+1);

			*(u+2)	= *(a+4);
			*(u+3)	= *(a+5);

			*(u+4)	= *(a+2);
			*(u+5)	= *(a+3);

			*(u+6)	= *(a+6);
			*(u+7)	= *(a+7);

		}
		
	#endif

	#if (SUN==3)
	
		void SetTranspose(long double *u, const double* a)
		{

			u[0]  = a[0];   u[1]  = a[1];
			u[6]  = a[2];   u[7]  = a[3];
			u[12] = a[4];   u[13] = a[5];
			u[2]  = a[6];   u[3]  = a[7];
			u[8]  = a[8];   u[9]  = a[9];
			u[14] = a[10];  u[15] = a[11];
			u[4]  = a[12];  u[5]  = a[13];
			u[10] = a[14];  u[11] = a[15];
			u[16] = a[16];  u[17] = a[17];
			
		}
		
	#endif
	
	#if (SUN==4)
	
		void SetTranspose(long double *u, const double* a)
		{

			*(u+0)	= *(a+0);
			*(u+1)	= *(a+1);

			*(u+2)	= *(a+8);
			*(u+3)	= *(a+9);

			*(u+4)	= *(a+16);
			*(u+5)	= *(a+17);

			*(u+6)	= *(a+24);
			*(u+7)	= *(a+25);

			*(u+8)	= *(a+2);
			*(u+9)	= *(a+3);

			*(u+10)	= *(a+10);
			*(u+11)	= *(a+11);

			*(u+12)	= *(a+18);
			*(u+13)	= *(a+19);

			*(u+14)	= *(a+26);
			*(u+15)	= *(a+27);

			*(u+16)	= *(a+4);
			*(u+17)	= *(a+5);

			*(u+18)	= *(a+12);
			*(u+19)	= *(a+13);

			*(u+20)	= *(a+20);
			*(u+21)	= *(a+21);

			*(u+22)	= *(a+28);
			*(u+23)	= *(a+29);

			*(u+24)	= *(a+6);
			*(u+25)	= *(a+7);

			*(u+26)	= *(a+14);
			*(u+27)	= *(a+15);

			*(u+28)	= *(a+22);
			*(u+29)	= *(a+23);

			*(u+30)	= *(a+30);
			*(u+31)	= *(a+31);
		}
	#endif
	
	#if (SUN==5)
	
		void SetTranspose(long double *u, const double* a)
		{
			
			*(u+0)	= *(a+0);
			*(u+1)	= *(a+1);

			*(u+2)	= *(a+10);
			*(u+3)	= *(a+11);

			*(u+4)	= *(a+20);
			*(u+5)	= *(a+21);

			*(u+6)	= *(a+30);
			*(u+7)	= *(a+31);

			*(u+8)	= *(a+40);
			*(u+9)	= *(a+41);

			*(u+10)	= *(a+2);
			*(u+11)	= *(a+3);

			*(u+12)	= *(a+12);
			*(u+13)	= *(a+13);

			*(u+14)	= *(a+22);
			*(u+15)	= *(a+23);

			*(u+16)	= *(a+32);
			*(u+17)	= *(a+33);

			*(u+18)	= *(a+42);
			*(u+19)	= *(a+43);

			*(u+20)	= *(a+4);
			*(u+21)	= *(a+5);

			*(u+22)	= *(a+14);
			*(u+23)	= *(a+15);

			*(u+24)	= *(a+24);
			*(u+25)	= *(a+25);

			*(u+26)	= *(a+34);
			*(u+27)	= *(a+35);

			*(u+28)	= *(a+44);
			*(u+29)	= *(a+45);

			*(u+30)	= *(a+6);
			*(u+31)	= *(a+7);

			*(u+32)	= *(a+16);
			*(u+33)	= *(a+17);

			*(u+34)	= *(a+26);
			*(u+35)	= *(a+27);

			*(u+36)	= *(a+36);
			*(u+37)	= *(a+37);

			*(u+38)	= *(a+46);
			*(u+39)	= *(a+47);

			*(u+40)	= *(a+8);
			*(u+41)	= *(a+9);

			*(u+42)	= *(a+18);
			*(u+43)	= *(a+19);

			*(u+44)	= *(a+28);
			*(u+45)	= *(a+29);

			*(u+46)	= *(a+38);
			*(u+47)	= *(a+39);

			*(u+48)	= *(a+48);
			*(u+49)	= *(a+49);

		}
	#endif
	
	#if (SUN>5)
	
		void SetTranspose(long double *u, const double* a)
		{

			for(int i=0;i<SUN;i++){
				for(int j=0;j<SUN;j++){
				
					u[2*(i*SUN+j)]=a[2*(j*SUN+i)];
					u[2*(i*SUN+j)+1]=a[2*(j*SUN+i)+1];
					
			}}
			
		}
	#endif
	
	//---------------------------------------------------------------------------------------------
	//	MATRIX TRANSPOSE (double <-> long double )
	//---------------------------------------------------------------------------------------------
	#if (SUN==2)
	
		void SetTranspose(double *u, const long double* a)
		{
			
			*(u+0)	= *(a+0);
			*(u+1)	= *(a+1);

			*(u+2)	= *(a+4);
			*(u+3)	= *(a+5);

			*(u+4)	= *(a+2);
			*(u+5)	= *(a+3);

			*(u+6)	= *(a+6);
			*(u+7)	= *(a+7);

		}
		
	#endif

	#if (SUN==3)
	
		void SetTranspose(double *u, const long double* a)
		{

			u[0]  = a[0];   u[1]  = a[1];
			u[6]  = a[2];   u[7]  = a[3];
			u[12] = a[4];   u[13] = a[5];
			u[2]  = a[6];   u[3]  = a[7];
			u[8]  = a[8];   u[9]  = a[9];
			u[14] = a[10];  u[15] = a[11];
			u[4]  = a[12];  u[5]  = a[13];
			u[10] = a[14];  u[11] = a[15];
			u[16] = a[16];  u[17] = a[17];
			
		}
		
	#endif
	
	#if (SUN==4)
	
		void SetTranspose(double *u, const long double* a)
		{

			*(u+0)	= *(a+0);
			*(u+1)	= *(a+1);

			*(u+2)	= *(a+8);
			*(u+3)	= *(a+9);

			*(u+4)	= *(a+16);
			*(u+5)	= *(a+17);

			*(u+6)	= *(a+24);
			*(u+7)	= *(a+25);

			*(u+8)	= *(a+2);
			*(u+9)	= *(a+3);

			*(u+10)	= *(a+10);
			*(u+11)	= *(a+11);

			*(u+12)	= *(a+18);
			*(u+13)	= *(a+19);

			*(u+14)	= *(a+26);
			*(u+15)	= *(a+27);

			*(u+16)	= *(a+4);
			*(u+17)	= *(a+5);

			*(u+18)	= *(a+12);
			*(u+19)	= *(a+13);

			*(u+20)	= *(a+20);
			*(u+21)	= *(a+21);

			*(u+22)	= *(a+28);
			*(u+23)	= *(a+29);

			*(u+24)	= *(a+6);
			*(u+25)	= *(a+7);

			*(u+26)	= *(a+14);
			*(u+27)	= *(a+15);

			*(u+28)	= *(a+22);
			*(u+29)	= *(a+23);

			*(u+30)	= *(a+30);
			*(u+31)	= *(a+31);
		}
	#endif
	
	#if (SUN==5)
	
		void SetTranspose(double *u, const long double* a)
		{
			
			*(u+0)	= *(a+0);
			*(u+1)	= *(a+1);

			*(u+2)	= *(a+10);
			*(u+3)	= *(a+11);

			*(u+4)	= *(a+20);
			*(u+5)	= *(a+21);

			*(u+6)	= *(a+30);
			*(u+7)	= *(a+31);

			*(u+8)	= *(a+40);
			*(u+9)	= *(a+41);

			*(u+10)	= *(a+2);
			*(u+11)	= *(a+3);

			*(u+12)	= *(a+12);
			*(u+13)	= *(a+13);

			*(u+14)	= *(a+22);
			*(u+15)	= *(a+23);

			*(u+16)	= *(a+32);
			*(u+17)	= *(a+33);

			*(u+18)	= *(a+42);
			*(u+19)	= *(a+43);

			*(u+20)	= *(a+4);
			*(u+21)	= *(a+5);

			*(u+22)	= *(a+14);
			*(u+23)	= *(a+15);

			*(u+24)	= *(a+24);
			*(u+25)	= *(a+25);

			*(u+26)	= *(a+34);
			*(u+27)	= *(a+35);

			*(u+28)	= *(a+44);
			*(u+29)	= *(a+45);

			*(u+30)	= *(a+6);
			*(u+31)	= *(a+7);

			*(u+32)	= *(a+16);
			*(u+33)	= *(a+17);

			*(u+34)	= *(a+26);
			*(u+35)	= *(a+27);

			*(u+36)	= *(a+36);
			*(u+37)	= *(a+37);

			*(u+38)	= *(a+46);
			*(u+39)	= *(a+47);

			*(u+40)	= *(a+8);
			*(u+41)	= *(a+9);

			*(u+42)	= *(a+18);
			*(u+43)	= *(a+19);

			*(u+44)	= *(a+28);
			*(u+45)	= *(a+29);

			*(u+46)	= *(a+38);
			*(u+47)	= *(a+39);

			*(u+48)	= *(a+48);
			*(u+49)	= *(a+49);

		}
	#endif
	
	#if (SUN>5)
	
		void SetTranspose(double *u, const long double* a)
		{

			for(int i=0;i<SUN;i++){
				for(int j=0;j<SUN;j++){
				
					u[2*(i*SUN+j)]=a[2*(j*SUN+i)];
					u[2*(i*SUN+j)+1]=a[2*(j*SUN+i)+1];
					
			}}
			
		}
	#endif
	//---------------------------------------------------------------------------------------------
	//	MATRIX INVERSE FOR THE PSEUDO HEATBATH
	//---------------------------------------------------------------------------------------------

	void Mat2x2Invert(double *a)
	{
		
		double tmp[8];
		tmp[0]=a[0];
		tmp[1]=a[1];
		tmp[2]=a[2];
		tmp[3]=a[3];
		tmp[4]=a[4];
		tmp[5]=a[5];
		tmp[6]=a[6];
		tmp[7]=a[7];
		
		double detr = tmp[0]*tmp[6]-tmp[1]*tmp[7] - (tmp[4]*tmp[2]-tmp[5]*tmp[3]);
		double deti = tmp[1]*tmp[6]+tmp[0]*tmp[7] - (tmp[5]*tmp[2]+tmp[4]*tmp[3]);
		
		double norm2_a_1 = 1.0/(detr * detr + deti * deti);
		double sre = (1.0 * detr ) * norm2_a_1;
		
		double invdeti  = (- 1.0 * deti) * norm2_a_1;
		double invdetr = sre;

		a[0]=  ( invdetr*tmp[6]-invdeti*tmp[7] );
		a[1]=  ( invdeti*tmp[6]+invdetr*tmp[7] );

		a[2]= -( invdetr*tmp[2]-invdeti*tmp[3] );
		a[3]= -( invdeti*tmp[2]+invdetr*tmp[3] );

		a[4]= -( invdetr*tmp[4]-invdeti*tmp[5] );
		a[5]= -( invdeti*tmp[4]+invdetr*tmp[5] );

		a[6]=  ( invdetr*tmp[0]-invdeti*tmp[1] );
		a[7]=  ( invdeti*tmp[0]+invdetr*tmp[1] );		
		
	}


	void MatInvert(double *a)
	{
	
	#if (SUN==2)	
		
		double tmp[8];
		tmp[0]=a[0];
		tmp[1]=a[1];
		tmp[2]=a[2];
		tmp[3]=a[3];
		tmp[4]=a[4];
		tmp[5]=a[5];
		tmp[6]=a[6];
		tmp[7]=a[7];
		
		double detr = tmp[0]*tmp[6]-tmp[1]*tmp[7] - (tmp[4]*tmp[2]-tmp[5]*tmp[3]);
		double deti = tmp[1]*tmp[6]+tmp[0]*tmp[7] - (tmp[5]*tmp[2]+tmp[4]*tmp[3]);
		
		double norm2_a_1 = 1.0/(detr * detr + deti * deti);
		double sre = (1.0 * detr ) * norm2_a_1;
		
		double invdeti  = (- 1.0 * deti) * norm2_a_1;
		double invdetr = sre;

		a[0]=  ( invdetr*tmp[6]-invdeti*tmp[7] );
		a[1]=  ( invdeti*tmp[6]+invdetr*tmp[7] );

		a[2]= -( invdetr*tmp[2]-invdeti*tmp[3] );
		a[3]= -( invdeti*tmp[2]+invdetr*tmp[3] );

		a[4]= -( invdetr*tmp[4]-invdeti*tmp[5] );
		a[5]= -( invdeti*tmp[4]+invdetr*tmp[5] );

		a[6]=  ( invdetr*tmp[0]-invdeti*tmp[1] );
		a[7]=  ( invdeti*tmp[0]+invdetr*tmp[1] );		
		
	#endif
		
	#if (SUN==3)
	
		fprintf(stderr, "BUGGGGGYYYYY!!!!!\n"); exit(-1);
		
		double	scratch1[18];
		double	scratch2[18];
		double  mcopy[18];

		scratch1[0]=1.;
		scratch1[8]=1.;
		scratch1[16]=1.;
		scratch1[1]=0.;
		scratch1[2]=0.;
		scratch1[3]=0.;
		scratch1[4]=0.;
		scratch1[5]=0.;
		scratch1[6]=0.;
		scratch1[7]=0.;
		scratch1[9]=0.;
		scratch1[10]=0.;
		scratch1[11]=0.;
		scratch1[12]=0.;
		scratch1[13]=0.;
		scratch1[14]=0.;
		scratch1[15]=0.;
		scratch1[17]=0.;

		scratch2[0]=1.;
		scratch2[8]=1.;
		scratch2[16]=1.;
		scratch2[1]=0.;
		scratch2[2]=0.;
		scratch2[3]=0.;
		scratch2[4]=0.;
		scratch2[5]=0.;
		scratch2[6]=0.;
		scratch2[7]=0.;
		scratch2[9]=0.;
		scratch2[10]=0.;
		scratch2[11]=0.;
		scratch2[12]=0.;
		scratch2[13]=0.;
		scratch2[14]=0.;
		scratch2[15]=0.;
		scratch2[17]=0.;

		mcopy[0]=a[0];
		mcopy[1]=a[1];

		mcopy[2]=a[2];
		mcopy[3]=a[3];
		
		mcopy[4]=a[4];
		mcopy[5]=a[5];

		mcopy[6]=a[6];
		mcopy[7]=a[7];

		mcopy[8]=a[8];
		mcopy[9]=a[9];

		mcopy[10]=a[10];
		mcopy[11]=a[11];

		mcopy[12]=a[12];
		mcopy[13]=a[13];

		mcopy[14]=a[14];
		mcopy[15]=a[15];

		mcopy[16]=a[16];
		mcopy[17]=a[17];

		*(scratch1 + 0)  = (*(mcopy + 8) * *(mcopy + 16) -
				*(mcopy + 9)* *(mcopy + 17))
				- (*(mcopy + 10) * *(mcopy + 14) -
				*(mcopy + 11)* *(mcopy + 15));

		*(scratch1 + 1)  = (*(mcopy + 8) * *(mcopy + 17)+
				*(mcopy + 9)* *(mcopy + 16) )
				- (*(mcopy + 10) * *(mcopy + 15)+
				*(mcopy + 11)* *(mcopy + 14) );

		*(scratch1 + 2)  = (*(mcopy + 6) * *(mcopy + 16) -
				*(mcopy + 7)* *(mcopy + 17))
				- (*(mcopy + 10) * *(mcopy + 12) -
				*(mcopy + 11)* *(mcopy + 13));

		*(scratch1 + 3) = (*(mcopy + 6) * *(mcopy + 17)+
				*(mcopy + 7)* *(mcopy + 16) )
				- (*(mcopy + 10) * *(mcopy + 13)+
				*(mcopy + 11)* *(mcopy + 12) );

		*(scratch1 + 4)  = (*(mcopy + 6) * *(mcopy + 14) -
				*(mcopy + 7)* *(mcopy + 15))
				- (*(mcopy + 8) * *(mcopy + 12) -
				*(mcopy + 9)* *(mcopy + 13));

		*(scratch1 + 5) = (*(mcopy + 6) * *(mcopy + 15)+
				*(mcopy + 7)* *(mcopy + 14) )
				- (*(mcopy + 8) * *(mcopy + 13)+
				*(mcopy + 9)* *(mcopy + 12) );

		*(scratch1 + 6)  = (*(mcopy + 2) * *(mcopy + 16) -
				*(mcopy + 3)* *(mcopy + 17))
				- (*(mcopy + 4) * *(mcopy + 14) -
				*(mcopy + 5)* *(mcopy + 15));

		*(scratch1 + 7) = (*(mcopy + 2) * *(mcopy + 17)+
				*(mcopy + 3)* *(mcopy + 16) )
				- (*(mcopy + 4) * *(mcopy + 15)+
				*(mcopy + 5)* *(mcopy + 14) );

		*(scratch1 + 8)  = (*(mcopy + 0) * *(mcopy + 16) -
				*(mcopy + 1) * *(mcopy + 17))
				- (*(mcopy + 4) * *(mcopy + 12) -
				*(mcopy + 5)* *(mcopy + 13));

		*(scratch1 + 9) = (*(mcopy + 0) * *(mcopy + 17)+
				*(mcopy + 1) * *(mcopy + 16) )
				- (*(mcopy + 4) * *(mcopy + 13)+
				*(mcopy + 5)* *(mcopy + 12) );

		*(scratch1 + 10)  = (*(mcopy + 0) * *(mcopy + 14) -
				*(mcopy + 1) * *(mcopy + 15))
				- (*(mcopy + 2) * *(mcopy + 12) -
				*(mcopy + 3)* *(mcopy + 13));

		*(scratch1 + 11) = (*(mcopy + 0) * *(mcopy + 15)+
				*(mcopy + 1) * *(mcopy + 14) )
				- (*(mcopy + 2) * *(mcopy + 13)+
				*(mcopy + 3)* *(mcopy + 12) );

		*(scratch1 + 12)  = (*(mcopy + 2) * *(mcopy + 10) -
				*(mcopy + 3)* *(mcopy + 11))
				- (*(mcopy + 4) * *(mcopy + 8) -
				*(mcopy + 5)* *(mcopy + 9));

		*(scratch1 + 13) = (*(mcopy + 2) * *(mcopy + 11)+
				*(mcopy + 3)* *(mcopy + 10) )
				- (*(mcopy + 4) * *(mcopy + 9)+
				*(mcopy + 5)* *(mcopy + 8) );

		*(scratch1 + 14)  = (*(mcopy + 0) * *(mcopy + 10) -
				*(mcopy + 1) * *(mcopy + 11))
				- (*(mcopy + 4) * *(mcopy + 6) -
				*(mcopy + 5)* *(mcopy + 7));

		*(scratch1 + 15) = (*(mcopy + 0) * *(mcopy + 11)+
				*(mcopy + 1) * *(mcopy + 10) )
				- (*(mcopy + 4) * *(mcopy + 7)+
				*(mcopy + 5)* *(mcopy + 6) );

		*(scratch1 + 16)  = (*(mcopy + 0) * *(mcopy + 8) -
				*(mcopy + 1) * *(mcopy + 9))
				- (*(mcopy + 2) * *(mcopy + 6) -
				*(mcopy + 3)* *(mcopy + 7));

		*(scratch1 + 17) = (*(mcopy + 0) * *(mcopy + 9)+
				*(mcopy + 1) * *(mcopy + 8) )
				- (*(mcopy + 2) * *(mcopy + 7)+
				*(mcopy + 3)* *(mcopy + 6) );

		*(scratch1 + 2)  = - *(scratch1 + 2) ;
		*(scratch1 + 3) = - *(scratch1 + 3);
		*(scratch1 + 6)  = - *(scratch1 + 6) ;
		*(scratch1 + 7) = - *(scratch1 + 7);
		*(scratch1 + 10)  = - *(scratch1 + 10) ;
		*(scratch1 + 11) = - *(scratch1 + 11);
		*(scratch1 + 14)  = - *(scratch1 + 14) ;
		*(scratch1 + 15) = - *(scratch1 + 15);
		*(scratch2 + 0)  = *(scratch1 + 0) ;
		*(scratch2 + 1)  = *(scratch1 + 1) ;  
		*(scratch2 + 2)  = *(scratch1 + 6) ;
		*(scratch2 + 3) = *(scratch1 + 7);
		*(scratch2 + 4)  = *(scratch1 + 12) ;
		*(scratch2 + 5) = *(scratch1 + 13);  
		*(scratch2 + 6)  = *(scratch1 + 2) ;
		*(scratch2 + 7) = *(scratch1 + 3);  
		*(scratch2 + 8)  = *(scratch1 + 8) ;
		*(scratch2 + 9) = *(scratch1 + 9);  
		*(scratch2 + 10)  = *(scratch1 + 14) ;
		*(scratch2 + 11) = *(scratch1 + 15);  
		*(scratch2 + 12)  = *(scratch1 + 4) ;
		*(scratch2 + 13) = *(scratch1 + 5);  
		*(scratch2 + 14)  = *(scratch1 + 10) ;
		*(scratch2 + 15) = *(scratch1 + 11);  
		*(scratch2 + 16)  = *(scratch1 + 16) ;
		*(scratch2 + 17) = *(scratch1 + 17);  
		
		a[0]=scratch2[0];
		a[1]=scratch2[1];

		a[2]=scratch2[2];
		a[3]=scratch2[3];

		a[4]=scratch2[4];
		a[5]=scratch2[5];

		a[6]=scratch2[6];
		a[7]=scratch2[7];
		
		a[8]=scratch2[8];
		a[9]=scratch2[9];

		a[10]=scratch2[10];
		a[11]=scratch2[11];
		
		a[12]=scratch2[12];
		a[13]=scratch2[13];

		a[14]=scratch2[14];
		a[15]=scratch2[15];

		a[16]=scratch2[16];
		a[17]=scratch2[17];
			
	#endif
		
	#if (SUN>3)
	
		fprintf(stderr, "SORRY MATRIX INVERSION FOR SUN>3 NOT YET IMPLEMENTED\n");
	
// 		ap::complex_2d_array u;
// 		
// 		u.setlength(SUN, SUN);
// 
// 		for(int i=0;i<SUN;i++)
// 		for(int j=0;j<SUN;j++)
// 		{
// 			
// 			u(i,j).x=a[2*SUN*i+2*j];
// 			u(i,j).y=a[2*SUN*i+2*j+1];
// 			
// 		}
// 		
// 		int info;
// 		matinvreport rep;
// 		
// 		cmatrixinverse(u,SUN, info, rep);
// 
// 		if(info==-3) fprintf(stderr, "PRPBLEM WITH MATRIX INVERSION, PROBABLY SINGULAR\n");
// 
// 		for(int i=0;i<SUN;i++)
// 		for(int j=0;j<SUN;j++)
// 		{
// 			
// 			a[2*SUN*i+2*j]=u(i,j).x;
// 			a[2*SUN*i+2*j+1]=u(i,j).y;
// 			
// 		}

	#endif
	
	}


	void RandomSU(TLP_RANDGEN *LocGSLr, double* u);

	
	//---------------------------------------------------------------------------------------------
	//	RANDOM MATRICES GENERATION FROM SU2 SUBMATRIX AROUND 1 FOR METROPOLIS
	//---------------------------------------------------------------------------------------------

	void RandomSU_AROUND1(TLP_RANDGEN *LocGSLr, double* u)
	{
			for(int i=0; i<2*SUN*SUN;i++) u[i]=0.;
					
			double p1,p2,p3,p4;
			
			p1=(1.-2.*TLP_RAND_GEN_DOUBLE_UNIFORM (LocGSLr)); 
			p2=(1.-2.*TLP_RAND_GEN_DOUBLE_UNIFORM (LocGSLr));
			p3=(1.-2.*TLP_RAND_GEN_DOUBLE_UNIFORM (LocGSLr));
			p4=(1.-2.*TLP_RAND_GEN_DOUBLE_UNIFORM (LocGSLr));
		
			double normalize= sqrt( (1.0 - p1*p1) / (p2*p2 + p3*p3 + p4*p4) );

			p2 *= normalize; 
 			p3 *= normalize; 
			p4 *= normalize;

			
		#if (SUN==2)
		
			*(u+0)=p1; *(u+1)=p2;
			*(u+2)=-p3; *(u+3)=p4;
			*(u+4)=p3; *(u+5)=p4;
			*(u+6)=p1; *(u+7)=-p2;
		
		#endif	
		
		
		#if (SUN==3)
		
			double choice = TLP_RAND_GEN_DOUBLE_UNIFORM (LocGSLr);
			
			if ( choice < 0.33333333 ) {

				*(u+0)=p1; *(u+1)=p2;
				*(u+2)=-p3; *(u+3)=p4;
				*(u+6)=p3; *(u+7)=p4;
				*(u+8)=p1; *(u+9)=-p2;

				*(u+16)=1.;
				
			}else if ( choice > 0.66666666 ) {
				
				*(u+8)=p1; *(u+9)=p2;
				*(u+10)=-p3; *(u+11)=p4;
				*(u+14)=p3; *(u+15)=p4;
				*(u+16)=p1; *(u+17)=-p2;

				*(u+0)=1.;
				
			}else{
				
				*(u+0)=p1; *(u+1)=p2;
				*(u+4)=-p3; *(u+5)=p4;
				*(u+12)=p3; *(u+13)=p4;
				*(u+16)=p1; *(u+17)=-p2;

				*(u+8)=1.;
				
			}
			
		
		#endif	
		
		#if (SUN>3)
		
			for(int i=0; i<SUN;i++) u[2*SUN*i+2*i]=1.;
		
			int choice = (int) floor( TLP_RAND_GEN_DOUBLE_UNIFORM (LocGSLr)*SUN);
		
			int re00 = SUNSUBGRPTABLE[choice][0];
			int im00 = SUNSUBGRPTABLE[choice][1];
			int re01 = SUNSUBGRPTABLE[choice][2];
			int im01 = SUNSUBGRPTABLE[choice][3];
			int re10 = SUNSUBGRPTABLE[choice][4];
			int im10 = SUNSUBGRPTABLE[choice][5];
			int re11 = SUNSUBGRPTABLE[choice][6];
			int im11 = SUNSUBGRPTABLE[choice][7];
			
			*(u+re00)=p1;  *(u+im00)=p2;
			*(u+re01)=-p3; *(u+im01)=p4;
			*(u+re10)=p3;  *(u+im10)=p4;
			*(u+re11)=p1;  *(u+im11)=-p2;
		
		#endif
	
	}	

	void RandomSU_AROUND1_SYM(TLP_RANDGEN *LocGSLr, double* u)
	{
			for(int i=0; i<2*SUN*SUN;i++) u[i]=0.;
					
			double p1,p2,p3,p4;
			
			p1=(1.-2.*TLP_RAND_GEN_DOUBLE_UNIFORM (LocGSLr)); 
			p2=(1.-2.*TLP_RAND_GEN_DOUBLE_UNIFORM (LocGSLr));
			p3=(1.-2.*TLP_RAND_GEN_DOUBLE_UNIFORM (LocGSLr));
			p4=(1.-2.*TLP_RAND_GEN_DOUBLE_UNIFORM (LocGSLr));
		
			double normalize= sqrt( (1.0 - p1*p1) / (p2*p2 + p3*p3 + p4*p4) );

			p2 *= normalize; 
 			p3 *= normalize; 
			p4 *= normalize;

			
		#if (SUN==2)
		
			double choice = TLP_RAND_GEN_DOUBLE_UNIFORM (LocGSLr);
			
			if ( choice < 0.5 ) {
			
				*(u+0)=p1; *(u+1)=p2;
				*(u+2)=-p3; *(u+3)=p4;
				*(u+4)=p3; *(u+5)=p4;
				*(u+6)=p1; *(u+7)=-p2;
			
			} else{
				
				*(u+0)=p1; *(u+1)=-p2;
				*(u+4)=-p3; *(u+5)=-p4;
				*(u+2)=p3; *(u+3)=-p4;
				*(u+6)=p1; *(u+7)=p2;
				
			}
		
		#endif	
		
		
		#if (SUN==3)
		
			double choice = TLP_RAND_GEN_DOUBLE_UNIFORM (LocGSLr);
			
			if ( choice < 0.33333333 ) {

				double choice2 = TLP_RAND_GEN_DOUBLE_UNIFORM (LocGSLr);
				
				if(choice2<0.5){
					
					*(u+0)=p1; *(u+1)=p2;
					*(u+2)=-p3; *(u+3)=p4;
					*(u+6)=p3; *(u+7)=p4;
					*(u+8)=p1; *(u+9)=-p2;

				}else{
					
					*(u+0)=p1; *(u+1)=-p2;
					*(u+6)=-p3; *(u+7)=-p4;
					*(u+2)=p3; *(u+3)=-p4;
					*(u+8)=p1; *(u+9)=p2;
					
				}
			
				
				*(u+16)=1.;
				
			}else if ( choice > 0.66666666 ) {
				
				double choice2 = TLP_RAND_GEN_DOUBLE_UNIFORM (LocGSLr);
				
				if(choice2<0.5){
					
					*(u+8)=p1; *(u+9)=p2;
					*(u+10)=-p3; *(u+11)=p4;
					*(u+14)=p3; *(u+15)=p4;
					*(u+16)=p1; *(u+17)=-p2;
				
				}else{
					
					*(u+8)=p1; *(u+9)=-p2;
					*(u+14)=-p3; *(u+15)=-p4;
					*(u+10)=p3; *(u+11)=-p4;
					*(u+16)=p1; *(u+17)=p2;

				}
				
				*(u+0)=1.;
				
			}else{
				
				double choice2 = TLP_RAND_GEN_DOUBLE_UNIFORM (LocGSLr);
				
				if(choice2<0.5){
					
					*(u+0)=p1; *(u+1)=p2;
					*(u+4)=-p3; *(u+5)=p4;
					*(u+12)=p3; *(u+13)=p4;
					*(u+16)=p1; *(u+17)=-p2;

				}else{
				
					*(u+0)=p1; *(u+1)=-p2;
					*(u+12)=-p3; *(u+13)=-p4;
					*(u+4)=p3; *(u+5)=-p4;
					*(u+16)=p1; *(u+17)=p2;

				}
				
				*(u+8)=1.;
				
			}
			
		
		#endif	
		
		#if (SUN>3)
		
			for(int i=0; i<SUN;i++) u[2*SUN*i+2*i]=1.;
		
			int choice = (int) floor( TLP_RAND_GEN_DOUBLE_UNIFORM (LocGSLr)*SUN);
		
			int re00 = SUNSUBGRPTABLE[choice][0];
			int im00 = SUNSUBGRPTABLE[choice][1];
			int re01 = SUNSUBGRPTABLE[choice][2];
			int im01 = SUNSUBGRPTABLE[choice][3];
			int re10 = SUNSUBGRPTABLE[choice][4];
			int im10 = SUNSUBGRPTABLE[choice][5];
			int re11 = SUNSUBGRPTABLE[choice][6];
			int im11 = SUNSUBGRPTABLE[choice][7];
			
			double choice2 = TLP_RAND_GEN_DOUBLE_UNIFORM (LocGSLr);
			
			if(choice2<0.5){
				
				*(u+re00)=p1;  *(u+im00)=p2;
				*(u+re01)=-p3; *(u+im01)=p4;
				*(u+re10)=p3;  *(u+im10)=p4;
				*(u+re11)=p1;  *(u+im11)=-p2;
			}else{
				*(u+re00)=p1;  *(u+im00)=-p2;
				*(u+re10)=-p3; *(u+im10)=-p4;
				*(u+re01)=p3;  *(u+im01)=-p4;
				*(u+re11)=p1;  *(u+im11)=p2;
			}
	
		#endif
	
	}	

	void ReSUN(double *u);
		
/*	void RandomSLC()
	{
		
		
	}
	
	void RandomU()
	{
		
		
		
	}*/
		
	//---------------------------------------------------------------------------------------------
	//	DETERMINANT FOR THE SUN MATRICES                                        
	//---------------------------------------------------------------------------------------------

	#if (SUN==2)
	
	Complex Determinant(double *a)
	{
		Complex Det;
		
		Det.real( -( *(a+2) * *(a+4)) + *(a+3) * *(a+5) + *(a+0) * *(a+6) - *(a+1) * *(a+7)  );
		Det.imag( -( *(a+3) * *(a+4))- *(a+2) * *(a+5) + *(a+1) * *(a+6) + *(a+0) * *(a+7)  );

		return Det;
	}
	#endif
	
	#if (SUN==3)
	
	Complex Determinant(double *a)
	{
		
		double re,im;
		Complex Det;
		
		re= *(a+10)**(a+12)**(a+2) - *(a+11)**(a+13)**(a+2) - *(a+11)**(a+12)**(a+3) - *(a+10)**(a+13)**(a+3) - 
		*(a+16)**(a+2)**(a+6) + *(a+17)**(a+3)**(a+6) + *(a+14)**(a+4)**(a+6) - *(a+15)**(a+5)**(a+6) + 
		*(a+17)**(a+2)**(a+7) + *(a+16)**(a+3)**(a+7) - *(a+15)**(a+4)**(a+7) - *(a+14)**(a+5)**(a+7) - 
		*(a+12)**(a+4)**(a+8) + *(a+13)**(a+5)**(a+8) + *(a+13)**(a+4)**(a+9) + *(a+12)**(a+5)**(a+9) + 
		*(a+1)*(*(a+11)**(a+14) + *(a+10)**(a+15) - *(a+17)**(a+8) - *(a+16)**(a+9) ) + 
		*(a+0)*(-(*(a+10)**(a+14)) + *(a+11)**(a+15) + *(a+16)**(a+8) - *(a+17)**(a+9));
		
		im=*(a+11)**(a+12)**(a+2) + *(a+10)**(a+13)**(a+2) + *(a+10)**(a+12)**(a+3) - *(a+11)**(a+13)**(a+3) - 
		*(a+17)**(a+2)**(a+6) - *(a+16)**(a+3)**(a+6) + *(a+15)**(a+4)**(a+6) + *(a+14)**(a+5)**(a+6) - 
		*(a+16)**(a+2)**(a+7) + *(a+17)**(a+3)**(a+7) + *(a+14)**(a+4)**(a+7) - *(a+15)**(a+5)**(a+7) - 
		*(a+13)**(a+4)**(a+8) - *(a+12)**(a+5)**(a+8) - *(a+12)**(a+4)**(a+9) + *(a+13)**(a+5)**(a+9) + 
		*(a+0)*(-(*(a+11)**(a+14)) - *(a+10)**(a+15) + *(a+17)**(a+8) + *(a+16)**(a+9)) + 
		*(a+1)*(-(*(a+10)**(a+14)) + *(a+11)**(a+15) + *(a+16)**(a+8) - *(a+17)**(a+9));
		
		Det.real( re );
		Det.imag( im );

		return Det;
	}
	
	#endif
	
	
	#if (SUN>3)
	
	Complex Determinant(double *a)
	{
		#if (LAPACK==1)
		
		//Calculate the Matrix Determinant from the LU decomposition
		//such that A = PLU -> det(A) = det(P) det(L) det(U)
		//where the rows are permuted to give L_ii=1. Thus
		//det(A) = det(P) det(U) where det(P) is either 1 or -1
		//depending on the even or oddness of the permutations
		//used.
		
		//Transpose the current matrix data for Fortran LAPACK
		
		double tmp[2*SUN*SUN];
		
		for(int i=0;i<SUN;i++){
		  for(int j=0;j<SUN;j++){
			
			tmp[2*(i*SUN+j)]=a[2*(j*SUN+i)];
			tmp[2*(i*SUN+j)+1]=a[2*(j*SUN+i)+1];
			
			
		}}
		
		//Prepare and execute the LU Decomposition             
		
		int M=SUN;
		int* pivot;
		int INFO;
		pivot=new int [SUN];

		zgetrf_( &M, &N, tmp, &M, pivot, &INFO);
	
		//Determine the sign of the determinant for the permutation matrix
		
		int pivcnt=0;
		
		for(int i=0;i<SUN;i++) if( pivot[i]!= i ) pivcnt++;
		
		double pivsign= ((pivcnt%2==0)?1.:-1.);
		
		//Multiply the diagonal elements of the U matrix                   
		
		Complex Det;
		Det=1.;
		
		for(int i=0;i<SUN;i++){
			
			Complex ctmp;
			
			ctmp.real(tmp[2*(i*SUN+i)]);
			ctmp.imag(tmp[2*(i*SUN+i)+1]);
						
			Det*=ctmp;
			
		}
		
		Det*=pivsign;
	
		#else
		
		fprintf(stderr, "PLEASE ENABLE LAPACK FOR THE GENERAL DETERMINANT SUN>3 TO WORK!\n"); exit(-1);
		
		#endif

		
	}
	#endif


	
	//---------------------------------------------------------------------------------------------
	//	MATRIX DATATYPE
	//---------------------------------------------------------------------------------------------
	
	class ComplGenMat{
	
		private:
	
		double u[2*SUN*SUN];
	
		public:
	
		// Generic Constructor
		ComplGenMat(){
			
			for(int i=0;i<2*SUN*SUN;i++) u[i]=0.;
		}

		// Read Access
		const Complex& operator()(int i, int j) const
		{ return ((Complex*)u)[i*SUN+j]; }
	
		const Complex& operator()(int i) const
		{ return ((Complex*)u)[i]; }
	
		const double& operator[](int i) const
		{ return ( ((double*)u)[i]); }
	
		// Write Access
		Complex& operator()(int i, int j)
		{ return ((Complex*)u)[i*SUN+j]; }
	
		Complex& operator()(int i)
		{ return ((Complex*)u)[i]; }
	
		double& operator[](int i)
		{ return ( ((double*)u)[i]); }
	
		//Matrix Assignments
	
		ComplGenMat& operator=(const double c)
		{
	
			for(int i=0;i<2*SUN*SUN;i++) u[i]=0.;
	
			for(int i=0;i<SUN;i++) u[2*(SUN*i+i)]=c;
	
			return *this; 
		}
	
		ComplGenMat& operator=(const Complex& c)
		{
	
			for(int i=0;i<2*SUN*SUN;i++) u[i]=0.;
	
			for(int i=0;i<SUN;i++) ((Complex&)u[(SUN*i+i)])=c;
	
			return *this; 
		}
	
	
		ComplGenMat& operator=(const ComplGenMat* m)
		{ 
			for(int i=0;i<2*SUN*SUN;i++) u[i] = m->u[i];
		
			return *this; 
		}
	
	
		ComplGenMat& operator=(const ComplGenMat& m)
		{ 
			for(int i=0;i<2*SUN*SUN;i++) u[i] = m.u[i];
			
			return *this; 
		}
	
		ComplGenMat& operator=(const double* m)
		{ 
			for(int i=0;i<2*SUN*SUN;i++) u[i] = m[i];
		
			return *this; 
		}
			
		ComplGenMat& operator*=(const double m)
		{ 
			for(int i=0;i<2*SUN*SUN;i++) u[i] *= m;
		
			return *this; 
		}
		
		ComplGenMat& operator*=(const double *rhs)
		{ 
			ComplGenMat TMP; 

			TMP=*this; 

			GenMatMult((double *)u, (double *) TMP.u, rhs);

			return *this; 

		}
			
		ComplGenMat& operator*=(const Complex m)
		{ 
			const double rem=m.real();
			const double imm=m.imag();
			
			for(int i=0;i<SUN*SUN;i++){
			
				double tre,tim;
				
				tre= u[2*i]*rem-u[2*i+1]*imm;
				tim= u[2*i]*imm+u[2*i+1]*rem;
				
				u[2*i]= tre;
				u[2*i+1]=tim;
				
			}
		
			return *this; 
		}
			
		ComplGenMat& operator*=(const ComplGenMat* rhs)
		{ 
			ComplGenMat TMP; 

			TMP=*this; 

			GenMatMult((double *)u, (double *) TMP.u, (double *) rhs->u);

			return *this; 

		}
		
		ComplGenMat& operator*=(const ComplGenMat& rhs)
		{ 
			ComplGenMat TMP; 

			TMP=*this; 

			GenMatMult((double *)u, (double *) TMP.u, (double *) rhs.u);

			return *this; 

		}


		ComplGenMat& operator-=(const double *rhs)
		{ 
			for(int i=0; i<2*SUN*SUN; i++){
				u[i]-=rhs[i];
			}
			
			return *this; 

		}

		ComplGenMat& operator-=(const ComplGenMat& rhs)
		{ 
			for(int i=0; i<2*SUN*SUN; i++){
				u[i]-=rhs.u[i];
			}
			
			return *this; 

		}


		ComplGenMat& operator+=(const double *rhs)
		{ 
			for(int i=0; i<2*SUN*SUN; i++){
				u[i]+=rhs[i];
			}
			
			return *this; 

		}

		void LeftMult(const ComplGenMat& rhs)
		{ 
			ComplGenMat TMP; 

			TMP=*this; 

			GenMatMult((double *)u, (double *) rhs.u, (double *) TMP.u);

		}
				
		ComplGenMat& operator+=(const ComplGenMat& rhs)
		{ 
			
			for(int i=0;i<2*SUN*SUN;i++) u[i] += rhs.u[i];

			return *this; 

		}
		
// 		ComplGenMat& operator+=(const double& c)
// 		{ 
// 			
// 			for(int i=0;i<SUN;i++) u[2*(SUN*i+i)] += c;
// 
// 			return *this; 
// 
// 		}

		ComplGenMat& operator-=(const double& c)
		{ 
			
			for(int i=0;i<SUN;i++) u[2*(SUN*i+i)] -= c;

			return *this; 

		}

	   	
		ComplGenMat& operator/=(const double& rhs)
		{ 
			
			for(int i=0;i<2*SUN*SUN;i++) u[i] /= rhs;

			return *this; 

		}
		
#if (HPCOMPLEX==3||HPCOMPLEX==4)		
		ComplGenMat& operator/=(const ArbFloat& rhs)
		{ 
			
			for(int i=0;i<2*SUN*SUN;i++) u[i] /= rhs.dbl();

			return *this; 

		}
#endif

		void SetGeneratorFromLeft(int a, Matrix* in){
			
#if (SUN==3)		
		fprintf(stderr, "Not Yet DEBUGGED FOR SU3\n"); exit(-1);
		switch (a)
		{	

			case 0:
			u[0]=in->u[0]/2.;u[1]=in->u[1]/2.;
			u[2]=in->u[2]/2.;u[3]=in->u[3]/2.;
			u[4]=in->u[4]/2.;u[5]=in->u[5]/2.;
			u[6]=-in->u[6]/2.;u[7]=-in->u[7]/2.;
			u[8]=-in->u[8]/2.;u[9]=-in->u[9]/2.;
			u[10]=-in->u[10]/2.;u[11]=-in->u[11]/2.;
			u[12]=0;u[13]=0;
			u[14]=0;u[15]=0;
			u[16]=0;u[17]=0;
			break;
			case 1:
			u[0]=in->u[0]/(2.*sqrt(3.));u[1]=in->u[1]/(2.*sqrt(3.));
			u[2]=in->u[2]/(2.*sqrt(3.));u[3]=in->u[3]/(2.*sqrt(3.));
			u[4]=in->u[4]/(2.*sqrt(3.));u[5]=in->u[5]/(2.*sqrt(3.));
			u[6]=in->u[6]/(2.*sqrt(3.));u[7]=in->u[7]/(2.*sqrt(3.));
			u[8]=in->u[8]/(2.*sqrt(3.));u[9]=in->u[9]/(2.*sqrt(3.));
			u[10]=in->u[10]/(2.*sqrt(3.));u[11]=in->u[11]/(2.*sqrt(3.));
			u[12]=(-2*in->u[12])/(2.*sqrt(3.));u[13]=(-2*in->u[13])/(2.*sqrt(3.));
			u[14]=(-2*in->u[14])/(2.*sqrt(3.));u[15]=(-2*in->u[15])/(2.*sqrt(3.));
			u[16]=(-2*in->u[16])/(2.*sqrt(3.));u[17]=(-2*in->u[17])/(2.*sqrt(3.));
			break;
			case 2:
			u[0]=in->u[6]/2.;u[1]=in->u[7]/2.;
			u[2]=in->u[8]/2.;u[3]=in->u[9]/2.;
			u[4]=in->u[10]/2.;u[5]=in->u[11]/2.;
			u[6]=in->u[0]/2.;u[7]=in->u[1]/2.;
			u[8]=in->u[2]/2.;u[9]=in->u[3]/2.;
			u[10]=in->u[4]/2.;u[11]=in->u[5]/2.;
			u[12]=0;u[13]=0;
			u[14]=0;u[15]=0;
			u[16]=0;u[17]=0;
			break;
			case 3:
			u[0]=in->u[12]/2.;u[1]=in->u[13]/2.;
			u[2]=in->u[14]/2.;u[3]=in->u[15]/2.;
			u[4]=in->u[16]/2.;u[5]=in->u[17]/2.;
			u[6]=0;u[7]=0;
			u[8]=0;u[9]=0;
			u[10]=0;u[11]=0;
			u[12]=in->u[0]/2.;u[13]=in->u[1]/2.;
			u[14]=in->u[2]/2.;u[15]=in->u[3]/2.;
			u[16]=in->u[4]/2.;u[17]=in->u[5]/2.;
			break;
			case 4:
			u[0]=0;u[1]=0;
			u[2]=0;u[3]=0;
			u[4]=0;u[5]=0;
			u[6]=in->u[12]/2.;u[7]=in->u[13]/2.;
			u[8]=in->u[14]/2.;u[9]=in->u[15]/2.;
			u[10]=in->u[16]/2.;u[11]=in->u[17]/2.;
			u[12]=in->u[6]/2.;u[13]=in->u[7]/2.;
			u[14]=in->u[8]/2.;u[15]=in->u[9]/2.;
			u[16]=in->u[10]/2.;u[17]=in->u[11]/2.;
			break;
			case 5:
			u[0]=in->u[7]/2.;u[1]=-in->u[6]/2.;
			u[2]=in->u[9]/2.;u[3]=-in->u[8]/2.;
			u[4]=in->u[11]/2.;u[5]=-in->u[10]/2.;
			u[6]=-in->u[1]/2.;u[7]=in->u[0]/2.;
			u[8]=-in->u[3]/2.;u[9]=in->u[2]/2.;
			u[10]=-in->u[5]/2.;u[11]=in->u[4]/2.;
			u[12]=0;u[13]=0;
			u[14]=0;u[15]=0;
			u[16]=0;u[17]=0;
			break;
			case 6:
			u[0]=in->u[13]/2.;u[1]=-in->u[12]/2.;
			u[2]=in->u[15]/2.;u[3]=-in->u[14]/2.;
			u[4]=in->u[17]/2.;u[5]=-in->u[16]/2.;
			u[6]=0;u[7]=0;
			u[8]=0;u[9]=0;
			u[10]=0;u[11]=0;
			u[12]=-in->u[1]/2.;u[13]=in->u[0]/2.;
			u[14]=-in->u[3]/2.;u[15]=in->u[2]/2.;
			u[16]=-in->u[5]/2.;u[17]=in->u[4]/2.;
			break;
			case 7:
			u[0]=0;u[1]=0;
			u[2]=0;u[3]=0;
			u[4]=0;u[5]=0;
			u[6]=in->u[13]/2.;u[7]=-in->u[12]/2.;
			u[8]=in->u[15]/2.;u[9]=-in->u[14]/2.;
			u[10]=in->u[17]/2.;u[11]=-in->u[16]/2.;
			u[12]=-in->u[7]/2.;u[13]=in->u[6]/2.;
			u[14]=-in->u[9]/2.;u[15]=in->u[8]/2.;
			u[16]=-in->u[11]/2.;u[17]=in->u[10]/2.;
			break;
		}	
#elif (SUN==2)
		switch (a) 

		{
		
			case 0:
			u[0]=in->u[0]/2.;u[1]=in->u[1]/2.;
			u[2]=in->u[2]/2.;u[3]=in->u[3]/2.;
			u[4]=-in->u[4]/2.;u[5]=-in->u[5]/2.;
			u[6]=-in->u[6]/2.;u[7]=-in->u[7]/2.;
			break;
			case 1:
			u[0]=in->u[4]/2.;u[1]=in->u[5]/2.;
			u[2]=in->u[6]/2.;u[3]=in->u[7]/2.;
			u[4]=in->u[0]/2.;u[5]=in->u[1]/2.;
			u[6]=in->u[2]/2.;u[7]=in->u[3]/2.;
			break;
			case 2:
			u[0]=in->u[5]/2.;u[1]=-in->u[4]/2.;
			u[2]=in->u[7]/2.;u[3]=-in->u[6]/2.;
			u[4]=-in->u[1]/2.;u[5]=in->u[0]/2.;
			u[6]=-in->u[3]/2.;u[7]=in->u[2]/2.;	
			break;
		}

#endif
			
			
		}

		void SetGeneratorFromLeft(int a, double* in){
			
#if (SUN==3)		
		fprintf(stderr, "Not Yet DEBUGGED FOR SU3\n"); exit(-1);
		switch (a)
		{	
			
			case 0:
			u[0]=in[0]/2.;u[1]=in[1]/2.;
			u[2]=in[2]/2.;u[3]=in[3]/2.;
			u[4]=in[4]/2.;u[5]=in[5]/2.;
			u[6]=-in[6]/2.;u[7]=-in[7]/2.;
			u[8]=-in[8]/2.;u[9]=-in[9]/2.;
			u[10]=-in[10]/2.;u[11]=-in[11]/2.;
			u[12]=0;u[13]=0;
			u[14]=0;u[15]=0;
			u[16]=0;u[17]=0;
			break;
			case 1:
			u[0]=in[0]/(2.*sqrt(3.));u[1]=in[1]/(2.*sqrt(3.));
			u[2]=in[2]/(2.*sqrt(3.));u[3]=in[3]/(2.*sqrt(3.));
			u[4]=in[4]/(2.*sqrt(3.));u[5]=in[5]/(2.*sqrt(3.));
			u[6]=in[6]/(2.*sqrt(3.));u[7]=in[7]/(2.*sqrt(3.));
			u[8]=in[8]/(2.*sqrt(3.));u[9]=in[9]/(2.*sqrt(3.));
			u[10]=in[10]/(2.*sqrt(3.));u[11]=in[11]/(2.*sqrt(3.));
			u[12]=(-2*in[12])/(2.*sqrt(3.));u[13]=(-2*in[13])/(2.*sqrt(3.));
			u[14]=(-2*in[14])/(2.*sqrt(3.));u[15]=(-2*in[15])/(2.*sqrt(3.));
			u[16]=(-2*in[16])/(2.*sqrt(3.));u[17]=(-2*in[17])/(2.*sqrt(3.));
			break;
			case 2:
			u[0]=in[6]/2.;u[1]=in[7]/2.;
			u[2]=in[8]/2.;u[3]=in[9]/2.;
			u[4]=in[10]/2.;u[5]=in[11]/2.;
			u[6]=in[0]/2.;u[7]=in[1]/2.;
			u[8]=in[2]/2.;u[9]=in[3]/2.;
			u[10]=in[4]/2.;u[11]=in[5]/2.;
			u[12]=0;u[13]=0;
			u[14]=0;u[15]=0;
			u[16]=0;u[17]=0;
			break;
			case 3:
			u[0]=in[12]/2.;u[1]=in[13]/2.;
			u[2]=in[14]/2.;u[3]=in[15]/2.;
			u[4]=in[16]/2.;u[5]=in[17]/2.;
			u[6]=0;u[7]=0;
			u[8]=0;u[9]=0;
			u[10]=0;u[11]=0;
			u[12]=in[0]/2.;u[13]=in[1]/2.;
			u[14]=in[2]/2.;u[15]=in[3]/2.;
			u[16]=in[4]/2.;u[17]=in[5]/2.;
			break;
			case 4:
			u[0]=0;u[1]=0;
			u[2]=0;u[3]=0;
			u[4]=0;u[5]=0;
			u[6]=in[12]/2.;u[7]=in[13]/2.;
			u[8]=in[14]/2.;u[9]=in[15]/2.;
			u[10]=in[16]/2.;u[11]=in[17]/2.;
			u[12]=in[6]/2.;u[13]=in[7]/2.;
			u[14]=in[8]/2.;u[15]=in[9]/2.;
			u[16]=in[10]/2.;u[17]=in[11]/2.;
			break;
			case 5:
			u[0]=in[7]/2.;u[1]=-in[6]/2.;
			u[2]=in[9]/2.;u[3]=-in[8]/2.;
			u[4]=in[11]/2.;u[5]=-in[10]/2.;
			u[6]=-in[1]/2.;u[7]=in[0]/2.;
			u[8]=-in[3]/2.;u[9]=in[2]/2.;
			u[10]=-in[5]/2.;u[11]=in[4]/2.;
			u[12]=0;u[13]=0;
			u[14]=0;u[15]=0;
			u[16]=0;u[17]=0;
			break;
			case 6:
			u[0]=in[13]/2.;u[1]=-in[12]/2.;
			u[2]=in[15]/2.;u[3]=-in[14]/2.;
			u[4]=in[17]/2.;u[5]=-in[16]/2.;
			u[6]=0;u[7]=0;
			u[8]=0;u[9]=0;
			u[10]=0;u[11]=0;
			u[12]=-in[1]/2.;u[13]=in[0]/2.;
			u[14]=-in[3]/2.;u[15]=in[2]/2.;
			u[16]=-in[5]/2.;u[17]=in[4]/2.;
			break;
			case 7:
			u[0]=0;u[1]=0;
			u[2]=0;u[3]=0;
			u[4]=0;u[5]=0;
			u[6]=in[13]/2.;u[7]=-in[12]/2.;
			u[8]=in[15]/2.;u[9]=-in[14]/2.;
			u[10]=in[17]/2.;u[11]=-in[16]/2.;
			u[12]=-in[7]/2.;u[13]=in[6]/2.;
			u[14]=-in[9]/2.;u[15]=in[8]/2.;
			u[16]=-in[11]/2.;u[17]=in[10]/2.;
			break;			
		}	
#elif (SUN==2)
		switch (a) 

		{
			case 0:
			u[0]=in[0]/2.;u[1]=in[1]/2.;
			u[2]=in[2]/2.;u[3]=in[3]/2.;
			u[4]=-in[4]/2.;u[5]=-in[5]/2.;
			u[6]=-in[6]/2.;u[7]=-in[7]/2.;
			break;
			case 1:
			u[0]=in[4]/2.;u[1]=in[5]/2.;
			u[2]=in[6]/2.;u[3]=in[7]/2.;
			u[4]=in[0]/2.;u[5]=in[1]/2.;
			u[6]=in[2]/2.;u[7]=in[3]/2.;
			break;
			case 2:
			u[0]=in[5]/2.;u[1]=-in[4]/2.;
			u[2]=in[7]/2.;u[3]=-in[6]/2.;
			u[4]=-in[1]/2.;u[5]=in[0]/2.;
			u[6]=-in[3]/2.;u[7]=in[2]/2.;		
			break;
			
		}

#endif
			
			
		}
		
		void GeneratorFromLeft(int a)
		{
			
		Matrix out;
		
#if (SUN==3)		
		fprintf(stderr, "Not Yet DEBUGGED FOR SU3\n"); exit(-1);
		switch (a)
		{	
			
			case 0:
			out[0]=u[0]/2.;out[1]=u[1]/2.;
			out[2]=u[2]/2.;out[3]=u[3]/2.;
			out[4]=u[4]/2.;out[5]=u[5]/2.;
			out[6]=-u[6]/2.;out[7]=-u[7]/2.;
			out[8]=-u[8]/2.;out[9]=-u[9]/2.;
			out[10]=-u[10]/2.;out[11]=-u[11]/2.;
			out[12]=0;out[13]=0;
			out[14]=0;out[15]=0;
			out[16]=0;out[17]=0;
			break;
			case 1:
			out[0]=u[0]/(2.*sqrt(3.));out[1]=u[1]/(2.*sqrt(3.));
			out[2]=u[2]/(2.*sqrt(3.));out[3]=u[3]/(2.*sqrt(3.));
			out[4]=u[4]/(2.*sqrt(3.));out[5]=u[5]/(2.*sqrt(3.));
			out[6]=u[6]/(2.*sqrt(3.));out[7]=u[7]/(2.*sqrt(3.));
			out[8]=u[8]/(2.*sqrt(3.));out[9]=u[9]/(2.*sqrt(3.));
			out[10]=u[10]/(2.*sqrt(3.));out[11]=u[11]/(2.*sqrt(3.));
			out[12]=(-2*u[12])/(2.*sqrt(3.));out[13]=(-2*u[13])/(2.*sqrt(3.));
			out[14]=(-2*u[14])/(2.*sqrt(3.));out[15]=(-2*u[15])/(2.*sqrt(3.));
			out[16]=(-2*u[16])/(2.*sqrt(3.));out[17]=(-2*u[17])/(2.*sqrt(3.));
			break;
			case 2:
			out[0]=u[6]/2.;out[1]=u[7]/2.;
			out[2]=u[8]/2.;out[3]=u[9]/2.;
			out[4]=u[10]/2.;out[5]=u[11]/2.;
			out[6]=u[0]/2.;out[7]=u[1]/2.;
			out[8]=u[2]/2.;out[9]=u[3]/2.;
			out[10]=u[4]/2.;out[11]=u[5]/2.;
			out[12]=0;out[13]=0;
			out[14]=0;out[15]=0;
			out[16]=0;out[17]=0;
			break;
			case 3:
			out[0]=u[12]/2.;out[1]=u[13]/2.;
			out[2]=u[14]/2.;out[3]=u[15]/2.;
			out[4]=u[16]/2.;out[5]=u[17]/2.;
			out[6]=0;out[7]=0;
			out[8]=0;out[9]=0;
			out[10]=0;out[11]=0;
			out[12]=u[0]/2.;out[13]=u[1]/2.;
			out[14]=u[2]/2.;out[15]=u[3]/2.;
			out[16]=u[4]/2.;out[17]=u[5]/2.;
			break;
			case 4:
			out[0]=0;out[1]=0;
			out[2]=0;out[3]=0;
			out[4]=0;out[5]=0;
			out[6]=u[12]/2.;out[7]=u[13]/2.;
			out[8]=u[14]/2.;out[9]=u[15]/2.;
			out[10]=u[16]/2.;out[11]=u[17]/2.;
			out[12]=u[6]/2.;out[13]=u[7]/2.;
			out[14]=u[8]/2.;out[15]=u[9]/2.;
			out[16]=u[10]/2.;out[17]=u[11]/2.;
			break;
			case 5:
			out[0]=u[7]/2.;out[1]=-u[6]/2.;
			out[2]=u[9]/2.;out[3]=-u[8]/2.;
			out[4]=u[11]/2.;out[5]=-u[10]/2.;
			out[6]=-u[1]/2.;out[7]=u[0]/2.;
			out[8]=-u[3]/2.;out[9]=u[2]/2.;
			out[10]=-u[5]/2.;out[11]=u[4]/2.;
			out[12]=0;out[13]=0;
			out[14]=0;out[15]=0;
			out[16]=0;out[17]=0;
			break;
			case 6:
			out[0]=u[13]/2.;out[1]=-u[12]/2.;
			out[2]=u[15]/2.;out[3]=-u[14]/2.;
			out[4]=u[17]/2.;out[5]=-u[16]/2.;
			out[6]=0;out[7]=0;
			out[8]=0;out[9]=0;
			out[10]=0;out[11]=0;
			out[12]=-u[1]/2.;out[13]=u[0]/2.;
			out[14]=-u[3]/2.;out[15]=u[2]/2.;
			out[16]=-u[5]/2.;out[17]=u[4]/2.;
			break;
			case 7:
			out[0]=0;out[1]=0;
			out[2]=0;out[3]=0;
			out[4]=0;out[5]=0;
			out[6]=u[13]/2.;out[7]=-u[12]/2.;
			out[8]=u[15]/2.;out[9]=-u[14]/2.;
			out[10]=u[17]/2.;out[11]=-u[16]/2.;
			out[12]=-u[7]/2.;out[13]=u[6]/2.;
			out[14]=-u[9]/2.;out[15]=u[8]/2.;
			out[16]=-u[11]/2.;out[17]=u[10]/2.;
			break;	
			
		}	
#elif (SUN==2)
		switch (a) 

		{
		
			case 0:
			out[0]=u[0]/2.;out[1]=u[1]/2.;
			out[2]=u[2]/2.;out[3]=u[3]/2.;
			out[4]=-u[4]/2.;out[5]=-u[5]/2.;
			out[6]=-u[6]/2.;out[7]=-u[7]/2.;
			break;
			case 1:
			out[0]=u[4]/2.;out[1]=u[5]/2.;
			out[2]=u[6]/2.;out[3]=u[7]/2.;
			out[4]=u[0]/2.;out[5]=u[1]/2.;
			out[6]=u[2]/2.;out[7]=u[3]/2.;
			break;
			case 2:
			out[0]=u[5]/2.;out[1]=-u[4]/2.;
			out[2]=u[7]/2.;out[3]=-u[6]/2.;
			out[4]=-u[1]/2.;out[5]=u[0]/2.;
			out[6]=-u[3]/2.;out[7]=u[2]/2.;
			break;
		}

#endif

		for(int i=0;i<2*SUN*SUN;i++) u[i]=out[i];
			
		}

		void GeneratorFromRight(int a)
		{
			
		Matrix out;
		
#if (SUN==3)		
		fprintf(stderr, "Not Yet DEBUGGED FOR SU3\n"); exit(-1);
		switch (a)
		{	
			
			case 0:
			out[0]=u[0]/2.;out[1]=u[1]/2.;
			out[2]=-u[2]/2.;out[3]=-u[3]/2.;
			out[4]=0;out[5]=0;
			out[6]=u[6]/2.;out[7]=u[7]/2.;
			out[8]=-u[8]/2.;out[9]=-u[9]/2.;
			out[10]=0;out[11]=0;
			out[12]=u[12]/2.;out[13]=u[13]/2.;
			out[14]=-u[14]/2.;out[15]=-u[15]/2.;
			out[16]=0;out[17]=0;
			break;
			case 1:
			out[0]=u[0]/(2.*sqrt(3.));out[1]=u[1]/(2.*sqrt(3.));
			out[2]=u[2]/(2.*sqrt(3.));out[3]=u[3]/(2.*sqrt(3.));
			out[4]=(-2*u[4])/(2.*sqrt(3.));out[5]=(-2*u[5])/(2.*sqrt(3.));
			out[6]=u[6]/(2.*sqrt(3.));out[7]=u[7]/(2.*sqrt(3.));
			out[8]=u[8]/(2.*sqrt(3.));out[9]=u[9]/(2.*sqrt(3.));
			out[10]=(-2*u[10])/(2.*sqrt(3.));out[11]=(-2*u[11])/(2.*sqrt(3.));
			out[12]=u[12]/(2.*sqrt(3.));out[13]=u[13]/(2.*sqrt(3.));
			out[14]=u[14]/(2.*sqrt(3.));out[15]=u[15]/(2.*sqrt(3.));
			out[16]=(-2.*u[16])/(2.*sqrt(3.));out[17]=(-2.*u[17])/(2.*sqrt(3.));
			break;
			case 2:
			out[0]=u[2]/2.;out[1]=u[3]/2.;
			out[2]=u[0]/2.;out[3]=u[1]/2.;
			out[4]=0;out[5]=0;
			out[6]=u[8]/2.;out[7]=u[9]/2.;
			out[8]=u[6]/2.;out[9]=u[7]/2.;
			out[10]=0;out[11]=0;
			out[12]=u[14]/2.;out[13]=u[15]/2.;
			out[14]=u[12]/2.;out[15]=u[13]/2.;
			out[16]=0;out[17]=0;
			break;
			case 3:
			out[0]=u[4]/2.;out[1]=u[5]/2.;
			out[2]=0;out[3]=0;
			out[4]=u[0]/2.;out[5]=u[1]/2.;
			out[6]=u[10]/2.;out[7]=u[11]/2.;
			out[8]=0;out[9]=0;
			out[10]=u[6]/2.;out[11]=u[7]/2.;
			out[12]=u[16]/2.;out[13]=u[17]/2.;
			out[14]=0;out[15]=0;
			out[16]=u[12]/2.;out[17]=u[13]/2.;
			break;
			case 4:
			out[0]=0;out[1]=0;
			out[2]=u[4]/2.;out[3]=u[5]/2.;
			out[4]=u[2]/2.;out[5]=u[3]/2.;
			out[6]=0;out[7]=0;
			out[8]=u[10]/2.;out[9]=u[11]/2.;
			out[10]=u[8]/2.;out[11]=u[9]/2.;
			out[12]=0;out[13]=0;
			out[14]=u[16]/2.;out[15]=u[17]/2.;
			out[16]=u[14]/2.;out[17]=u[15]/2.;
			break;
			case 5:
			out[0]=-u[3]/2.;out[1]=u[2]/2.;
			out[2]=u[1]/2.;out[3]=-u[0]/2.;
			out[4]=0;out[5]=0;
			out[6]=-u[9]/2.;out[7]=u[8]/2.;
			out[8]=u[7]/2.;out[9]=-u[6]/2.;
			out[10]=0;out[11]=0;
			out[12]=-u[15]/2.;out[13]=u[14]/2.;
			out[14]=u[13]/2.;out[15]=-u[12]/2.;
			out[16]=0;out[17]=0;
			break;
			case 6:
			out[0]=-u[5]/2.;out[1]=u[4]/2.;
			out[2]=0;out[3]=0;
			out[4]=u[1]/2.;out[5]=-u[0]/2.;
			out[6]=-u[11]/2.;out[7]=u[10]/2.;
			out[8]=0;out[9]=0;
			out[10]=u[7]/2.;out[11]=-u[6]/2.;
			out[12]=-u[17]/2.;out[13]=u[16]/2.;
			out[14]=0;out[15]=0;
			out[16]=u[13]/2.;out[17]=-u[12]/2.;
			break;
			case 7:
			out[0]=0;out[1]=0;
			out[2]=-u[5]/2.;out[3]=u[4]/2.;
			out[4]=u[3]/2.;out[5]=-u[2]/2.;
			out[6]=0;out[7]=0;
			out[8]=-u[11]/2.;out[9]=u[10]/2.;
			out[10]=u[9]/2.;out[11]=-u[8]/2.;
			out[12]=0;out[13]=0;
			out[14]=-u[17]/2.;out[15]=u[16]/2.;
			out[16]=u[15]/2.;out[17]=-u[14]/2.;
			break;
		}	
#elif (SUN==2)
		switch (a) 

		{	

			case 0:
			out[0]=u[0]/2.;out[1]=u[1]/2.;
			out[2]=-u[2]/2.;out[3]=-u[3]/2.;
			out[4]=u[4]/2.;out[5]=u[5]/2.;
			out[6]=-u[6]/2.;out[7]=-u[7]/2.;
			break;
			case 1:
			out[0]=u[2]/2.;out[1]=u[3]/2.;
			out[2]=u[0]/2.;out[3]=u[1]/2.;
			out[4]=u[6]/2.;out[5]=u[7]/2.;
			out[6]=u[4]/2.;out[7]=u[5]/2.;
			break;
			case 2:
			out[0]=-u[3]/2.;out[1]=u[2]/2.;
			out[2]=u[1]/2.;out[3]=-u[0]/2.;
			out[4]=-u[7]/2.;out[5]=u[6]/2.;
			out[6]=u[5]/2.;out[7]=-u[4]/2.;
			break;			

		}

#endif

		for(int i=0;i<2*SUN*SUN;i++) u[i]=out[i];
			
		}

		void DotMEqual(const ComplGenMat& a, const ComplGenMat& b)
		{ 
			GenMatMult( (double *)u, (double *) a.u , (double *) b.u) ;	
		}
		//Matrix Operations
		
		void MatSVD( double *U, double *S, double *Vt);		
		void Exponential( const ComplGenMat& In);		
		void Exponential();		
		
		Complex Trace()
		{
			#if (SUN==2)	
			return ((Complex*)u)[0] + ((Complex*)u)[3];
			#endif

			#if (SUN==3)	
			return ((Complex*)u)[0] + ((Complex*)u)[4]+ ((Complex*)u)[8];
			#endif


			#if (SUN==4)	
			return ((Complex*)u)[0] + ((Complex*)u)[5]+ ((Complex*)u)[10]+ ((Complex*)u)[15];
			#endif


			#if (SUN==5)	
			return ((Complex*)u)[0] + ((Complex*)u)[6]+ ((Complex*)u)[12]+ ((Complex*)u)[18]+ ((Complex*)u)[24];
			#endif

			#if (SUN>5)	
			Complex tr=((Complex*)u)[0];
			for(int i=1;i<SUN;i++) tr+= ((Complex*)u)[SUN*i+i];
			return tr;
			#endif
			
		}
				
		double RealTrace()
		{
			#if (SUN==2)	
			return u[0] + u[6];
			#endif

			#if (SUN==3)	
			return u[0] + u[8]+ u[16];
			#endif


			#if (SUN==4)	
			return u[0] + u[10]+ u[20]+ u[30];
			#endif


			#if (SUN==5)	
			return u[0] + u[12]+ u[24]+ u[36]+ u[48];
			#endif

			#if (SUN>5)	
			double tr=u[0];
			for(int i=1;i<SUN;i++) tr+= u[2*SUN*i+2*i];
			return tr;
			#endif
			
		}
		
		void Traceless()
		{

			#if (SUN==2)
			Complex tracenth =  ( ((Complex*)u)[0] + ((Complex*)u)[3] ) / 2. ;
			((Complex*)u)[0]-=tracenth;
			((Complex*)u)[3]-=tracenth;
			#endif
			
			#if (SUN==3)
			Complex tracenth =  ( ((Complex*)u)[0] + ((Complex*)u)[4] + ((Complex*)u)[8] ) / 3. ;
			((Complex*)u)[0]-=tracenth;
			((Complex*)u)[4]-=tracenth;
			((Complex*)u)[8]-=tracenth;
			#endif
			
			#if (SUN==4)
			Complex tracenth =  ( ((Complex*)u)[0] + ((Complex*)u)[10] + ((Complex*)u)[20] + ((Complex*)u)[30] ) / 4. ;
			((Complex*)u)[0]-=tracenth;
			((Complex*)u)[10]-=tracenth;
			((Complex*)u)[20]-=tracenth;
			((Complex*)u)[30]-=tracenth;
			#endif
			

			#if (SUN==5)
			Complex tracenth =  ( ((Complex*)u)[0] + ((Complex*)u)[12] + ((Complex*)u)[24] + ((Complex*)u)[36] + ((Complex*)u)[48] ) / 5. ;
			((Complex*)u)[0]-=tracenth;
			((Complex*)u)[12]-=tracenth;
			((Complex*)u)[24]-=tracenth;
			((Complex*)u)[36]-=tracenth;
			((Complex*)u)[48]-=tracenth;
			#endif
			
			#if (SUN>5)	
			Complex tracenth=((Complex*)u)[0];
			for(int i=1;i<SUN;i++) tracenth+= ((Complex*)u)[SUN*i+i];
			tracenth/=(double)SUN;
			for(int i=0;i<SUN;i++) ((Complex*)u)[SUN*i+i]-= tracenth;
			#endif

		}
		
		void Dagger()
		{
				
			ComplGenMat tmp;
			
			for(int i=0;i<2*SUN*SUN;i++) tmp.u[i]=u[i];
			
			SetDagger(this->u , (const double *)&tmp );

			
		}
		
		void Dagger(const ComplGenMat& m)
		{
			SetDagger(this->u, (const double *)&m); 
		}
		
		void Dagger(const double* m)
		{
			SetDagger(this->u, m); 
		}
		
		double ErrorU() const
		{
			ComplGenMat prod1, prod2;

			prod1.Dagger(*this);
			prod2.DotMEqual(prod1, *this); 
			
			prod2 -= 1.0;
			
			double err=fabs(prod2[0]);
			for(int i = 1; i<2*SUN*SUN; i++) err+=fabs(prod2[i]);
			
			return err;
		}

		int Is0() 
		{
			
			double devfrom0=fabs(u[0]);
			for(int i = 1; i<2*SUN*SUN; i++) devfrom0+=fabs(u[i]);
			
			int answer;
			
			if (fabs(devfrom0)==0.) {answer =1;}else{answer=0;}
			
			return answer;
		}


		void print()
		{
			fprintf(stderr, "\n");
			for(int i=0; i<SUN; i++){
				if(i==0) { fprintf(stderr, "%c ",218); } else if (i==SUN-1) { fprintf(stderr, "%c ",192); } else { fprintf(stderr, "%c ",179); }
				for(int j=0;j<SUN;j++){
					
				fprintf(stderr, " (%.10e, %.10e) ", u[2*SUN*i+2*j],u[2*SUN*i+2*j+1]);	
					
			} if(i==0) { fprintf(stderr, "%c\n",191); } else if (i==SUN-1) { fprintf(stderr, "%c\n",217); } else { fprintf(stderr, "%c\n",179); }

			}
			fprintf(stderr, "\n");
			
		}

		void printM()
		{
			fprintf(stderr, "\n{");
			for(int i=0; i<SUN; i++){
				if(i==0) { fprintf(stderr, "{ "); } else if (i==SUN-1) { fprintf(stderr, "{ "); } else { fprintf(stderr, "{ "); }
				for(int j=0;j<SUN;j++){
					
				fprintf(stderr, " %.10f+I*%.10f", u[2*SUN*i+2*j],u[2*SUN*i+2*j+1]);	
				if(j!=SUN-1){ fprintf(stderr, ", " );}
			} if(i==0) { fprintf(stderr, "},\n"); } else if (i==SUN-1) { fprintf(stderr, "}\n"); } else { fprintf(stderr, "},\n"); }

			}
			fprintf(stderr, "}\n");
			
		}
		
		
		void Rand1SUN(TLP_RANDGEN *LocGSLr)
		{
			RandomSU_AROUND1(LocGSLr, this->u );
		}
		
		void Rand1SUNSYM(TLP_RANDGEN *LocGSLr)
		{
			RandomSU_AROUND1_SYM(LocGSLr, this->u );
		}
		
		void RandSUN(TLP_RANDGEN *LocGSLr)
		{
			//fprintf(stderr, "THERE SEEM TO APPEAR ZERO's IN THE RandSUN ROUTINE SO WE NEED A CHECK BEFORE USE\n"); exit(-1);
			RandomSU( LocGSLr, this->u );
			//RandomSU_AROUND1_SYM(LocGSLr, this->u );
		}
		
		void Invert()
		{
		
			MatInvert(this->u);
			
		}

		void Zero()
		{
		
			for(int i=0;i<2*SUN*SUN;i++) u[i]=0.;
			
		}

		void Unit()
		{
		
			for(int i=0;i<2*SUN*SUN;i++) u[i]=0.;
			for(int i=0;i<SUN;i++) u[i*2*SUN+2*i]=1.;
			
		}

		void Inverse(const ComplGenMat& m)
		{
		
			*this=m;
			
			MatInvert(this->u);
			
		}
		
		void Reunitarize()
		{
			
			ReSUN( this->u);
			
		}

		void SVD(Matrix& U, double *S, Matrix& Vt)
		{
			
			MatSVD(U.u,S,Vt.u);
			
		}

		void SVD_UVt(Matrix& Res)
		{
			
			Matrix U,Vt;
			double S[SUN];
			
			
			MatSVD(U.u,S,Vt.u);
			
			GenMatMult( Res.u, U.u, Vt.u);
			
		}
		
		Complex Det()
		{
			
			return Determinant(this->u);
			
		}
		
		void  FROM_REAL_SUN_GENERATORS(double *a);
		void  FROM_COMPL_SLC_GENERATORS(double *a);
		double REAL_SUN_GENERATOR(int which);
		Complex COMPL_SLC_GENERATOR(int which);
		
		double ImTrGen(int which);
		double ReTrGen(int which);
		Complex TrGen(int which);
		
		void EXP_SUN_REAL_GEN(double* a);
		void EXP_SLC_COMPL_GEN(double* a);
	};
	
	//---------------------------------------------------------------------------------------------
	//	SUN/SLC MATRICES AND GENERATORS ROUTINES
	//---------------------------------------------------------------------------------------------

	void ComplGenMat::FROM_REAL_SUN_GENERATORS(double *a)
	{

		#if (SUN==2)
		
			u[0]=a[0]/2.;
			u[1]=0;

			u[2]=a[1]/2.;
			u[3]=-a[2]/2.;

			u[4]=a[1]/2.;
			u[5]=a[2]/2.;

			u[6]=-a[0]/2.;
			u[7]=0;
			
		#elif (SUN==3)
		
			u[0]=(3*a[0] + sqrt(3.)*a[1])/6.;
			u[1]=0;

			u[2]=a[2]/2.;
			u[3]=-a[5]/2.;

			u[4]=a[3]/2.;
			u[5]=-a[6]/2.;

			u[6]=a[2]/2.;
			u[7]=a[5]/2.;

			u[8]=(-3.*a[0] + sqrt(3.)*a[1])/6.;
			u[9]=0;

			u[10]=a[4]/2.;
			u[11]=-a[7]/2.;

			u[12]=a[3]/2.;
			u[13]=a[6]/2.;

			u[14]=a[4]/2.;
			u[15]=a[7]/2.;

			u[16]=-(a[1]/sqrt(3.));
			u[17]=0;
			
		#elif (SUN==4)
		
			u[0]=(6.*a[0] + 2.*sqrt(3.)*a[1] + sqrt(6.)*a[2])/12.;
			u[1]=0;

			u[2]=a[3]/2.;
			u[3]=-a[9]/2.;

			u[4]=a[4]/2.;
			u[5]=-a[10]/2.;

			u[6]=a[6]/2.;
			u[7]=-a[12]/2.;

			u[8]=a[3]/2.;
			u[9]=a[9]/2.;

			u[10]=(-6.*a[0] + 2.*sqrt(3.)*a[1] + sqrt(6.)*a[2])/12.;
			u[11]=0;

			u[12]=a[5]/2.;
			u[13]=-a[11]/2.;

			u[14]=a[7]/2.;
			u[15]=-a[13]/2.;

			u[16]=a[4]/2.;
			u[17]=a[10]/2.;

			u[18]=a[5]/2.;
			u[19]=a[11]/2.;

			u[20]=(-4.*sqrt(3.)*a[1] + sqrt(6.)*a[2])/12.;
			u[21]=0;

			u[22]=a[8]/2.;
			u[23]=-a[14]/2.;

			u[24]=a[6]/2.;
			u[25]=a[12]/2.;

			u[26]=a[7]/2.;
			u[27]=a[13]/2.;

			u[28]=a[8]/2.;
			u[29]=a[14]/2.;

			u[30]=-(sqrt(1.5)*a[2])/2.;
			u[31]=0;
			
		#elif (SUN==5)
		
			u[0]=(30.*a[0] + 10*sqrt(3.)*a[1] + 5.*sqrt(6.)*a[2] + 3.*sqrt(10.)*a[3])/60.;
			u[1]=0;

			u[2]=a[4]/2.;
			u[3]=-a[14]/2.;

			u[4]=a[5]/2.;
			u[5]=-a[15]/2.;

			u[6]=a[7]/2.;
			u[7]=-a[17]/2.;

			u[8]=a[10]/2.;
			u[9]=-a[20]/2.;

			u[10]=a[4]/2.;
			u[11]=a[14]/2.;

			u[12]=(-30.*a[0] + 10.*sqrt(3.)*a[1] + 5.*sqrt(6.)*a[2] + 3.*sqrt(10.)*a[3])/60.;
			u[13]=0;

			u[14]=a[6]/2.;
			u[15]=-a[16]/2.;

			u[16]=a[8]/2.;
			u[17]=-a[18]/2.;

			u[18]=a[11]/2.;
			u[19]=-a[21]/2.;

			u[20]=a[5]/2.;
			u[21]=a[15]/2.;

			u[22]=a[6]/2.;
			u[23]=a[16]/2.;

			u[24]=(-20.*sqrt(3.)*a[1] + 5*sqrt(6.)*a[2] + 3*sqrt(10.)*a[3])/60.;
			u[25]=0;

			u[26]=a[9]/2.;
			u[27]=-a[19]/2.;

			u[28]=a[12]/2.;
			u[29]=-a[22]/2.;

			u[30]=a[7]/2.;
			u[31]=a[17]/2.;

			u[32]=a[8]/2.;
			u[33]=a[18]/2.;

			u[34]=a[9]/2.;
			u[35]=a[19]/2.;

			u[36]=(-5.*sqrt(6.)*a[2] + sqrt(10.)*a[3])/20.;
			u[37]=0;

			u[38]=a[13]/2.;
			u[39]=-a[23]/2.;

			u[40]=a[10]/2.;
			u[41]=a[20]/2.;

			u[42]=a[11]/2.;
			u[43]=a[21]/2.;

			u[44]=a[12]/2.;
			u[45]=a[22]/2.;

			u[46]=a[13]/2.;
			u[47]=a[23]/2.;

			u[48]=-(sqrt(0.4)*a[3]);
			u[49]=0;
			
		#elif (SUN==6)
		
		#elif (SUN==7)
		
		#elif (SUN==8)
		
		#elif (SUN==9)
		
		#elif (SUN==10)
		
		#endif






	}

	void ComplGenMat::FROM_COMPL_SLC_GENERATORS(double *a)
	{

		#if (SUN==2)
		
			u[0]=a[0]/2.;
			u[1]=a[1]/2.;

			u[2]=(a[2] + a[5])/2.;
			u[3]=(a[3] - a[4])/2.;

			u[4]=(a[2] - a[5])/2.;
			u[5]=(a[3] + a[4])/2.;

			u[6]=-a[0]/2.;
			u[7]=-a[1]/2.;	
			
		#elif (SUN==3)
		
			u[0]=(3*a[0] + sqrt(3)*a[2])/6.;
			u[1]=(3*a[1] + sqrt(3)*a[3])/6.;

			u[2]=(a[4] + a[11])/2.;
			u[3]=(a[5] - a[10])/2.;

			u[4]=(a[6] + a[13])/2.;
			u[5]=(a[7] - a[12])/2.;

			u[6]=(a[4] - a[11])/2.;
			u[7]=(a[5] + a[10])/2.;

			u[8]=(-3*a[0] + sqrt(3)*a[2])/6.;
			u[9]=(-3*a[1] + sqrt(3)*a[3])/6.;

			u[10]=(a[8] + a[15])/2.;
			u[11]=(a[9] - a[14])/2.;

			u[12]=(a[6] - a[13])/2.;
			u[13]=(a[7] + a[12])/2.;

			u[14]=(a[8] - a[15])/2.;
			u[15]=(a[9] + a[14])/2.;

			u[16]=-(a[2]/sqrt(3));
			u[17]=-(a[3]/sqrt(3));
			
		#elif (SUN==4)

			u[0]=(6*a[0] + 2*sqrt(3.)*a[2] + sqrt(6.)*a[4])/12.;
			u[1]=(6*a[1] + 2*sqrt(3.)*a[3] + sqrt(6.)*a[5])/12.;

			u[2]=(a[6] + a[19])/2.;
			u[3]=(a[7] - a[18])/2.;

			u[4]=(a[8] + a[21])/2.;
			u[5]=(a[9] - a[20])/2.;

			u[6]=(a[12] + a[25])/2.;
			u[7]=(a[13] - a[24])/2.;

			u[8]=(a[6] - a[19])/2.;
			u[9]=(a[7] + a[18])/2.;

			u[10]=(-6*a[0] + 2*sqrt(3)*a[2] + sqrt(6)*a[4])/12.;
			u[11]=(-6*a[1] + 2*sqrt(3)*a[3] + sqrt(6)*a[5])/12.;

			u[12]=(a[10] + a[23])/2.;
			u[13]=(a[11] - a[22])/2.;

			u[14]=(a[14] + a[27])/2.;
			u[15]=(a[15] - a[26])/2.;

			u[16]=(a[8] - a[21])/2.;
			u[17]=(a[9] + a[20])/2.;

			u[18]=(a[10] - a[23])/2.;
			u[19]=(a[11] + a[22])/2.;

			u[20]=(-4*a[2] + sqrt(2.)*a[4])/(4.*sqrt(3));
			u[21]=(-4*a[3] + sqrt(2.)*a[5])/(4.*sqrt(3));

			u[22]=(a[16] + a[29])/2.;
			u[23]=(a[17] - a[28])/2.;

			u[24]=(a[12] - a[25])/2.;
			u[25]=(a[13] + a[24])/2.;

			u[26]=(a[14] - a[27])/2.;
			u[27]=(a[15] + a[26])/2.;

			u[28]=(a[16] - a[29])/2.;
			u[29]=(a[17] + a[28])/2.;

			u[30]=-(sqrt(1.5)*a[4])/2.;
			u[31]=-(sqrt(1.5)*a[5])/2.;

		#elif (SUN==5)

			u[0]=(30*a[0] + 10*sqrt(3)*a[2] + 5*sqrt(6)*a[4] + 3*sqrt(10)*a[6])/60.;
			u[1]=(30*a[1] + 10*sqrt(3)*a[3] + 5*sqrt(6)*a[5] + 3*sqrt(10)*a[7])/60.;

			u[2]=(a[8] + a[29])/2.;
			u[3]=(a[9] - a[28])/2.;

			u[4]=(a[10] + a[31])/2.;
			u[5]=(a[11] - a[30])/2.;

			u[6]=(a[14] + a[35])/2.;
			u[7]=(a[15] - a[34])/2.;

			u[8]=(a[20] + a[41])/2.;
			u[9]=(a[21] - a[40])/2.;

			u[10]=(a[8] - a[29])/2.;
			u[11]=(a[9] + a[28])/2.;

			u[12]=(-30*a[0] + 10*sqrt(3)*a[2] + 5*sqrt(6)*a[4] + 3*sqrt(10)*a[6])/60.;
			u[13]=(-30*a[1] + 10*sqrt(3)*a[3] + 5*sqrt(6)*a[5] + 3*sqrt(10)*a[7])/60.;

			u[14]=(a[12] + a[33])/2.;
			u[15]=(a[13] - a[32])/2.;

			u[16]=(a[16] + a[37])/2.;
			u[17]=(a[17] - a[36])/2.;

			u[18]=(a[22] + a[43])/2.;
			u[19]=(a[23] - a[42])/2.;

			u[20]=(a[10] - a[31])/2.;
			u[21]=(a[11] + a[30])/2.;

			u[22]=(a[12] - a[33])/2.;
			u[23]=(a[13] + a[32])/2.;

			u[24]=(-20*sqrt(3)*a[2] + 5*sqrt(6)*a[4] + 3*sqrt(10)*a[6])/60.;
			u[25]=(-20*sqrt(3)*a[3] + 5*sqrt(6)*a[5] + 3*sqrt(10)*a[7])/60.;

			u[26]=(a[18] + a[39])/2.;
			u[27]=(a[19] - a[38])/2.;

			u[28]=(a[24] + a[45])/2.;
			u[29]=(a[25] - a[44])/2.;

			u[30]=(a[14] - a[35])/2.;
			u[31]=(a[15] + a[34])/2.;

			u[32]=(a[16] - a[37])/2.;
			u[33]=(a[17] + a[36])/2.;

			u[34]=(a[18] - a[39])/2.;
			u[35]=(a[19] + a[38])/2.;

			u[36]=(-5*sqrt(6)*a[4] + sqrt(10)*a[6])/20.;
			u[37]=(-5*sqrt(6)*a[5] + sqrt(10)*a[7])/20.;

			u[38]=(a[26] + a[47])/2.;
			u[39]=(a[27] - a[46])/2.;

			u[40]=(a[20] - a[41])/2.;
			u[41]=(a[21] + a[40])/2.;

			u[42]=(a[22] - a[43])/2.;
			u[43]=(a[23] + a[42])/2.;

			u[44]=(a[24] - a[45])/2.;
			u[45]=(a[25] + a[44])/2.;

			u[46]=(a[26] - a[47])/2.;
			u[47]=(a[27] + a[46])/2.;

			u[48]=-(sqrt(0.4)*a[6]);
			u[49]=-(sqrt(0.4)*a[7]);

		#elif (SUN==6)
		
		#elif (SUN==7)
		
		#elif (SUN==8)
		
		#elif (SUN==9)
		
		#elif (SUN==10)
		
		#endif






	}
		
	double ComplGenMat::ImTrGen(int which) 
	{
	//THIS ROUTINE CALCULATES THE TRACE WITH THE GENERATOR MATRICES DIVIDED BY I AND THEN TAKEN THE REALPART
		#if (SUN==2)
			switch ( which ) {

			case 0:
			return (u[1] - u[7])/2.;
			break;
			
			case 1:
			return (u[3] + u[5])/2.;
			break;
			
			case 2:
			return (u[2] - u[4])/2.;
			break;
			
			default:
			fprintf(stderr, "SU2 only has 3 GENERATORS, PLEASE CORRECT CODE WHICH CHOSE: %d\n", which); exit(-1);
			break;
			}
		#elif (SUN==3)
			switch ( which ) {

			case 0:
			return (u[1] - u[9])/2.;
			break;

			case 1:
			return (u[1] + u[9] - 2.*u[17])/(2.*sqrt(3.));
			break;

			case 2:
			return (u[3] + u[7])/2.;
			break;

			case 3:
			return (u[5] + u[13])/2.;
			break;

			case 4:
			return (u[11] + u[15])/2.;
			break;

			case 5:
			return (u[2] - u[6])/2.;
			break;

			case 6:
			return (u[4] - u[12])/2.;
			break;

			case 7:
			return (u[10] - u[14])/2.;
			break;
	
			default:
			fprintf(stderr, "SU3 only has 8 GENERATORS, PLEASE CORRECT CODE WHICH CHOSE: %d\n", which); exit(-1);
			break;
			}
		
		#elif (SUN==4)
			switch ( which ) {

			case 0:
			return (u[1] - u[11])/2.;
			break;

			case 1:
			return (u[1] + u[11] - 2.*u[21])/(2.*sqrt(3.));
			break;

			case 2:
			return (u[1] + u[11] + u[21] - 3.*u[31])/(2.*sqrt(6.));
			break;

			case 3:
			return (u[3] + u[9])/2.;
			break;

			case 4:
			return (u[5] + u[17])/2.;
			break;

			case 5:
			return (u[13] + u[19])/2.;
			break;

			case 6:
			return (u[7] + u[25])/2.;
			break;

			case 7:
			return (u[15] + u[27])/2.;
			break;

			case 8:
			return (u[23] + u[29])/2.;
			break;

			case 9:
			return (u[2] - u[8])/2.;
			break;

			case 10:
			return (u[4] - u[16])/2.;
			break;

			case 11:
			return (u[12] - u[18])/2.;
			break;

			case 12:
			return (u[6] - u[24])/2.;
			break;

			case 13:
			return (u[14] - u[26])/2.;
			break;

			case 14:
			return (u[22] - u[28])/2.;
			break;
				
			
			default:
			fprintf(stderr, "SU4 only has 15 GENERATORS, PLEASE CORRECT CODE WHICH CHOSE: %d\n", which); exit(-1);
			break;
			}
		
		#elif (SUN==5)
		
			switch ( which ) {

			case 0:
			return (u[1] - u[13])/2.;
			break;

			case 1:
			return (u[1] + u[13] - 2.*u[25])/(2.*sqrt(3.));
			break;

			case 2:
			return (u[1] + u[13] + u[25] - 3.*u[37])/(2.*sqrt(6.));
			break;

			case 3:
			return (u[1] + u[13] + u[25] + u[37] - 4.*u[49])/(2.*sqrt(10.));
			break;				
				
			case 4:
			return (u[3] + u[11])/2.;
			break;

			case 5:
			return (u[5] + u[21])/2.;
			break;

			case 6:
			return (u[15] + u[23])/2.;
			break;

			case 7:
			return (u[7] + u[31])/2.;
			break;

			case 8:
			return (u[17] + u[33])/2.;
			break;

			case 9:
			return (u[27] + u[35])/2.;
			break;

			case 10:
			return (u[9] + u[41])/2.;
			break;

			case 11:
			return (u[19] + u[43])/2.;
			break;

			case 12:
			return (u[29] + u[45])/2.;
			break;

			case 13:
			return (u[39] + u[47])/2.;
			break;

			case 14:
			return (u[2] - u[10])/2.;
			break;

			case 15:
			return (u[4] - u[20])/2.;
			break;

			case 16:
			return (u[14] - u[22])/2.;
			break;

			case 17:
			return (u[6] - u[30])/2.;
			break;

			case 18:
			return (u[16] - u[32])/2.;
			break;

			case 19:
			return (u[26] - u[34])/2.;
			break;

			case 20:
			return (u[8] - u[40])/2.;
			break;

			case 21:
			return (u[18] - u[42])/2.;
			break;

			case 22:
			return (u[28] - u[44])/2.;
			break;

			case 23:
			return (u[38] - u[46])/2.;
			break;


			default:
			fprintf(stderr, "SU5 only has 24 GENERATORS, PLEASE CORRECT CODE WHICH CHOSE: %d\n", which); exit(-1);
			break;
			}
		
		#elif (SUN==6)
			switch ( which ) {

				
				
			default:
			fprintf(stderr, "SU2 only has 3 GENERATORS, PLEASE CORRECT CODE WHICH CHOSE: %d\n", which); exit(-1);
			break;
			}
		
		#elif (SUN==7)
			switch ( which ) {

				
				
			default:
			fprintf(stderr, "SU2 only has 3 GENERATORS, PLEASE CORRECT CODE WHICH CHOSE: %d\n", which); exit(-1);
			break;
			}
		
		#elif (SUN==8)
			switch ( which ) {

				
				
			default:
			fprintf(stderr, "SU2 only has 3 GENERATORS, PLEASE CORRECT CODE WHICH CHOSE: %d\n", which); exit(-1);
			break;
			}
		
		#elif (SUN==9)
			switch ( which ) {

				
				
			default:
			fprintf(stderr, "SU2 only has 3 GENERATORS, PLEASE CORRECT CODE WHICH CHOSE: %d\n", which); exit(-1);
			break;
			}
		
		#elif (SUN==10)
			switch ( which ) {

				
				
			default:
			fprintf(stderr, "SU2 only has 3 GENERATORS, PLEASE CORRECT CODE WHICH CHOSE: %d\n", which); exit(-1);
			break;
			}
		
		#endif
		
	}

      double ComplGenMat::ReTrGen(int which)
	{

		#if (SUN==2)
			switch ( which ) {

			case 0:
			return (u[0] - u[6])/2.;
			break;
			
			case 1:
			return (u[2] + u[4])/2.;
			break;
			
			case 2:
			return (-u[3] + u[5])/2.;
			break;
			
			default:
			fprintf(stderr, "SU2 only has 3 GENERATORS, PLEASE CORRECT CODE WHICH CHOSE: %d\n", which); exit(-1);
			break;
			}

		#elif (SUN==3)
			switch ( which ) {
				
			case 0:
			return (u[0] - u[8])/2.;
			break;

			case 1:
			return (u[0] + u[8] - 2.*u[16])/(2.*sqrt(3.));
			break;

			case 2:
			return (u[2] + u[6])/2.;
			break;

			case 3:
			return (u[4] + u[12])/2.;
			break;

			case 4:
			return (u[10] + u[14])/2.;
			break;

			case 5:
			return (-u[3] + u[7])/2.;
			break;

			case 6:
			return (-u[5] + u[13])/2.;
			break;

			case 7:
			return (-u[11] + u[15])/2.;
			break;

			default:
			fprintf(stderr, "SU3 only has 8 GENERATORS, PLEASE CORRECT CODE WHICH CHOSE: %d\n", which); exit(-1);
			break;
			}
			
		#endif
	}
	
      Complex ComplGenMat::TrGen(int which)
	{
	//THIS ROUTINE CALCULATES THE TRACE WITH THE GENERATOR MATRICES DIVIDED BY I

		#if (SUN==2)
			switch ( which ) {

			case 0:
			return Complex((u[0] - u[6])/2.,(u[1] - u[7])/2.);
			break;
			
			case 1:
			return Complex((u[2] + u[4])/2.,(u[3] + u[5])/2.);
			break;
			
			case 2:
			return Complex((-u[3] + u[5])/2.,(u[2] - u[4])/2.);
			break;
			
			default:
			fprintf(stderr, "SU2 only has 3 GENERATORS, PLEASE CORRECT CODE WHICH CHOSE: %d\n", which); exit(-1);
			break;
			}

		#elif (SUN==3)
			switch ( which ) {
				
			case 0:
			return Complex((u[0] - u[8])/2.,(u[1] - u[9])/2.);
			break;

			case 1:
			return Complex((u[0] + u[8] - 2.*u[16])/(2.*sqrt(3.)),(u[1] + u[9] - 2.*u[17])/(2.*sqrt(3.)));
			break;

			case 2:
			return Complex((u[2] + u[6])/2.,(u[3] + u[7])/2.);
			break;

			case 3:
			return Complex((u[4] + u[12])/2.,(u[5] + u[13])/2.);
			break;

			case 4:
			return Complex((u[10] + u[14])/2.,(u[11] + u[15])/2.);
			break;

			case 5:
			return Complex((-u[3] + u[7])/2.,(u[2] - u[6])/2.);
			break;

			case 6:
			return Complex((-u[5] + u[13])/2.,(u[4] - u[12])/2.);
			break;

			case 7:
			return Complex((-u[11] + u[15])/2.,(u[10] - u[14])/2.);
			break;

				
			default:
			fprintf(stderr, "SU3 only has 8 GENERATORS, PLEASE CORRECT CODE WHICH CHOSE: %d\n", which); exit(-1);
			break;
			}
		
		#elif (SUN==4)
			switch ( which ) {

			case 0:
			return Complex((u[0] - u[10])/2.,(u[1] - u[11])/2.);
			break;

			case 1:
			return Complex((u[0] + u[10] - 2.*u[20])/(2.*sqrt(3.)),(u[1] + u[11] - 2.*u[21])/(2.*sqrt(3.)));
			break;

			case 2:
			return Complex((u[0] + u[10] + u[20] - 3.*u[30])/(2.*sqrt(6.)),(u[1] + u[11] + u[21] - 3.*u[31])/(2.*sqrt(6.)));
			break;

			case 3:
			return Complex((u[2] + u[8])/2.,(u[3] + u[9])/2.);
			break;

			case 4:
			return Complex((u[4] + u[16])/2.,(u[5] + u[17])/2.);
			break;

			case 5:
			return Complex((u[12] + u[18])/2.,(u[13] + u[19])/2.);
			break;

			case 6:
			return Complex((u[6] + u[24])/2.,(u[7] + u[25])/2.);
			break;

			case 7:
			return Complex((u[14] + u[26])/2.,(u[15] + u[27])/2.);
			break;

			case 8:
			return Complex((u[22] + u[28])/2.,(u[23] + u[29])/2.);
			break;

			case 9:
			return Complex((-u[3] + u[9])/2.,(u[2] - u[8])/2.);
			break;

			case 10:
			return Complex((-u[5] + u[17])/2.,(u[4] - u[16])/2.);
			break;

			case 11:
			return Complex((-u[13] + u[19])/2.,(u[12] - u[18])/2.);
			break;

			case 12:
			return Complex((-u[7] + u[25])/2.,(u[6] - u[24])/2.);
			break;

			case 13:
			return Complex((-u[15] + u[27])/2.,(u[14] - u[26])/2.);
			break;

			case 14:
			return Complex((-u[23] + u[29])/2.,(u[22] - u[28])/2.);
			break;


				
			default:
			fprintf(stderr, "SU4 only has 15 GENERATORS, PLEASE CORRECT CODE WHICH CHOSE: %d\n", which); exit(-1);
			break;
			}
		
		#elif (SUN==5)
			switch ( which ) {

			case 0:
			return Complex((u[0] - u[12])/2.,(u[1] - u[13])/2.);
			break;

			case 1:
			return Complex((u[0] + u[12] - 2.*u[24])/(2.*sqrt(3.)),(u[1] + u[13] - 2.*u[25])/(2.*sqrt(3.)));
			break;

			case 2:
			return Complex((u[0] + u[12] + u[24] - 3.*u[36])/(2.*sqrt(6.)),(u[1] + u[13] + u[25] - 3.*u[37])/(2.*sqrt(6.)));
			break;

			case 3:
			return Complex((u[0] + u[12] + u[24] + u[36] - 4.*u[48])/(2.*sqrt(10.)),(u[1] + u[13] + u[25] + u[37] - 4.*u[49])/(2.*sqrt(10.)));
			break;

			case 4:
			return Complex((u[2] + u[10])/2.,(u[3] + u[11])/2.);
			break;

			case 5:
			return Complex((u[4] + u[20])/2.,(u[5] + u[21])/2.);
			break;

			case 6:
			return Complex((u[14] + u[22])/2.,(u[15] + u[23])/2.);
			break;

			case 7:
			return Complex((u[6] + u[30])/2.,(u[7] + u[31])/2.);
			break;

			case 8:
			return Complex((u[16] + u[32])/2.,(u[17] + u[33])/2.);
			break;

			case 9:
			return Complex((u[26] + u[34])/2.,(u[27] + u[35])/2.);
			break;

			case 10:
			return Complex((u[8] + u[40])/2.,(u[9] + u[41])/2.);
			break;

			case 11:
			return Complex((u[18] + u[42])/2.,(u[19] + u[43])/2.);
			break;

			case 12:
			return Complex((u[28] + u[44])/2.,(u[29] + u[45])/2.);
			break;

			case 13:
			return Complex((u[38] + u[46])/2.,(u[39] + u[47])/2.);
			break;

			case 14:
			return Complex((-u[3] + u[11])/2.,(u[2] - u[10])/2.);
			break;

			case 15:
			return Complex((-u[5] + u[21])/2.,(u[4] - u[20])/2.);
			break;

			case 16:
			return Complex((-u[15] + u[23])/2.,(u[14] - u[22])/2.);
			break;

			case 17:
			return Complex((-u[7] + u[31])/2.,(u[6] - u[30])/2.);
			break;

			case 18:
			return Complex((-u[17] + u[33])/2.,(u[16] - u[32])/2.);
			break;

			case 19:
			return Complex((-u[27] + u[35])/2.,(u[26] - u[34])/2.);
			break;

			case 20:
			return Complex((-u[9] + u[41])/2.,(u[8] - u[40])/2.);
			break;

			case 21:
			return Complex((-u[19] + u[43])/2.,(u[18] - u[42])/2);
			break;

			case 22:
			return Complex((-u[29] + u[45])/2.,(u[28] - u[44])/2.);
			break;

			case 23:
			return Complex((-u[39] + u[47])/2.,(u[38] - u[46])/2.);
			break;
						
			default:
			fprintf(stderr, "SU5 only has 24 GENERATORS, PLEASE CORRECT CODE WHICH CHOSE: %d\n", which); exit(-1);
			break;
			}
		
		#elif (SUN==6)
			switch ( which ) {

				
				
			default:
			fprintf(stderr, "SU2 only has 3 GENERATORS, PLEASE CORRECT CODE WHICH CHOSE: %d\n", which); exit(-1);
			break;
			}
		
		#elif (SUN==7)
			switch ( which ) {

				
				
			default:
			fprintf(stderr, "SU2 only has 3 GENERATORS, PLEASE CORRECT CODE WHICH CHOSE: %d\n", which); exit(-1);
			break;
			}
		
		#elif (SUN==8)
			switch ( which ) {

				
				
			default:
			fprintf(stderr, "SU2 only has 3 GENERATORS, PLEASE CORRECT CODE WHICH CHOSE: %d\n", which); exit(-1);
			break;
			}
		
		#elif (SUN==9)
			switch ( which ) {

				
				
			default:
			fprintf(stderr, "SU2 only has 3 GENERATORS, PLEASE CORRECT CODE WHICH CHOSE: %d\n", which); exit(-1);
			break;
			}
		
		#elif (SUN==10)
			switch ( which ) {

				
				
			default:
			fprintf(stderr, "SU2 only has 3 GENERATORS, PLEASE CORRECT CODE WHICH CHOSE: %d\n", which); exit(-1);
			break;
			}
		
		#endif
		
	}

	double ComplGenMat::REAL_SUN_GENERATOR(int which) 
	{
	//THIS ROUTINE CALCULATES THE TRACE WITH THE GENERATOR MATRICES DIVIDED BY I AND THEN TAKEN THE REALPART
		#if (SUN==2)
			switch ( which ) {

			case 0:
			return (u[1] - u[7])/2.;
			break;				
				
			case 1:
			return (u[3] + u[5])/2.;
			break;

			case 2:
			return (u[2] - u[4])/2.;
			break;

			default:
			fprintf(stderr, "SU2 only has 3 GENERATORS, PLEASE CORRECT CODE WHICH CHOSE: %d\n", which); exit(-1);
			break;
			}
		#elif (SUN==3)
			switch ( which ) {

			case 0:
			return (u[1] - u[9])/2.;
			break;

			case 1:
			return (u[1] + u[9] - 2*u[17])/(2.*sqrt(3));
			break;

			case 2:
			return (u[3] + u[7])/2.;
			break;

			case 3:
			return (u[5] + u[13])/2.;
			break;

			case 4:
			return (u[11] + u[15])/2.;
			break;

			case 5:
			return (u[2] - u[6])/2.;
			break;

			case 6:
			return (u[4] - u[12])/2.;
			break;

			case 7:
			return (u[10] - u[14])/2.;
			break;
				
			default:
			fprintf(stderr, "SU3 only has 8 GENERATORS, PLEASE CORRECT CODE WHICH CHOSE: %d\n", which); exit(-1);
			break;
			}
		
		#elif (SUN==4)
			switch ( which ) {

			case 0:
			return (u[1] - u[11])/2.;
			break;

			case 1:
			return (u[1] + u[11] - 2*u[21])/(2.*sqrt(3));
			break;

			case 2:
			return (u[1] + u[11] + u[21] - 3*u[31])/(2.*sqrt(6));
			break;

			case 3:
			return (u[3] + u[9])/2.;
			break;

			case 4:
			return (u[5] + u[17])/2.;
			break;

			case 5:
			return (u[13] + u[19])/2.;
			break;

			case 6:
			return (u[7] + u[25])/2.;
			break;

			case 7:
			return (u[15] + u[27])/2.;
			break;

			case 8:
			return (u[23] + u[29])/2.;
			break;

			case 9:
			return (u[2] - u[8])/2.;
			break;

			case 10:
			return (u[4] - u[16])/2.;
			break;

			case 11:
			return (u[12] - u[18])/2.;
			break;

			case 12:
			return (u[6] - u[24])/2.;
			break;

			case 13:
			return (u[14] - u[26])/2.;
			break;

			case 14:
			return (u[22] - u[28])/2.;
			break;
			
			default:
			fprintf(stderr, "SU4 only has 15 GENERATORS, PLEASE CORRECT CODE WHICH CHOSE: %d\n", which); exit(-1);
			break;
			}
		
		#elif (SUN==5)
		
			switch ( which ) {

			case 0:
			return (u[1] - u[13])/2.;
			break;

			case 1:
			return (u[1] + u[13] - 2*u[25])/(2.*sqrt(3));
			break;

			case 2:
			return (u[1] + u[13] + u[25] - 3*u[37])/(2.*sqrt(6));
			break;

			case 3:
			return (u[1] + u[13] + u[25] + u[37] - 4*u[49])/(2.*sqrt(10));
			break;

			case 4:
			return (u[3] + u[11])/2.;
			break;

			case 5:
			return (u[5] + u[21])/2.;
			break;

			case 6:
			return (u[15] + u[23])/2.;
			break;

			case 7:
			return (u[7] + u[31])/2.;
			break;

			case 8:
			return (u[17] + u[33])/2.;
			break;

			case 9:
			return (u[27] + u[35])/2.;
			break;

			case 10:
			return (u[9] + u[41])/2.;
			break;

			case 11:
			return (u[19] + u[43])/2.;
			break;

			case 12:
			return (u[29] + u[45])/2.;
			break;

			case 13:
			return (u[39] + u[47])/2.;
			break;

			case 14:
			return (u[2] - u[10])/2.;
			break;

			case 15:
			return (u[4] - u[20])/2.;
			break;

			case 16:
			return (u[14] - u[22])/2.;
			break;

			case 17:
			return (u[6] - u[30])/2.;
			break;

			case 18:
			return (u[16] - u[32])/2.;
			break;

			case 19:
			return (u[26] - u[34])/2.;
			break;

			case 20:
			return (u[8] - u[40])/2.;
			break;

			case 21:
			return (u[18] - u[42])/2.;
			break;

			case 22:
			return (u[28] - u[44])/2.;
			break;

			case 23:
			return (u[38] - u[46])/2.;
			break;
				
			default:
			fprintf(stderr, "SU5 only has 24 GENERATORS, PLEASE CORRECT CODE WHICH CHOSE: %d\n", which); exit(-1);
			break;
			}
		
		#elif (SUN==6)
			switch ( which ) {

				
				
			default:
			fprintf(stderr, "SU2 only has 3 GENERATORS, PLEASE CORRECT CODE WHICH CHOSE: %d\n", which); exit(-1);
			break;
			}
		
		#elif (SUN==7)
			switch ( which ) {

				
				
			default:
			fprintf(stderr, "SU2 only has 3 GENERATORS, PLEASE CORRECT CODE WHICH CHOSE: %d\n", which); exit(-1);
			break;
			}
		
		#elif (SUN==8)
			switch ( which ) {

				
				
			default:
			fprintf(stderr, "SU2 only has 3 GENERATORS, PLEASE CORRECT CODE WHICH CHOSE: %d\n", which); exit(-1);
			break;
			}
		
		#elif (SUN==9)
			switch ( which ) {

				
				
			default:
			fprintf(stderr, "SU2 only has 3 GENERATORS, PLEASE CORRECT CODE WHICH CHOSE: %d\n", which); exit(-1);
			break;
			}
		
		#elif (SUN==10)
			switch ( which ) {

				
				
			default:
			fprintf(stderr, "SU2 only has 3 GENERATORS, PLEASE CORRECT CODE WHICH CHOSE: %d\n", which); exit(-1);
			break;
			}
		
		#endif
		
	}

        Complex ComplGenMat::COMPL_SLC_GENERATOR(int which)
	{
	//THIS ROUTINE CALCULATES THE TRACE WITH THE GENERATOR MATRICES DIVIDED BY I

		#if (SUN==2)
			switch ( which ) {

			case 0:
			return Complex((u[1] - u[7])/2.,-(u[0] - u[6])/2.);
			break;				

			case 1:
			return Complex((u[3] + u[5])/2.,-(u[2] + u[4])/2.);
			break;
	
			case 2:
			return Complex((u[2] - u[4])/2.,-(-u[3] + u[5])/2.);
			break;			
			
			default:
			fprintf(stderr, "SU2 only has 3 GENERATORS, PLEASE CORRECT CODE WHICH CHOSE: %d\n", which); exit(-1);
			break;
			}

		#elif (SUN==3)
			switch ( which ) {

			case 0:
			return Complex((u[1] - u[9])/2.,-(u[0] - u[8])/2.);
			break;

			case 1:
			return Complex((u[1] + u[9] - 2*u[17])/(2.*sqrt(3)),-(u[0] + u[8] - 2*u[16])/(2.*sqrt(3)));
			break;

			case 2:
			return Complex((u[3] + u[7])/2.,-(u[2] + u[6])/2.);
			break;

			case 3:
			return Complex((u[5] + u[13])/2.,-(u[4] + u[12])/2.);
			break;

			case 4:
			return Complex((u[11] + u[15])/2.,-(u[10] + u[14])/2.);
			break;

			case 5:
			return Complex((u[2] - u[6])/2.,-(-u[3] + u[7])/2.);
			break;

			case 6:
			return Complex((u[4] - u[12])/2.,-(-u[5] + u[13])/2.);
			break;

			case 7:
			return Complex((u[10] - u[14])/2.,-(-u[11] + u[15])/2.);
			break;
				
			default:
			fprintf(stderr, "SU3 only has 8 GENERATORS, PLEASE CORRECT CODE WHICH CHOSE: %d\n", which); exit(-1);
			break;
			}
		
		#elif (SUN==4)
			switch ( which ) {

			case 0:
			return Complex((u[1] - u[11])/2.,-(u[0] - u[10])/2.);
			break;

			case 1:
			return Complex((u[1] + u[11] - 2*u[21])/(2.*sqrt(3)),-(u[0] + u[10] - 2*u[20])/(2.*sqrt(3)));
			break;

			case 2:
			return Complex((u[1] + u[11] + u[21] - 3*u[31])/(2.*sqrt(6)),-(u[0] + u[10] + u[20] - 3*u[30])/(2.*sqrt(6)));
			break;

			case 3:
			return Complex((u[3] + u[9])/2.,-(u[2] + u[8])/2.);
			break;

			case 4:
			return Complex((u[5] + u[17])/2.,-(u[4] + u[16])/2.);
			break;

			case 5:
			return Complex((u[13] + u[19])/2.,-(u[12] + u[18])/2.);
			break;

			case 6:
			return Complex((u[7] + u[25])/2.,-(u[6] + u[24])/2.);
			break;

			case 7:
			return Complex((u[15] + u[27])/2.,-(u[14] + u[26])/2.);
			break;

			case 8:
			return Complex((u[23] + u[29])/2.,-(u[22] + u[28])/2.);
			break;

			case 9:
			return Complex((u[2] - u[8])/2.,-(-u[3] + u[9])/2.);
			break;

			case 10:
			return Complex((u[4] - u[16])/2.,-(-u[5] + u[17])/2.);
			break;

			case 11:
			return Complex((u[12] - u[18])/2.,-(-u[13] + u[19])/2.);
			break;

			case 12:
			return Complex((u[6] - u[24])/2.,-(-u[7] + u[25])/2.);
			break;

			case 13:
			return Complex((u[14] - u[26])/2.,-(-u[15] + u[27])/2.);
			break;

			case 14:
			return Complex((u[22] - u[28])/2.,-(-u[23] + u[29])/2.);
			break;
				
			default:
			fprintf(stderr, "SU4 only has 15 GENERATORS, PLEASE CORRECT CODE WHICH CHOSE: %d\n", which); exit(-1);
			break;
			}
		
		#elif (SUN==5)
			switch ( which ) {

			case 0:
			return Complex((u[1] - u[13])/2.,-(u[0] - u[12])/2.);
			break;

			case 1:
			return Complex((u[1] + u[13] - 2*u[25])/(2.*sqrt(3)),-(u[0] + u[12] - 2*u[24])/(2.*sqrt(3)));
			break;

			case 2:
			return Complex((u[1] + u[13] + u[25] - 3*u[37])/(2.*sqrt(6)),-(u[0] + u[12] + u[24] - 3*u[36])/(2.*sqrt(6)));
			break;

			case 3:
			return Complex((u[1] + u[13] + u[25] + u[37] - 4*u[49])/(2.*sqrt(10)),-(u[0] + u[12] + u[24] + u[36] - 4*u[48])/(2.*sqrt(10)));
			break;

			case 4:
			return Complex((u[3] + u[11])/2.,-(u[2] + u[10])/2.);
			break;

			case 5:
			return Complex((u[5] + u[21])/2.,-(u[4] + u[20])/2.);
			break;

			case 6:
			return Complex((u[15] + u[23])/2.,-(u[14] + u[22])/2.);
			break;

			case 7:
			return Complex((u[7] + u[31])/2.,-(u[6] + u[30])/2.);
			break;

			case 8:
			return Complex((u[17] + u[33])/2.,-(u[16] + u[32])/2.);
			break;

			case 9:
			return Complex((u[27] + u[35])/2.,-(u[26] + u[34])/2.);
			break;

			case 10:
			return Complex((u[9] + u[41])/2.,-(u[8] + u[40])/2.);
			break;

			case 11:
			return Complex((u[19] + u[43])/2.,-(u[18] + u[42])/2.);
			break;

			case 12:
			return Complex((u[29] + u[45])/2.,-(u[28] + u[44])/2.);
			break;

			case 13:
			return Complex((u[39] + u[47])/2.,-(u[38] + u[46])/2.);
			break;

			case 14:
			return Complex((u[2] - u[10])/2.,-(-u[3] + u[11])/2.);
			break;

			case 15:
			return Complex((u[4] - u[20])/2.,-(-u[5] + u[21])/2.);
			break;

			case 16:
			return Complex((u[14] - u[22])/2.,-(-u[15] + u[23])/2.);
			break;

			case 17:
			return Complex((u[6] - u[30])/2.,-(-u[7] + u[31])/2.);
			break;

			case 18:
			return Complex((u[16] - u[32])/2.,-(-u[17] + u[33])/2.);
			break;

			case 19:
			return Complex((u[26] - u[34])/2.,-(-u[27] + u[35])/2.);
			break;

			case 20:
			return Complex((u[8] - u[40])/2.,-(-u[9] + u[41])/2.);
			break;

			case 21:
			return Complex((u[18] - u[42])/2.,-(-u[19] + u[43])/2.);
			break;

			case 22:
			return Complex((u[28] - u[44])/2.,-(-u[29] + u[45])/2.);
			break;

			case 23:
			return Complex((u[38] - u[46])/2.,-(-u[39] + u[47])/2.);
			break;
				
			default:
			fprintf(stderr, "SU5 only has 24 GENERATORS, PLEASE CORRECT CODE WHICH CHOSE: %d\n", which); exit(-1);
			break;
			}
		
		#elif (SUN==6)
			switch ( which ) {

				
				
			default:
			fprintf(stderr, "SU2 only has 3 GENERATORS, PLEASE CORRECT CODE WHICH CHOSE: %d\n", which); exit(-1);
			break;
			}
		
		#elif (SUN==7)
			switch ( which ) {

				
				
			default:
			fprintf(stderr, "SU2 only has 3 GENERATORS, PLEASE CORRECT CODE WHICH CHOSE: %d\n", which); exit(-1);
			break;
			}
		
		#elif (SUN==8)
			switch ( which ) {

				
				
			default:
			fprintf(stderr, "SU2 only has 3 GENERATORS, PLEASE CORRECT CODE WHICH CHOSE: %d\n", which); exit(-1);
			break;
			}
		
		#elif (SUN==9)
			switch ( which ) {

				
				
			default:
			fprintf(stderr, "SU2 only has 3 GENERATORS, PLEASE CORRECT CODE WHICH CHOSE: %d\n", which); exit(-1);
			break;
			}
		
		#elif (SUN==10)
			switch ( which ) {

				
				
			default:
			fprintf(stderr, "SU2 only has 3 GENERATORS, PLEASE CORRECT CODE WHICH CHOSE: %d\n", which); exit(-1);
			break;
			}
		
		#endif
		
	}

	
	void ComplGenMat::EXP_SUN_REAL_GEN(double* a)
	{
		
		#if (SUN==2)
		
 			double nrm=a[0]*a[0]+a[1]*a[1]+a[2]*a[2];
 			double snrm=sqrt(nrm);
 			double sinhpdp = sinh(0.5*snrm)/snrm; 
 			double coshp = cosh(0.5*snrm); 
 			
			u[0]=coshp+a[0]*sinhpdp;
			u[1]=0;
			
			u[2]=a[1]*sinhpdp;
			u[3]=-a[2]*sinhpdp;
			
			u[4]=u[2];
			u[5]=-u[3];
			
			u[6]=coshp-a[0]*sinhpdp;
			u[7]=0;
			
		#elif (SUN==3)
		
			this->FROM_REAL_SUN_GENERATORS(a);
	
			//---------------------------------------------------------------------------------------------
			//	FOR THE CASE OF REAL GENERATORS CARDANOS METHOD WITH THE VECTOR PRODUCT IS USED
			//---------------------------------------------------------------------------------------------
			
			Matrix Evecs,Tmp,Tmp2;
			
			//double DBL_EPSILON=1e-16;
			
			double norm;          // Squared norm or inverse norm of current eigenvector
			double n0, n1;        // Norm of first and second columns of A
			double error;         // Estimated maximum roundoff error
			double t, u2;          // Intermediate storage
			int j;                // Loop counter
			
			// ----------------------------------------------------------------------------
			// Calculates the eigenvalues of a hermitian 3x3 matrix A using Cardano's
			// analytical algorithm.
			// Only the diagonal and upper triangular parts of A are accessed. The access
			// is read-only.
			
			double m, c1, c0,w[3];
			
			// Determine coefficients of characteristic poynomial. We write
			//       | a   d   f  |
			//  A =  | d*  b   e  |
			//       | f*  e*  c  |
			
			double rede=u[2]*u[10]-u[3]*u[11];  // Re[d * e]
			double imde=u[2]*u[11]+u[3]*u[10];  // Im[d * e]
			double dd = (u[2]*u[2]+u[3]*u[3]);                                  // d * conj(d)
			double ee = (u[10]*u[10]+u[11]*u[11]);                                  // e * conj(e)
			double ff = (u[4]*u[4]+u[5]*u[5]);                                  // f * conj(f)
			m  = u[0] + u[8] + u[16]; 
			c1 = u[0]*u[8]+ u[0]*u[16] + u[8]*u[16] - (dd+ee+ff); // a*b + a*c + b*c - d*conj(d) - e*conj(e) - f*conj(f)
			c0 = u[16]*dd + u[0]*ee + u[8]*ff - u[0]*u[8]*u[16] - 2.*(u[4]*rede + u[5]*imde);// c*d*conj(d) + a*e*conj(e) + b*f*conj(f) - a*b*c - 2*Re(conj(f)*d*e)
						

			double p, sqrt_p, q, c, s, phi;
			p = m*m - 3.0*c1;
			q = m*(p - (3.0/2.0)*c1) - (27.0/2.0)*c0;
			sqrt_p = sqrt(fabs(p));

			phi = 27.0 * ( 0.25*c1*c1*(p - c1) + c0*(q + 27.0/4.0*c0));
			phi = (1.0/3.0) * atan2(sqrt(fabs(phi)), q);
			
			c = sqrt_p*cos(phi);
			s = (1.0/1.73205080756887729352744634151)*sqrt_p*sin(phi);

			w[1]  = (1.0/3.0)*(m - c);
			w[2]  = w[1] + s;
			w[0]  = w[1] + c;
			w[1] -= s;
			
			
			//fprintf(stderr, "CHECK VALS %e %e %e\n", w[0],w[1],w[2]);
			
			// Calculates the eigenvalues and normalized eigenvectors of a hermitian 3x3
			// matrix A using an analytical
			// method based on vector cross products for the eigenvectors.
			
			n0 = u[0]*u[0] + u[2]*u[2]+u[3]*u[3]+u[4]*u[4]+u[5]*u[5];//  SQR(creal(A[0][0])) + SQR_ABS(A[0][1]) + SQR_ABS(A[0][2]);
			n1 = u[2]*u[2]+u[3]*u[3] + u[8]*u[8] + u[10]*u[10]+u[11]*u[11]; //SQR_ABS(A[0][1]) + SQR(creal(A[1][1])) + SQR_ABS(A[1][2]);
			
			t = fabs(w[0]);
			if ((u2=fabs(w[1])) > t)
			t = u2;
			if ((u2=fabs(w[2])) > t)
			t = u2;
			if (t < 1.0)
			u2 = t;
			else
			u2 = t*t;
			error = 256.0 * DBL_EPSILON * (n0 + u2) * (n1 + u2);

			Evecs(0,1)= ( *((Complex*) &u[2]) )*( *((Complex*) &u[10]) )- ( *((Complex*) &u[4]) )*u[8];
			Evecs(1,1)= ( *((Complex*) &u[4]) )*( Complex(u[2],-u[3]) ) - ( *((Complex*) &u[10]) )*u[0];
			Evecs(2,1)= u[2]*u[2]+u[3]*u[3];
			
// 			Q[0][1] = A[0][1]*A[1][2] - A[0][2]*creal(A[1][1]);
// 			Q[1][1] = A[0][2]*conj(A[0][1]) - A[1][2]*creal(A[0][0]);
// 			Q[2][1] = SQR_ABS(A[0][1]);

			// Calculate first eigenvector by the formula
			//   v[0] = conj( (A - w[0]).e1 x (A - w[0]).e2 )
			Evecs(0,0) = Evecs(0,1) + ( *((Complex*) &u[4]) )*w[0];
			Evecs(1,0) = Evecs(1,1) + ( *((Complex*) &u[10]) )*w[0];
			Evecs(2,0) = (u[0]-w[0])*(u[8]-w[0]) - Evecs(2,1);
			norm = Evecs[0]*Evecs[0] + Evecs[1]*Evecs[1] + Evecs[6]*Evecs[6] + Evecs[7]*Evecs[7] + Evecs[12]*Evecs[12]+ Evecs[13]*Evecs[13];
			
// 			Q[0][0] = Q[0][1] + A[0][2]*w[0];
// 			Q[1][0] = Q[1][1] + A[1][2]*w[0];
// 			Q[2][0] = (creal(A[0][0]) - w[0]) * (creal(A[1][1]) - w[0]) - Q[2][1];
// 			norm    = SQR_ABS(Q[0][0]) + SQR_ABS(Q[1][0]) + SQR(creal(Q[2][0]));

			// If vectors are nearly linearly dependent, or if there might have
			// been large cancellations in the calculation of A(I,I) - W(1), fall
			// back to QL algorithm
			// Note that this simultaneously ensures that multiple eigenvalues do
			// not cause problems: If W(1) = W(2), then A - W(1) * I has rank 1,
			// i.e. all columns of A - W(1) * I are linearly dependent.
			
			if (norm <= error){
			 fprintf(stderr, "THE MATRIX HAD PROBLEMS \n"); exit(-1);
			}else                      // This is the standard branch
			{
			norm = sqrt(1.0 / norm);
			for (j=0; j < 3; j++)
			Evecs(j,0) = Evecs(j,0) * norm;
			}
			
			// Calculate second eigenvector by the formula
			//   v[1] = conj( (A - w[1]).e1 x (A - w[1]).e2 )
			Evecs(0,1) = Evecs(0,1) + ( *((Complex*) &u[4])  )*w[1];
			Evecs(1,1) = Evecs(1,1) + ( *((Complex*) &u[10]) )*w[1];
			Evecs(2,1) = (u[0]-w[1])*(u[8]-w[1]) - Evecs[14];
			norm = Evecs[2]*Evecs[2] + Evecs[3]*Evecs[3] + Evecs[8]*Evecs[8] + Evecs[9]*Evecs[9] + Evecs[14]*Evecs[14]+ Evecs[15]*Evecs[15];
			
/*			Q[0][1]  = Q[0][1] + A[0][2]*w[1];
			Q[1][1]  = Q[1][1] + A[1][2]*w[1];
			Q[2][1]  = (creal(A[0][0]) - w[1]) * (creal(A[1][1]) - w[1]) - creal(Q[2][1]);
			norm     = SQR_ABS(Q[0][1]) + SQR_ABS(Q[1][1]) + SQR(creal(Q[2][1]));*/
			
			if (norm <= error){
			 fprintf(stderr, "THE MATRIX HAD PROBLEMS \n"); exit(-1);
			}else
			{
			norm = sqrt(1.0 / norm);
			for (j=0; j < 3; j++)
			Evecs(j,1) = Evecs(j,1) * norm;
			}
			
			// Calculate third eigenvector according to
			//   v[2] = conj(v[0] x v[1])
			
			Evecs(0,2)=conj( Evecs(1,0)*Evecs(2,1) - Evecs(2,0)*Evecs(1,1) );
			Evecs(1,2)=conj( Evecs(2,0)*Evecs(0,1) - Evecs(0,0)*Evecs(2,1) );
			Evecs(2,2)=conj( Evecs(0,0)*Evecs(1,1) - Evecs(1,0)*Evecs(0,1) );
			
/*			Q[0][2] = conj(Q[1][0]*Q[2][1] - Q[2][0]*Q[1][1]);
			Q[1][2] = conj(Q[2][0]*Q[0][1] - Q[0][0]*Q[2][1]);
			Q[2][2] = conj(Q[0][0]*Q[1][1] - Q[1][0]*Q[0][1]);*/
			

			// ----------------------------------------------------------------------------
			// Calculates the matrix exponential based on the 
			
			w[0]=exp(w[0]);
			w[1]=exp(w[1]);
			w[2]=exp(w[2]);

			Tmp=Evecs;
			Tmp(0,0)*=w[0];
			Tmp(1,0)*=w[0];
			Tmp(2,0)*=w[0];
			Tmp(0,1)*=w[1];
			Tmp(1,1)*=w[1];
			Tmp(2,1)*=w[1];
			Tmp(0,2)*=w[2];
			Tmp(1,2)*=w[2];
			Tmp(2,2)*=w[2];
			
			*this=Tmp;
			
			Tmp2.Dagger(Evecs);
			
			*this *=Tmp2;
			
		#else
			Matrix tmp;
			//fprintf(stderr, "D1\n");
			tmp.FROM_REAL_SUN_GENERATORS(a);
			//fprintf(stderr, "D2\n");
			this->Exponential(tmp);
			//fprintf(stderr, "D3\n");
		#endif
	
	
	}

	void ComplGenMat::EXP_SLC_COMPL_GEN(double* a)
	{
		
		#if (SUN==2)
		
			Complex tmp1,tmp2;
			
			double nrmre= (a[0]*a[0] - a[1]*a[1] + a[2]*a[2] - a[3]*a[3] + a[4]*a[4] - a[5]*a[5]);
			double nrmim= 2*(a[0]*a[1] + a[2]*a[3] + a[4]*a[5]);
			
			double phi=atan(nrmim/nrmre);
			double absv=nrmre*nrmre+nrmim*nrmim;
			
			nrmre=0.5*sqrt(sqrt(absv))*cos(phi/2.);
			nrmim=0.5*sqrt(sqrt(absv))*sin(phi/2.);
			Complex nrmc(nrmre,nrmim);
						
			double sinhpre= sinh(nrmre)*cos(nrmim);
			double sinhpim= cosh(nrmre)*sin(nrmim);
			Complex sinhp(sinhpre,sinhpim);
			
			tmp1=(sinhp/nrmc);
			tmp2=tmp1*Complex(a[0],a[1]);
			
			double coshpre= cosh(nrmre)*cos(nrmim);
			double coshpim= sinh(nrmre)*sin(nrmim);

			tmp2.addreal(coshpre);
			tmp2.addimag(coshpim);

			u[0]=tmp2.real();
			u[1]=tmp2.imag();

			tmp2.real(a[2]+a[5]);
			tmp2.imag(a[3]-a[4]);
			
			tmp2*=tmp1;
			
			u[2]=tmp2.real();
			u[3]=tmp2.imag();
			
			tmp2.real(a[2]-a[5]);
			tmp2.imag(a[3]+a[4]);
			
			tmp2*=tmp1;
			
			u[4]=tmp2.real();
			u[5]=tmp2.imag();
			
			tmp2=tmp1*Complex(-a[0],-a[1]);
			
			tmp2.addreal(coshpre);
			tmp2.addimag(coshpim);
			
			u[6]=tmp2.real();
			u[7]=tmp2.imag();
			
		#else
			Matrix tmp;
			tmp.FROM_COMPL_SLC_GENERATORS(a);
			this->Exponential(tmp);
		#endif

	}
	
	//---------------------------------------------------------------------------------------------
	//	RANDOM MATRICES GENERATION COVERING THE FULL MANIFOLD
	//---------------------------------------------------------------------------------------------

	//---------------------------------------------------------------------------------------------
	//	BEWARE: ONLY FOR THE HIGHER N MATRICES WE HAVE IMPLEMENTED THE
	//	HAAR MEASURE NORMALIZATION SO THAT EIGENVALUES ARE DISTRIBUTED
	//	ACCORDINGLY PLEASE CHECK THE CASE FOR N=2 AND N=3 SEPARATELY.
	//---------------------------------------------------------------------------------------------


	void RandomSU(TLP_RANDGEN *LocGSLr, double* u)
	{
	
	#if (SUN==2)
	
		double p1,p2,p3,p4;
		
		p1=(1.-2.*TLP_RAND_GEN_DOUBLE_UNIFORM (LocGSLr)); 
		p2=(1.-2.*TLP_RAND_GEN_DOUBLE_UNIFORM (LocGSLr));
		p3=(1.-2.*TLP_RAND_GEN_DOUBLE_UNIFORM (LocGSLr));
		p4=(1.-2.*TLP_RAND_GEN_DOUBLE_UNIFORM (LocGSLr));
	
		double normalize= sqrt( (1.0 - p1*p1) / (p2*p2 + p3*p3 + p4*p4) );

		p2 *= normalize; 
		p3 *= normalize; 
		p4 *= normalize;

		*(u+0)=p1; *(u+1)=p2;
		*(u+2)=-p3; *(u+3)=p4;
		*(u+4)=p3; *(u+5)=p4;
		*(u+6)=p1; *(u+7)=-p2;
	
	#endif	
		
	#if (SUN==3)

			double param[8];
			
			for(int i=0; i<8; i++) param[i]= (TLP_RAND_GEN_DOUBLE_UNIFORM (LocGSLr)*2.-1.);

			double SU21[18];
			double SU22[18];

			double tmp1,tmp2,tmp3,tmp4,tmp5,tmp6;

			//-----------------------------------------------------------------------
			//	Calculate the first half of the 8 factors
			//-----------------------------------------------------------------------

			tmp1=cos(param[0]+2.*param[2]);
			tmp2=cos(param[0]-2.*param[2]);

			tmp3=cos(param[1]*0.5);
			tmp4=sin(param[1]*0.5);

			tmp5=cos(param[3]*0.5);
			tmp6=sin(param[3]*0.5);

			SU21[0]=tmp1*tmp3*tmp5;		SU21[2]=(tmp2*tmp4);	SU21[4]=(tmp1*tmp3*tmp6);
			SU21[6]=(-tmp2*tmp4*tmp5);	SU21[8]=(tmp1*tmp3);	SU21[10]=(-tmp2*tmp4*tmp6);
			SU21[12]=(-tmp6);		SU21[14]=(0.);		SU21[16]=(tmp5);

			tmp1=sin(param[0]+2.*param[2]);
			tmp2=sin(param[0]-2.*param[2]);

			SU21[1]=(tmp1*tmp3*tmp5);	SU21[3]=(tmp2*tmp4);	SU21[5]=(tmp1*tmp3*tmp6);
			SU21[7]=(+tmp2*tmp4*tmp5);	SU21[9]=(-tmp1*tmp3);	SU21[11]=(+tmp2*tmp4*tmp6);
			SU21[13]=(0.);		SU21[15]=(0.);		SU21[17]=(0.);


			//-----------------------------------------------------------------------
			//	Calculate the second half of the 8 factors
			//-----------------------------------------------------------------------

			tmp1=cos(param[4]+2.*param[6]+sqrt(3.)*param[7]);
			tmp2=cos(param[4]-2.*param[6]+sqrt(3.)*param[7]);
			tmp3=cos(param[4]-2.*param[6]-sqrt(3.)*param[7]);
			tmp4=cos(param[4]+2.*param[6]-sqrt(3.)*param[7]);

			tmp5=cos(param[5]*0.5)/sqrt(3.);
			tmp6=sin(param[5]*0.5)/sqrt(3.);


			SU22[0]=(tmp1*tmp5);	SU22[2]=(tmp2*tmp6);	SU22[4]=(0.);
			SU22[6]=(-tmp3*tmp6);	SU22[8]=(tmp4*tmp5);	SU22[10]=(0.);
			SU22[12]=(0.);		SU22[14]=(0.);		SU22[16]=(cos(2.*sqrt(3.)*param[7])/sqrt(3.));

			tmp1=sin(param[4]+2.*param[6]+sqrt(3.)*param[7]);
			tmp2=sin(param[4]-2.*param[6]+sqrt(3.)*param[7]);
			tmp3=sin(param[4]-2.*param[6]-sqrt(3.)*param[7]);
			tmp4=sin(param[4]+2.*param[6]-sqrt(3.)*param[7]);

			SU22[1]=(tmp1*tmp5);	SU22[3]=(tmp2*tmp6);	SU22[5]=(0.);
			SU22[7]=(tmp3*tmp6);	SU22[9]=(-tmp4*tmp5);	SU22[11]=(0.);
			SU22[13]=(0.);		SU22[15]=(0.);		SU22[17]=(-sin(2.*sqrt(3.)*param[7])/sqrt(3.));

			SU21[0]*=sqrt(3.); SU21[1]*=sqrt(3.); SU21[2]*=sqrt(3.); SU21[3]*=sqrt(3.);
			SU21[4]*=sqrt(3.); SU21[5]*=sqrt(3.); SU21[6]*=sqrt(3.); SU21[7]*=sqrt(3.);
			SU21[8]*=sqrt(3.); SU21[9]*=sqrt(3.); SU21[10]*=sqrt(3.); SU21[11]*=sqrt(3.);
			SU21[12]*=sqrt(3.); SU21[13]*=sqrt(3.); SU21[14]*=sqrt(3.); SU21[15]*=sqrt(3.);
			SU21[16]*=sqrt(3.); SU21[17]*=sqrt(3.);

			GenMatMult(u,(double*) &SU21, (double*) &SU22);
	
	#endif
		
	#if (SUN>3)
	
/*			Matrix TEST;
			TEST.Rand1SUN(LocGSLr);*/
	
			Complex A[SUN*SUN];
			Complex Q[SUN*SUN];
			Complex R[SUN];
			
			_lapack_complex_double TAU[SUN];
			_lapack_complex_double WORK[SUN*SUN];
			
			double RWORK[2*SUN];
			
			int N=SUN;
			int N2=SUN*SUN;
			
			for(int i=0;i<SUN;i++)
			for(int j=0;j<SUN;j++)
			{
			
/*				A[j*SUN+i].real(TEST[2*i*SUN+2*j]);
				A[j*SUN+i].imag(TEST[2*i*SUN+2*j+1]);*/
				A[j*SUN+i].real((TLP_RAND_GEN_DOUBLE_UNIFORM (LocGSLr)*2.-1.));
				A[j*SUN+i].imag((TLP_RAND_GEN_DOUBLE_UNIFORM (LocGSLr)*2.-1.));
				
// 				fprintf(stderr, "A[%d,%d] (%e,%e)\n",i,j,A[j*SUN+i].real(), A[j*SUN+i].imag());
				
				
			}
			
			int PIVOT[SUN];
			int INFO;
			
			zgeqp3_ ( &N, &N, (_lapack_complex_double*) &(A[0]), &N, PIVOT, TAU, WORK, &N2, RWORK, &INFO  );
			
			for(int i=0;i<SUN;i++) { R[i]= A[i*SUN+i]; /*fprintf(stderr, "R[%d,%d] (%e,%e)\n",i,i,R[i].real(), R[i].imag());*/ }
			
			zungqr_ ( &N, &N, &N, (_lapack_complex_double*) &(A[0]), &N, TAU, WORK, &N2, &INFO  );
			
			for(int i=0;i<SUN;i++){
				
				int PIVC=PIVOT[i]-1;
				
				Complex norm = R[PIVC];
				norm/=R[PIVC].abs();
				
// 				fprintf(stderr, "NORM: (%e %e), PIVC %d\n", norm.real(), norm.imag(), PIVC);
				for(int j=0;j<SUN;j++){
				
				Complex val = A[(PIVOT[j]-1)*SUN+i]*norm;
				
				u[2*SUN*i + 2*j] = val.real(); 
				u[2*SUN*i + 2*j+1] = val.imag(); 
				
// 				fprintf(stderr, "U[%d,%d] (%e,%e)\n",i,j,u[2*SUN*i + 2*j], u[2*SUN*i + 2*j+1]);
				
				}
			}
	
	#endif
		
	}
	
	
	//---------------------------------------------------------------------------------------------
	//	REUNITARIZING THE MATRIX BACK TO SU(N)
	//---------------------------------------------------------------------------------------------
		
	void ReSUN(double *u)
	{
		
		#if (SUN==2)
			//***************************************************//
			//	NORMALIZE THE FIRST COLUMN		     //
			//***************************************************//
			
			double columnr1 =       u[0]*u[0]+u[1]*u[1] +
						u[4]*u[4] + u[5]*u[5];
			
			double	col1norm=1./sqrt(columnr1);
		
			u[0]*=col1norm;
			u[1]*=col1norm;
			
			u[4]*=col1norm;
			u[5]*=col1norm;
		
			//***************************************************//
			//	ORTHOGONALIZE THE SECOND ONE WRT THE FIRST   //
			//***************************************************//
				
			double columnr2 =       u[2*SUN*0+2*0]*u[2*SUN*0+2*1] + u[2*SUN*0+2*0+1]*u[2*SUN*0+2*1+1] +
						u[2*SUN*1+2*0]*u[2*SUN*1+2*1] + u[2*SUN*1+2*0+1]*u[2*SUN*1+2*1+1];
			
			double columni2 =       u[2*SUN*0+2*0]*u[2*SUN*0+2*1+1] - u[2*SUN*0+2*0+1]*u[2*SUN*0+2*1] +
						u[2*SUN*1+2*0]*u[2*SUN*1+2*1+1] - u[2*SUN*1+2*0+1]*u[2*SUN*1+2*1];
			
			u[2]-= columnr2* u[0]   - columni2* u[1];
			u[3]-= columnr2* u[1] + columni2* u[0];
			
			u[6]-= columnr2* u[4]   - columni2* u[5] ;
			u[7]-= columnr2* u[5] + columni2* u[4];
									
			columnr1 =       	u[2*SUN*0+2*1]*u[2*SUN*0+2*1] + u[2*SUN*0+2*1+1]*u[2*SUN*0+2*1+1] +
						u[2*SUN*1+2*1]*u[2*SUN*1+2*1] + u[2*SUN*1+2*1+1]*u[2*SUN*1+2*1+1];
			
			col1norm=1./sqrt(columnr1);

			u[2]*=col1norm;
			u[3]*=col1norm;
			
			u[6]*=col1norm;
			u[7]*=col1norm;
		#endif
		
		#if (SUN==3)
		
			//***************************************************//
			//	NORMALIZE THE FIRST COLUMN		     //
			//***************************************************//
			
			double columnr1 =       u[0]*u[0]+u[1]*u[1] +
						u[2*SUN*1+2*0]*u[2*SUN*1+2*0] + u[2*SUN*1+2*0+1]*u[2*SUN*1+2*0+1] +
						u[2*SUN*2+2*0]*u[2*SUN*2+2*0] + u[2*SUN*2+2*0+1]*u[2*SUN*2+2*0+1];
			
			double	col1norm=1./sqrt(columnr1);
		
			u[2*SUN*0+2*0]*=col1norm;
			u[2*SUN*0+2*0+1]*=col1norm;
			
			u[2*SUN*1+2*0]*=col1norm;
			u[2*SUN*1+2*0+1]*=col1norm;
			
			u[2*SUN*2+2*0]*=col1norm;
			u[2*SUN*2+2*0+1]*=col1norm;
			
			//***************************************************//
			//	ORTHOGONALIZE THE SECOND ONE WRT THE FIRST   //
			//***************************************************//
				
			double columnr2 =       u[2*SUN*0+2*0]*u[2*SUN*0+2*1] + u[2*SUN*0+2*0+1]*u[2*SUN*0+2*1+1] +
						u[2*SUN*1+2*0]*u[2*SUN*1+2*1] + u[2*SUN*1+2*0+1]*u[2*SUN*1+2*1+1] +
						u[2*SUN*2+2*0]*u[2*SUN*2+2*1] + u[2*SUN*2+2*0+1]*u[2*SUN*2+2*1+1];
			
			double columni2 =       u[2*SUN*0+2*0]*u[2*SUN*0+2*1+1] - u[2*SUN*0+2*0+1]*u[2*SUN*0+2*1] +
						u[2*SUN*1+2*0]*u[2*SUN*1+2*1+1] - u[2*SUN*1+2*0+1]*u[2*SUN*1+2*1] +
						u[2*SUN*2+2*0]*u[2*SUN*2+2*1+1] - u[2*SUN*2+2*0+1]*u[2*SUN*2+2*1];
			
			u[2*SUN*0+2*1]-=   columnr2* u[2*SUN*0+2*0]   - columni2* u[2*SUN*0+2*0+1];
			u[2*SUN*0+2*1+1]-= columnr2* u[2*SUN*0+2*0+1] + columni2* u[2*SUN*0+2*0];
			
			u[2*SUN*1+2*1]-=   columnr2* u[2*SUN*1+2*0]   - columni2* u[2*SUN*1+2*0+1] ;
			u[2*SUN*1+2*1+1]-= columnr2* u[2*SUN*1+2*0+1] + columni2* u[2*SUN*1+2*0];
			
			u[2*SUN*2+2*1]-=   columnr2* u[2*SUN*2+2*0]   - columni2* u[2*SUN*2+2*0+1] ;
			u[2*SUN*2+2*1+1]-= columnr2* u[2*SUN*2+2*0+1] + columni2* u[2*SUN*2+2*0+0];
									
			columnr1 =       	u[2*SUN*0+2*1]*u[2*SUN*0+2*1] + u[2*SUN*0+2*1+1]*u[2*SUN*0+2*1+1] +
						u[2*SUN*1+2*1]*u[2*SUN*1+2*1] + u[2*SUN*1+2*1+1]*u[2*SUN*1+2*1+1] +
						u[2*SUN*2+2*1]*u[2*SUN*2+2*1] + u[2*SUN*2+2*1+1]*u[2*SUN*2+2*1+1];
			
			col1norm=1./sqrt(columnr1);

			u[2*SUN*0+2*1]*=col1norm;
			u[2*SUN*0+2*1+1]*=col1norm;
			
			u[2*SUN*1+2*1]*=col1norm;
			u[2*SUN*1+2*1+1]*=col1norm;
			
			u[2*SUN*2+2*1]*=col1norm;
			u[2*SUN*2+2*1+1]*=col1norm;

			//***************************************************//
			//	THIRD COLUMN IS DETERMINED BY CROSS PRODUCT  //
			//***************************************************//

			u[2*SUN*0+2*2]= 	u[2*SUN*1+2*0]*u[2*SUN*2+2*1]   - u[2*SUN*1+2*0+1]*u[2*SUN*2+2*1+1] - u[2*SUN*2+2*0]*u[2*SUN*1+2*1]   + u[2*SUN*2+2*0+1]*u[2*SUN*1+2*1+1] ;
			u[2*SUN*0+2*2+1]= -( 	u[2*SUN*1+2*0]*u[2*SUN*2+2*1+1] + u[2*SUN*1+2*0+1]*u[2*SUN*2+2*1]   - u[2*SUN*2+2*0]*u[2*SUN*1+2*1+1] - u[2*SUN*2+2*0+1]*u[2*SUN*1+2*1]   );
					
			u[2*SUN*1+2*2]= 	u[2*SUN*2+2*0]*u[2*SUN*0+2*1]   - u[2*SUN*2+2*0+1]*u[2*SUN*0+2*1+1] - u[2*SUN*0+2*0]*u[2*SUN*2+2*1]   + u[2*SUN*0+2*0+1]*u[2*SUN*2+2*1+1] ;
			u[2*SUN*1+2*2+1]= -( 	u[2*SUN*2+2*0]*u[2*SUN*0+2*1+1] + u[2*SUN*2+2*0+1]*u[2*SUN*0+2*1]   - u[2*SUN*0+2*0]*u[2*SUN*2+2*1+1] - u[2*SUN*0+2*0+1]*u[2*SUN*2+2*1]   );
			
			u[2*SUN*2+2*2]= 	u[2*SUN*0+2*0]*u[2*SUN*1+2*1]   - u[2*SUN*0+2*0+1]*u[2*SUN*1+2*1+1] - u[2*SUN*1+2*0]*u[2*SUN*0+2*1]   + u[2*SUN*1+2*0+1]*u[2*SUN*0+2*1+1] ;
			u[2*SUN*2+2*2+1]= -( 	u[2*SUN*0+2*0]*u[2*SUN*1+2*1+1] + u[2*SUN*0+2*0+1]*u[2*SUN*1+2*1]   - u[2*SUN*1+2*0]*u[2*SUN*0+2*1+1] - u[2*SUN*1+2*0+1]*u[2*SUN*0+2*1] );
			
		#endif
		
		#if (SUN>3)

			Complex A[SUN*SUN];
			Complex Q[SUN*SUN];
			Complex R[SUN];
			
			_lapack_complex_double TAU[SUN];
			_lapack_complex_double WORK[SUN*SUN];
			
			double RWORK[2*SUN];
			
			int N=SUN;
			int N2=SUN*SUN;
			
			for(int i=0;i<SUN;i++)
			for(int j=0;j<SUN;j++)
			{
			
				A[j*SUN+i].real(u[2*(i*SUN+j)]);
				A[j*SUN+i].imag(u[2*(i*SUN+j)+1]);
				
				
			}
			
			int PIVOT[SUN];
			int INFO;
			
			zgeqp3_ ( &N, &N, (_lapack_complex_double*) &A[0], &N, PIVOT, TAU, WORK, &N2, RWORK, &INFO  );
			
 			for(int i=0;i<SUN;i++) { R[i]= A[i*SUN+i];}
			
			zungqr_ ( &N, &N, &N, (_lapack_complex_double*) &A[0], &N, TAU, WORK, &N2, &INFO  );
			
			for(int i=0;i<SUN;i++){
				
				int PIVC=PIVOT[i]-1;
				
				Complex norm = R[PIVC];
				norm/=R[PIVC].abs();
				
				for(int j=0;j<SUN;j++){
				
				Complex val = A[(PIVOT[j]-1)*SUN+i]*norm;
				
				u[2*SUN*i + 2*j] = val.real(); 
				u[2*SUN*i + 2*j+1] = val.imag(); 
				}
			}

		#endif
		
	}

	//---------------------------------------------------------------------------------------------
	//	SVD DECOMPOSITION FOR THE SUN MATRICES (NON-OPTIMIZED BASED ON LAPACK)
	//---------------------------------------------------------------------------------------------

	void ComplGenMat::MatSVD( double *U, double *S, double *Vt)
	{
		
		#if (LAPACK!=0)
		
		Complex UTmp[2*SUN*SUN];
		
		SetTranspose( (double*)UTmp, this->u);
		
		char JOBU ='O';
		char JOBVT = 'S';
		
		int M=SUN;
		int N=SUN;

		int LDA=SUN;
	
		int LDVT=SUN;
		
		_lapack_complex_double WORK[SUN*SUN];
		
		int LWORK=SUN*SUN;
		
		double RWORK[5*SUN];
		
		int  INFO;
		
		double STmp[SUN]; 
		_lapack_complex_double VtTmp[SUN*SUN];
	
		zgesvd_( &JOBU, &JOBVT, &M, &N, (_lapack_complex_double*) &UTmp[0], &N, STmp, NULL, &N, VtTmp, &LDVT, WORK, &LWORK, RWORK, &INFO );				
		
		SetTranspose( U, (double*) &UTmp[0]);
	
		SetTranspose( Vt, (double*) &VtTmp[0]);
		
		for(int i=0;i<SUN;i++){
			S[i]= ((double*) &STmp[i])[0];
		}

		#else
		
		fprintf(stderr, "PLEASE ENABLE LAPACK FOR THE SVD TO WORK!\n"); exit(-1);
		
		#endif
	}

	void ComplGenMat::Exponential( const ComplGenMat& In  )
	{
		
		#if (LAPACK!=0)
		
		for(int i=0;i<2*SUN*SUN; i++) this->u[i]=In.u[i];
		
		char dsjobl='N';
		char dsjobr='V';
		
		int size=SUN;
		
		int *piv;
		piv = new int [SUN];
		
		Complex *dsw;
		dsw = new Complex [SUN];
		
		Complex *dsvr;
		dsvr = new Complex [SUN*SUN];
		
		Complex *dsvl;
		dsvl = new Complex [SUN*SUN];
		
		double *dsrwork;
		dsrwork= new double [2*SUN];
		
		int dsinfo;
		
		int dslda=SUN;
		int dslvr=SUN;
		int dslvl=SUN;
		int dslw=2*SUN;
					
		Complex *dswork;
		dswork= new Complex [2*SUN*SUN];
		
		zgeev_( &dsjobl , &dsjobr , &size, (_lapack_complex_double*) &(this->u[0]), &dslda, (_lapack_complex_double*)dsw, (_lapack_complex_double*)dsvl, &dslvl, (_lapack_complex_double*)dsvr, &dslvr, (_lapack_complex_double*)dswork, &dslw, dsrwork, &dsinfo );		
		
		for(int i=0;i<SUN;i++){
			double t1=exp(dsw[i].real())*cos(dsw[i].imag());
			double t2=exp(dsw[i].real())*sin(dsw[i].imag());
			dsw[i].real(t1);
			dsw[i].imag(t2);
		}

		for(int i=0;i<2*SUN*SUN; i++) this->u[i]=((ComplGenMat*)dsvr)[0].operator[](i);
	
		zgetrf_( &size , &size, (_lapack_complex_double*) &(this->u[0]), &size, piv, &dsinfo );
		zgetri_( &size , (_lapack_complex_double*) &(this->u[0]), &size, piv, (_lapack_complex_double*)dswork,  &dslw, &dsinfo );

		for(int i=0;i<SUN;i++){
		  for(int j=0;j<SUN;j++){
		    
		    this->operator()(i,j)*=dsw[j];
		    
		  }
		}
	
		
		this->operator*=((double*)dsvr);
		
		delete[] piv;
		delete[] dsw;
		delete[] dsvr;
		delete[] dsvl;
		delete[] dsrwork;
		delete[] dswork;
		
		#else
		
		fprintf(stderr, "PLEASE ENABLE LAPACK FOR THE Exponential TO WORK!\n"); exit(-1);
		
		#endif
	}
	
	void ComplGenMat::Exponential( )
	{
		
		#if (LAPACK!=0)
		
		char dsjobl='N';
		char dsjobr='V';
		
		int size=SUN;
		
		int *piv;
		piv = new int [SUN];
		
		Complex *dsw;
		dsw = new Complex [SUN];
		
		Complex *dsvr;
		dsvr = new Complex [SUN*SUN];
		
		Complex *dsvl;
		dsvl = new Complex [SUN*SUN];
		
		double *dsrwork;
		dsrwork= new double [2*SUN];
		
		int dsinfo;
		
		int dslda=SUN;
		int dslvr=SUN;
		int dslvl=SUN;
		int dslw=2*SUN;
					
		Complex *dswork;
		dswork= new Complex [2*SUN*SUN];
		
		zgeev_( &dsjobl , &dsjobr , &size, (_lapack_complex_double*) &(this->u[0]), &dslda, (_lapack_complex_double*)dsw, (_lapack_complex_double*)dsvl, &dslvl, (_lapack_complex_double*)dsvr, &dslvr, (_lapack_complex_double*)dswork, &dslw, dsrwork, &dsinfo );		
		
		for(int i=0;i<SUN;i++){
			double t1=exp(dsw[i].real())*cos(dsw[i].imag());
			double t2=exp(dsw[i].real())*sin(dsw[i].imag());
			dsw[i].real(t1);
			dsw[i].imag(t2);
		}

		for(int i=0;i<2*SUN*SUN; i++) this->u[i]=((ComplGenMat*)dsvr)[0].operator[](i);
	
		zgetrf_( &size , &size, (_lapack_complex_double*) &(this->u[0]), &size, piv, &dsinfo );
		zgetri_( &size , (_lapack_complex_double*) &(this->u[0]), &size, piv, (_lapack_complex_double*)dswork,  &dslw, &dsinfo );

		for(int i=0;i<SUN;i++){
		  for(int j=0;j<SUN;j++){
		    
		    this->operator()(i,j)*=dsw[j];
		    
		  }
		}
	
		
		this->operator*=((double*)dsvr);
		
		delete[] piv;
		delete[] dsw;
		delete[] dsvr;
		delete[] dsvl;
		delete[] dsrwork;
		delete[] dswork;
		
		#else
		
		fprintf(stderr, "PLEASE ENABLE LAPACK FOR THE Exponential TO WORK!\n"); exit(-1);
		
		#endif
	}

	
	